/**
 * @license
 * Copyright 2023 Google LLC. All Rights Reserved.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * =============================================================================
 */
!function(e,t){"object"==typeof exports&&"undefined"!=typeof module?t(exports,require("@tensorflow/tfjs-core")):"function"==typeof define&&define.amd?define(["exports","@tensorflow/tfjs-core"],t):t((e="undefined"!=typeof globalThis?globalThis:e||self).tf=e.tf||{},e.tf)}(this,(function(e,t){"use strict";function n(e){var t=Object.create(null);return e&&Object.keys(e).forEach((function(n){if("default"!==n){var i=Object.getOwnPropertyDescriptor(e,n);Object.defineProperty(t,n,i.get?i:{enumerable:!0,get:function(){return e[n]}})}})),t.default=e,t}var i=n(t);const r=t.env();r.registerFlag("WEBGPU_DEFERRED_SUBMIT_BATCH_SIZE",(()=>15)),r.registerFlag("WEBGPU_CPU_FORWARD",(()=>!0)),r.registerFlag("WEBGPU_MATMUL_PROGRAM_TYPE",(()=>-1)),r.registerFlag("WEBGPU_USE_NAIVE_CONV2D_TRANSPOSE",(()=>!0)),r.registerFlag("WEBGPU_USE_LOW_POWER_GPU",(()=>!1)),r.registerFlag("WEBGPU_CPU_HANDOFF_SIZE_THRESHOLD",(()=>1e3)),r.registerFlag("WEBGPU_USE_PROFILE_TOOL",(()=>!1)),r.registerFlag("WEBGPU_IMPORT_EXTERNAL_TEXTURE",(()=>!0)),r.registerFlag("WEBGPU_USE_NAIVE_CONV2D_DEBUG",(()=>!1)),r.registerFlag("WEBGPU_THRESHOLD_TO_INCREASE_WORKGROUPS_FOR_MATMUL",(()=>0)),r.registerFlag("WEBGPU_CONV_SEPARATE_IM2COL_SHADER",(()=>!1)),r.registerFlag("WEBGPU_PRINT_SHADER",(()=>"")),r.registerFlag("WEBGPU_ENGINE_COMPILE_ONLY",(()=>!1));class s{constructor(e){e&&(this.vendor=e.vendor,this.architecture=e.architecture,this.intelGPUGeneration=this.getIntelGPUGeneration())}getIntelGPUGeneration(){if(this.isIntel()){if(this.architecture.startsWith("gen"))return Number(this.architecture.match(/\d+/));if(this.architecture.startsWith("xe"))return 12}return 0}isIntel(){return"intel"===this.vendor}}class a{constructor(e){this.device=e,this.numUsedBuffers=0,this.numFreeBuffers=0,this.freeBuffers=new Map,this.usedBuffers=new Map,this.numBytesUsed=0,this.numBytesAllocated=0}acquireBuffer(e,t,n=!1,i=!0){let r;const s=o(e,t);return i?(this.freeBuffers.has(s)||this.freeBuffers.set(s,[]),this.freeBuffers.get(s).length>0?(r=this.freeBuffers.get(s).pop(),this.numFreeBuffers--):(r=this.device.createBuffer({size:e,usage:t,mappedAtCreation:n}),this.numBytesAllocated+=e)):(r=this.device.createBuffer({size:e,usage:t,mappedAtCreation:n}),this.numBytesAllocated+=e),this.usedBuffers.has(s)||this.usedBuffers.set(s,[]),this.usedBuffers.get(s).push(r),this.numUsedBuffers++,this.numBytesUsed+=e,r}releaseBuffer(e,t=!0){if(0===this.freeBuffers.size)return;const n=e.size,i=o(n,e.usage),r=this.usedBuffers.get(i),s=r.indexOf(e);if(s<0)throw new Error("Cannot find the buffer in buffer manager");r[s]=r[r.length-1],r.pop(),this.numUsedBuffers--,this.numBytesUsed-=n,t?(this.freeBuffers.get(i).push(e),this.numFreeBuffers++):(e.destroy(),this.numBytesAllocated-=n)}getNumUsedBuffers(){return this.numUsedBuffers}getNumFreeBuffers(){return this.numFreeBuffers}dispose(){this.freeBuffers.forEach(((e,t)=>{e.forEach((e=>{e.destroy()}))})),this.usedBuffers.forEach(((e,t)=>{e.forEach((e=>{e.destroy()}))})),this.freeBuffers=new Map,this.usedBuffers=new Map,this.numUsedBuffers=0,this.numFreeBuffers=0,this.numBytesUsed=0,this.numBytesAllocated=0}}function o(e,t){return`${e}_${t}`}class u{constructor(e){this.device=e,this.numUsedTextures=0,this.numFreeTextures=0,this.freeTextures=new Map,this.usedTextures=new Map,this.numBytesUsed=0,this.numBytesAllocated=0}acquireTexture(e,t,n,i){const r=e*t*d(n),s=l(e,t,n,i);if(this.freeTextures.has(s)||this.freeTextures.set(s,[]),this.usedTextures.has(s)||this.usedTextures.set(s,[]),this.numBytesUsed+=r,this.numUsedTextures++,this.freeTextures.get(s).length>0){this.numFreeTextures--;const e=this.freeTextures.get(s).shift();return this.usedTextures.get(s).push(e),e}this.numBytesAllocated+=r;const a=this.device.createTexture({size:[e,t],format:n,usage:i});return this.usedTextures.get(s).push(a),a}releaseTexture(e){if(0===this.freeTextures.size)return;const t=e.width,n=e.height,i=e.format,r=l(t,n,i,e.usage);this.freeTextures.has(r)||this.freeTextures.set(r,[]),this.freeTextures.get(r).push(e),this.numFreeTextures++,this.numUsedTextures--;const s=this.usedTextures.get(r),a=s.indexOf(e);if(a<0)throw new Error("Cannot release a texture that was never provided by this texture manager");s.splice(a,1);const o=t*n*d(i);this.numBytesUsed-=o}getNumUsedTextures(){return this.numUsedTextures}getNumFreeTextures(){return this.numFreeTextures}dispose(){this.freeTextures.forEach(((e,t)=>{e.forEach((e=>{e.destroy()}))})),this.usedTextures.forEach(((e,t)=>{e.forEach((e=>{e.destroy()}))})),this.freeTextures=new Map,this.usedTextures=new Map,this.numUsedTextures=0,this.numFreeTextures=0,this.numBytesUsed=0,this.numBytesAllocated=0}}function l(e,t,n,i){return`${e}_${t}_${n}_${i}`}function d(e){if("rgba8unorm"===e)return 16;throw new Error(`${e} is not supported!`)}function h(e,t){if(Math.max(...e)>5)throw new Error("Cannot symbolically compute strides for rank > 6 tensor.");const n=e.length,i=e.map((e=>`${t}.${"xyzwuv"[e]}`)),r=new Array(n-1);r[n-2]=i[n-1];for(let e=n-3;e>=0;--e)r[e]=`(${r[e+1]} * ${i[e+1]})`;return r}const p=(e,t,n)=>"int32"===n?`atomicAdd(${e}, bitcast<i32>(${t}));`:`\n          {\n            var oldValue = 0;\n            loop {\n              let newValueF32 = bitcast<f32>(oldValue) + (${t});\n              let newValue = bitcast<i32>(newValueF32);\n              let res = atomicCompareExchangeWeak(${e}, oldValue, newValue);\n              if res.exchanged {\n                break;\n              }\n              oldValue = res.old_value;\n            }\n          }`,c=(e,n,i,r,s)=>{const a=function(e,n,i){const r=[],s=i.workgroupSize[0]*i.workgroupSize[1]*i.workgroupSize[2];if(i.outputComponent=i.outputComponent?i.outputComponent:1,r.push(`\n\n      var<private> localId: vec3<u32>;\n      var<private> localIndex: u32;\n      var<private> globalId: vec3<u32>;\n      var<private> numWorkgroups: vec3<u32>;\n      var<private> workgroupId: vec3<u32>;\n\n      // Only used when the y/z dimension of workgroup size is 1.\n      fn getGlobalIndex() -> i32 {\n        ${S(i)?"  return i32(globalId.x);":`  return i32((workgroupId.z * numWorkgroups.x * numWorkgroups.y +\n                workgroupId.y * numWorkgroups.x + workgroupId.x) * ${s}u +\n                localIndex);\n        `}\n      }\n    `),i.isFromPixels){r.push(`\n        struct Uniform {\n          size            : i32,\n          numChannels     : i32,\n          outShapeStrides : vec2<i32>,\n        };\n\n        @group(0) @binding(0) var<storage, read_write> result: array<${v(n.dtype,i.outputComponent)}>;\n        @group(0) @binding(2) var<uniform> uniforms: Uniform;\n      `);const e=I(i);return[y,r.join("\n"),C(n.shape),i.getUserCode(),b(e,i)].join("\n")}let a,o,u="struct Uniforms { NAN : f32, INFINITY : f32, ";i.variableNames.forEach(((t,n)=>{const i=m(e[n].shape.length);u+=`${t.charAt(0).toLowerCase()+t.slice(1)}Shape : ${i}, `,a=e[n].shape.length-1,o=m(a),u+=`${t.charAt(0).toLowerCase()+t.slice(1)}ShapeStrides: ${o}, `}));const l=m(n.shape.length);u+=`outShape : ${l}, `,a=n.shape.length-1,o=m(a),u+=`\n         outShapeStrides: ${o}, `,i.size&&(u+="size : i32, ");i.uniforms&&(u+=i.uniforms);u+="};",u=function(e){const t=/(\w+)\s*:\s*vec(5|6)/g;e=e.replace(t,(e=>"@align(16) "+e));const n=/vec(5|6)\s*,\s*(\w+)/g;return e=e.replace(n,((e,t,n)=>`vec${t}, @align(16) ${n}`))}(u),r.push(u),i.atomic?r.push("\n      @group(0) @binding(0) var<storage, read_write> result: array<atomic<i32>>;\n    "):r.push(`\n      @group(0) @binding(0) var<storage, read_write> result: array<${v(n.dtype,i.outputComponent)}>;\n    `);i.variableNames.forEach(((t,n)=>{r.push(`\n      @group(0) @binding(${1+n}) var<storage, read> ${t}: array<${i.variableComponents?v(e[n].dtype,i.variableComponents[n]):v(e[n].dtype,i.outputComponent)}>;\n        `)})),""!==u&&r.push(`\n      @group(0) @binding(${1+i.variableNames.length}) var<uniform> uniforms: Uniforms;\n      `);const d=function(e,t){const{x:n,y:i=[],z:r=[]}=t,s=e.length,a=n.length+i.length+r.length;if(a!==s)return"";if(n.length===s){return`fn getOutputCoords() -> ${m(s)}{\n    let globalIndex = getGlobalIndex();\n    return getCoordsFromIndex(globalIndex);\n  }\n  `}let o="";const u=[n,i,r];for(let e=0;e<u.length;e++){const t=u[e];if(0!==t.length)if(1===t.length)o+=`let d${t[0]} = i32(globalId[${e}]);`;else{const n=h(t,"uniforms.outShape");o+=`var index${e} = i32(globalId[${e}]);`;for(let i=0;i<n.length;i++)o+=`let d${t[i]} = index${e} / ${n[i]};`,i===n.length-1?o+=`let d${t[i+1]} = index${e} - d${t[i]} * ${n[i]};`:o+=`index${e} = index${e} - d${t[i]} * ${n[i]};`}}const l=[];for(let e=0;e<a;e++)l.push(`d${e}`);const d=m(a);let p=`fn getOutputCoords() -> ${d} {\n  ${o}\n`;0===l.length?p+=`return ${d}(0); }`:p+=`return ${d}(${l.join(",")}); }`;return p}(n.shape,i.dispatchLayout),p=[y,r.join("\n")+w,C(n.shape),d,k(n.shape.length)];i.atomic||p.push(function(e,t,n){const i=e.length,r=v(t,n);let s=`fn setOutputAtIndex(flatIndex : i32, value : ${f(n)}) {\n      result[flatIndex] = ${r}(value);\n    }\n\n    fn setOutputAtIndexI32(flatIndex : i32, value : ${f(n,"i32")}) {\n      result[flatIndex] = ${r}(value);\n    }\n    `;if(i>=2){const e=["d0","d1","d2","d3","d4","d5"].slice(0,i),t=m(i);s+=`\n      fn setOutputAtCoords(${e.map((e=>`${e} : i32`)).join(", ")}, value : ${f(n)}) {\n        let flatIndex = getOutputIndexFromCoords(${t}(${e.join(", ")}));\n        setOutputAtIndex(flatIndex${1===n?"":` / ${n}`}, value);\n      }\n      fn setOutputAtCoordsI32(${e.map((e=>`${e} : i32`)).join(", ")}, value : ${f(n,"i32")}) {\n        let flatIndex = getOutputIndexFromCoords(${t}(${e.join(", ")}));\n        setOutputAtIndexI32(flatIndex${1===n?"":` / ${n}`}, value);\n      }\n    `}return s}(n.shape,n.dtype,i.outputComponent));i.variableNames.forEach(((t,n)=>{p.push(`${C(e[n].shape,t)}`)}));const c=e.map(((e,r)=>function(e,n,i,r){let s=function(e,t){const n=e.name,i=e.shape.length,r=m(i),s="get"+n.charAt(0).toUpperCase()+n.slice(1),a=["d0","d1","d2","d3","d4","d5"].slice(0,i),o=a.map((e=>`${e} : i32`)).join(", ");if(i<1)return`\n      fn ${s}() -> ${f(t)} {\n        return ${f(t)}(${n}[0]);\n      }\n    `;const u=`uniforms.${n.charAt(0).toLowerCase()+n.slice(1)}Shape`;let l=`${i}D`;0===i&&(l="1D");return`\n    fn ${s}(${o}) -> ${f(t)} {\n      return ${f(t)}(${n}[getIndexFromCoords${l}(${r}(${a.join(",")}),\n        ${u})${1===t?"":` / ${t}`}]);\n    }\n   `}(e,i);e.shape.length<=n.length&&(s+=function(e,n,i,r){const s=e.name,a=s.charAt(0).toUpperCase()+s.slice(1),o="get"+a+"ByOutput",u=e.shape.length,l=n.length,d=m(l);if(t.util.arraysEqual(e.shape,n)&&r)return`\n    fn ${o}Index(globalIndex : i32) -> ${f(i)} {\n      return ${f(i)}(${s}[globalIndex]);\n    }\n\n    fn ${o}Coords(coords : ${d}) -> ${f(i)} {\n      return ${f(i)}(${s}[${l>1?"getOutputIndexFromCoords(coords)":"coords"}${1===i?"":` / ${i}`}]);\n    }\n    `;const h=t.backend_util.getBroadcastDims(e.shape,n),p=l-u;let c="";if(0===u)return`\n    fn ${o}Index(globalIndex : i32) -> ${f(i)}{\n      return get${a}();\n    }\n\n    fn ${o}Coords(coords : ${d}) -> ${f(i)}{\n      return get${a}();\n    }\n  `;c=l<2&&h.length>=1?"coords = 0;":h.map((e=>`coords.${g(e+p)} = 0;`)).join("\n");let x="";if(l<2&&u>0)x="coords";else if(l>1){const t=m(u),n=e.shape.map(((e,t)=>`coords.${g(t+p)}`)).join(", ");x=`${t}(${n})`}else x="coords";const b=`uniforms.${s.charAt(0).toLowerCase()+s.slice(1)}Shape`,y=`${u}D`;return`\n  fn ${o}Index(globalIndex : i32) -> ${f(i)} {\n    var coords = getCoordsFromIndex(globalIndex);\n    ${c}\n    return ${f(i)}(${s}[getIndexFromCoords${y}(${x}, ${b})${1===i?"":` / ${i}`}]);\n  }\n\n  fn ${o}Coords(coordsIn : ${d}) -> ${f(i)} {\n    var coords = coordsIn;\n    ${c}\n    return ${f(i)}(${s}[getIndexFromCoords${y}(${x}, ${b})${1===i?"":` / ${i}`}]);\n  }\n`}(e,n,i,r));return s}(e,n.shape,i.variableComponents?i.variableComponents[r]:i.outputComponent,i.dispatchLayout.x.length===n.shape.length))).join("\n");p.push(c),p.push(i.getUserCode());const x=I(i);p.push(b(x,i));return p.join("\n")}(i,{dtype:r.dtype,shape:r.shape},n),o=e.createShaderModule({code:a,label:n.constructor.name});let u=t.env().get("WEBGPU_PRINT_SHADER");if(""!==u){u=u.toLowerCase();const e=u.split(",");("all"===u||e.some((e=>n.shaderKey.toLowerCase().includes(e))))&&(console.group(n.shaderKey),console.debug(a),console.groupEnd())}return s?e.createComputePipelineAsync({compute:{module:o,entryPoint:"_start"},label:n.constructor.name,layout:"auto"}):e.createComputePipeline({compute:{module:o,entryPoint:"_start"},label:n.constructor.name,layout:"auto"})},f=(e,t="f32")=>{switch(e){case 1:return`${t}`;case 2:return`vec2<${t}>`;case 3:return`vec3<${t}>`;case 4:return`vec4<${t}>`;default:throw new Error(`${e}-component ${t} is not supported.`)}};function m(e){if(e<=1)return"i32";if(2===e)return"vec2<i32>";if(3===e)return"vec3<i32>";if(4===e)return"vec4<i32>";if(5===e)return"vec5";if(6===e)return"vec6";throw Error(`GPU for rank ${e} is not yet supported`)}function g(e){if(0===e)return"x";if(1===e)return"y";if(2===e)return"z";if(3===e)return"w";if(4===e)return"u";if(5===e)return"v";throw Error(`Index ${e} is not yet supported`)}function x(...e){let t;switch(e.length){case 0:t="\n        fn main()\n      ";break;case 1:t=`\n        fn main(${e[0]} : i32)\n      `;break;default:throw Error("Unreachable")}return t}function b(e,t){let n;return n=`\n     ${function(e){return`\n  @compute @workgroup_size(${e.workgroupSize[0]}, ${e.workgroupSize[1]}, ${e.workgroupSize[2]})\n`}(t)}\n      fn _start(@builtin(local_invocation_id) LocalId : vec3<u32>,\n                @builtin(global_invocation_id) GlobalId : vec3<u32>,\n                @builtin(local_invocation_index) LocalIndex: u32,\n                @builtin(workgroup_id) WorkgroupId : vec3<u32>,\n                @builtin(num_workgroups) NumWorkgroups : vec3<u32>) {\n        localId = LocalId;\n        localIndex = LocalIndex;\n        globalId = GlobalId;\n        numWorkgroups = NumWorkgroups;\n        workgroupId = WorkgroupId;\n        ${e?"main(getGlobalIndex());":"main();"};\n      }\n    `,n}const y="\n  struct vec5 {x: i32, y: i32, z: i32, w: i32, u: i32};\n  struct vec6 {x: i32, y: i32, z: i32, w: i32, u: i32, v: i32};\n\n  // Checks whether coordinates lie within the bounds of the shape.\n  fn coordsInBounds2D(coord : vec2<i32>, shape : vec2<i32>) -> bool {\n    return all(coord >= vec2<i32>(0)) && all(coord < shape);\n  }\n  fn coordsInBounds3D(coord : vec3<i32>, shape : vec3<i32>) -> bool {\n    return all(coord >= vec3<i32>(0)) && all(coord < shape);\n  }\n  fn coordsInBounds4D(coord : vec4<i32>, shape : vec4<i32>) -> bool {\n    return all(coord >= vec4<i32>(0)) && all(coord < shape);\n  }\n\n  fn getIndexFromCoords1D(coord : i32, shape : i32) -> i32 {\n    return coord;\n  }\n  fn getIndexFromCoords2D(coords : vec2<i32>, shape : vec2<i32>) -> i32 {\n    return dot(coords, vec2<i32>(shape.y, 1));\n  }\n  fn getIndexFromCoords3D(coords : vec3<i32>, shape : vec3<i32>) -> i32 {\n    return dot(coords, vec3<i32>(shape.y * shape.z, shape.z, 1));\n  }\n  fn getIndexFromCoords4D(coords : vec4<i32>, shape : vec4<i32>) -> i32 {\n    return dot(coords, vec4<i32>(\n        shape.y * shape.z * shape.w, shape.z * shape.w, shape.w, 1));\n  }\n  fn getIndexFromCoords5D(coords : vec5, shape : vec5) -> i32 {\n    let shapeStrides: vec5 = vec5(shape.y * shape.z * shape.w * shape.u, shape.z * shape.w * shape.u, shape.w * shape.u, shape.u, 1);\n    return coords.x*shapeStrides.x + coords.y*shapeStrides.y + coords.z*shapeStrides.z + coords.w*shapeStrides.w + coords.u*shapeStrides.u;\n  }\n  fn getIndexFromCoords6D(coords : vec6, shape : vec6) -> i32 {\n    let shapeStrides: vec6 = vec6(shape.y * shape.z * shape.w * shape.u * shape.v, shape.z * shape.w * shape.u * shape.v, shape.w * shape.u * shape.v, shape.u * shape.v, shape.v, 1);\n    return coords.x*shapeStrides.x + coords.y*shapeStrides.y + coords.z*shapeStrides.z + coords.w*shapeStrides.w + coords.u*shapeStrides.u + coords.v*shapeStrides.v;\n  }\n\n  fn idiv(a: i32, b: i32, sign: f32) -> i32 {\n    var res: i32 = a / b;\n    let modulo: i32 = a % b;\n    if (sign < 0. && modulo != 0) {\n      res = res - 1;\n    }\n    return res;\n  }\n\n  // NaN defination in IEEE 754-1985 is :\n  //   - sign = either 0 or 1.\n  //   - biased exponent = all 1 bits.\n  //   - fraction = anything except all 0 bits (since all 0 bits represents infinity).\n  // https://en.wikipedia.org/wiki/IEEE_754-1985#Representation_of_non-numbers\n  fn isnan(val: f32) -> bool {\n    let floatToUint: u32 = bitcast<u32>(val);\n    return (floatToUint & 0x7fffffffu) > 0x7f800000u;\n  }\n  fn isnanVec4(val : vec4<f32>) -> vec4<bool> {\n    let floatToUint: vec4<u32> = bitcast<vec4<u32>>(val);\n    return (floatToUint & vec4<u32>(0x7fffffffu)) > vec4<u32>(0x7f800000u);\n  }\n",w="\n  fn isinf(val: f32) -> bool {\n    return abs(val) == uniforms.INFINITY;\n  }\n";function C(e,n=""){const i=e.length,r=""!==n?`get${n.charAt(0).toUpperCase()+n.slice(1)}CoordsFromIndex`:"getCoordsFromIndex",s=""!==n?`${n.charAt(0).toLowerCase()+n.slice(1)}ShapeStrides`:"outShapeStrides";if(i<=1)return`fn ${r}(index : i32) -> i32 { return index; }`;const a=t.util.computeStrides(e),o=m(i),u=[];for(let e=0;e<i;e++)u.push(`d${e}`);if(1===a.length)return`    fn ${r}(index : i32) -> vec2<i32> {\n      let d0 = index / uniforms.${s}; let d1 = index - d0 * uniforms.${s};\n      return vec2<i32>(d0, d1);\n    }`;let l;return l="var index2 = index;"+a.map(((e,t)=>`${`let ${u[t]} = index2 / uniforms.${s}.${g(t)}`}; ${t===a.length-1?`let ${u[t+1]} = index2 - ${u[t]} * uniforms.${s}.${g(t)}`:`index2 = index2 - ${u[t]} * uniforms.${s}.${g(t)}`};`)).join(""),`\n    fn ${r}(index : i32) -> ${o} {\n      ${l}\n      return ${o}(${u.join(",")});\n    }\n  `}function k(e){let n="";switch(e){case 0:case 1:n+="\n        fn getOutputIndexFromCoords(coords : i32) -> i32 {\n          return coords;\n        }\n        ";break;case 2:n+="\n        fn getOutputIndexFromCoords(coords : vec2<i32>) -> i32 {\n          return dot(coords, vec2<i32>(uniforms.outShapeStrides, 1));\n        }\n        ";break;case 3:n+="\n        fn getOutputIndexFromCoords(coords : vec3<i32>) -> i32 {\n          return dot(coords, vec3<i32>(uniforms.outShapeStrides.x, uniforms.outShapeStrides.y, 1));\n        }\n        ";break;case 4:n+="\n        fn getOutputIndexFromCoords(coords : vec4<i32>) -> i32 {\n          return dot(coords, vec4<i32>(\n            uniforms.outShapeStrides.x, uniforms.outShapeStrides.y, uniforms.outShapeStrides.z, 1));\n        }\n        ";break;case 5:n+="\n        fn getOutputIndexFromCoords(coords : vec5) -> i32 {\n          return coords.x * uniforms.outShapeStrides.x +\n              coords.y * uniforms.outShapeStrides.y +\n              coords.z * uniforms.outShapeStrides.z +\n              coords.w * uniforms.outShapeStrides.w +\n              coords.u;\n        }\n        ";break;case 6:n+="\n        fn getOutputIndexFromCoords(coords : vec6) -> i32 {\n          return coords.x * uniforms.outShapeStrides.x +\n              coords.y * uniforms.outShapeStrides.y +\n              coords.z * uniforms.outShapeStrides.z +\n              coords.w * uniforms.outShapeStrides.w +\n              coords.u * uniforms.outShapeStrides.u +\n              coords.v;\n        }\n        ";break;default:t.util.assert(!1,(()=>`Unsupported ${e}D shape`))}return n}function S(e){return 1===e.dispatch[1]&&1===e.dispatch[2]}function v(e,t=1){if("float32"===e)return f(t,"f32");if("int32"===e||"bool"===e)return f(t,"i32");throw new Error(`type ${e} is not supported.`)}function I(e){return(!e.dispatchLayout.hasOwnProperty("y")||0===e.dispatchLayout.y.length)&&(!e.dispatchLayout.hasOwnProperty("z")||0===e.dispatchLayout.z.length)}const R=e=>{let t=1;for(let n=0;n<e.length;n++)t*=e[n];return t};function $(e,t,n=[1,1,1],i=[1,1,1]){const[r,s,a]=[Math.ceil(R(e.x.map((e=>t[e])))/(n[0]*i[0])),e.y?Math.ceil(R(e.y.map((e=>t[e])))/(n[1]*i[1])):1,e.z?Math.ceil(R(e.z.map((e=>t[e])))/(n[2]*i[2])):1];return[r,s,a]}function P(e,t,n,i=!1){const r=[8,8,1],s=[4,4,1];return i||(e<=8&&(s[1]=1),t<=16&&n<=16&&(r[0]=4)),{workgroupSize:r,elementsPerThread:s}}function A(e,t,n=!1){if(n)return[8,8,1];const i=R(e.x.map((e=>t[e]))),r=R(e.y.map((e=>t[e])));return i<=4?[4,16,1]:r<=4?[16,4,1]:[16,16,1]}function z(e,t,n=!1){if(n)return[4,4,1];const i=R(e.x.map((e=>t[e]))),r=R(e.y.map((e=>t[e])));return i<=4?[1,2,1]:r<=4?[2,1,1]:[2,2,1]}function N(e){return{x:e.map(((e,t)=>t))}}function D(e){if("float32"===e||"int32"===e||"bool"===e||"string"===e)return 4;if("complex64"===e)return 8;throw new Error(`Unknown dtype ${e}`)}function T(){return("undefined"!=typeof window||"undefined"!=typeof WorkerGlobalScope)&&!!navigator.gpu}function F(e,n){Array.isArray(e)||(e=[e]),e.forEach((e=>{null!=e&&t.util.assert("complex64"!==e.dtype,(()=>`${n} does not support complex64 tensors in the WebGPU backend.`))}))}var _;!function(e){e[e.MatMulReduceProgram=0]="MatMulReduceProgram",e[e.MatMulSplitKProgram=1]="MatMulSplitKProgram",e[e.MatMulSmallOutputSizeProgram=2]="MatMulSmallOutputSizeProgram",e[e.MatMulPackedProgram=3]="MatMulPackedProgram",e[e.MatMulMax=4]="MatMulMax"}(_||(_={}));var E={__proto__:null,GPUBytesPerElement:D,get MatMulProgramType(){return _},assertNotComplex:F,computeDispatch:$,computeWorkPerThreadForConv2d:z,computeWorkgroupInfoForMatMul:P,computeWorkgroupSizeForConv2d:A,flatDispatchLayout:N,isWebGPUSupported:T,tilesFitEvenlyIntoShape:function(e,t){if(e.length!==t.length)throw new Error(`Cannot compute whether rank ${e.length} tiles fit evenly into rank ${t.length} shape - ranks must match.`);return t.every(((t,n)=>t%e[n]==0))}};const W=t.env().getNumber("WEBGPU_CPU_HANDOFF_SIZE_THRESHOLD");class L extends t.KernelBackend{nextDataId(){return L.nextDataId++}constructor(e,n){if(super(),this.commandQueueOwnedIds=new WeakSet,this.dispatchNumberInEncoder=0,this.disposed=!1,this.downloadWaitMs=0,this.tensorDataPendingDisposal=[],this.stagingPendingDisposal=[],this.uniformPendingDisposal=[],this.uploadWaitMs=0,this.hasReadSyncWarned=!1,!T())throw new Error("WebGPU is not supported on this device");this.pipelineCache={},this.device=e,this.queue=e.queue,this.currentCommandEncoder=null,this.currentComputePass=null,this.supportTimeQuery=e.features.has("timestamp-query-inside-passes"),this.adapterInfo=new s(n),this.thresholdToIncreaseWorkgroups=this.adapterInfo.intelGPUGeneration>=12?16:8,this.bufferManager=new a(this.device),this.textureManager=new u(this.device),this.tensorMap=new t.DataStorage(this,t.engine()),this.supportTimeQuery&&(this.querySet=this.device.createQuerySet({type:"timestamp",count:2})),t.env().getBool("WEBGPU_USE_PROFILE_TOOL")&&(this.dummyCanvas=document.createElement("canvas"),this.dummyCanvas.width=1,this.dummyCanvas.height=1,this.dummyContext=this.dummyCanvas.getContext("webgpu"),this.dummyContext.configure({device:e,format:"bgra8unorm"}),document.body.appendChild(this.dummyCanvas))}floatPrecision(){return 32}disposeData(e,t=!1){if(!this.tensorMap.has(e))return!0;const n=this.tensorMap.get(e);return t?n.refCount=0:n.refCount--,!(n.refCount>0)&&(null!=n.complexTensorInfos&&(this.disposeData(n.complexTensorInfos.real.dataId),this.disposeData(n.complexTensorInfos.imag.dataId)),this.commandQueueOwnedIds.has(e)?(this.tensorDataPendingDisposal.push(e),!0):(this.releaseResource(e),this.tensorMap.delete(e),!0))}memory(){return{numBytesInGPU:this.bufferManager.numBytesUsed,numBytesAllocatedInGPU:this.bufferManager.numBytesAllocated,unreliable:!1}}releaseResource(e){const t=this.tensorMap.get(e);t&&t.resource&&(t.external||(t.resource instanceof GPUBuffer?this.bufferManager.releaseBuffer(t.resource):t.resource instanceof GPUTexture&&this.textureManager.releaseTexture(t.resource)),t.resource=null)}refCount(e){if(this.tensorMap.has(e)){return this.tensorMap.get(e).refCount}return 0}incRef(e){this.tensorMap.get(e).refCount++}decRef(e){if(this.tensorMap.has(e)){this.tensorMap.get(e).refCount--}}write(e,t,n){if("complex64"===n&&null!=e)throw new Error("Cannot write to a complex64 dtype. Please use tf.complex(real, imag).");const i={id:this.nextDataId()};return this.tensorMap.set(i,{dtype:n,shape:t,values:e,refCount:1}),i}move(e,t,n,i,r){if("complex64"===i)throw new Error("Cannot write to a complex64 dtype. Please use tf.complex(real, imag).");this.tensorMap.set(e,{dtype:i,shape:n,values:t,refCount:r})}submitQueue(){this.ensureComputePassEnded(),this.queue.submit([this.currentCommandEncoder.finish()]),this.currentCommandEncoder=null,this.dispatchNumberInEncoder=0,this.commandQueueOwnedIds=new WeakSet,this.tensorDataPendingDisposal.forEach((e=>{this.releaseResource(e),this.tensorMap.delete(e)})),this.uniformPendingDisposal.forEach((e=>this.bufferManager.releaseBuffer(e))),this.stagingPendingDisposal.forEach((e=>this.bufferManager.releaseBuffer(e,!1))),this.tensorDataPendingDisposal=[],this.uniformPendingDisposal=[],this.stagingPendingDisposal=[]}ensureCommandEncoderReady(){this.currentCommandEncoder||(this.currentCommandEncoder=this.device.createCommandEncoder())}ensureComputePassEnded(){this.currentComputePass&&(this.currentComputePass.end(),this.currentComputePass=null)}getComputePass(){return this.currentComputePass||(this.currentComputePass=this.currentCommandEncoder.beginComputePass()),this.currentComputePass}async checkCompileCompletionAsync(){let e;try{e=await Promise.all(Object.values(this.pipelineCache))}catch(e){throw new Error(e.message)}Object.keys(this.pipelineCache).map(((t,n)=>{this.pipelineCache[t]=e[n]}))}async getBufferData(e){if(t.env().getBool("WEBGPU_ENGINE_COMPILE_ONLY"))return console.warn("The data may be invalid since WEBGPU_ENGINE_COMPILE_ONLY is true, this can only be called when WEBGPU_ENGINE_COMPILE_ONLY is false"),null;const n=e.size,i=this.bufferManager.acquireBuffer(n,GPUBufferUsage.COPY_DST|GPUBufferUsage.MAP_READ);this.ensureCommandEncoderReady(),this.ensureComputePassEnded(),this.currentCommandEncoder.copyBufferToBuffer(e,0,i,0,n),this.submitQueue(),await i.mapAsync(GPUMapMode.READ);const r=i.getMappedRange().slice(0);return i.unmap(),null!=i&&this.bufferManager.releaseBuffer(i),t.env().getBool("WEBGPU_USE_PROFILE_TOOL")&&(t.util.assert(void 0!==this.dummyContext,(()=>"Fail to get context for profiling tool")),this.dummyContext.getCurrentTexture()),r}convertAndCacheOnCPU(e,t){const n=this.tensorMap.get(e);return n.values=t,n.values}readSync(e){this.hasReadSyncWarned||(this.hasReadSyncWarned=!0,console.warn("The performance of synchronously reading data from GPU to CPU is poor on the webgpu backend, please use asynchronous APIs instead."));const n=this.tensorMap.get(e),{values:i,complexTensorInfos:r}=n;if(null!=i||"string"===n.dtype)return i;if("complex64"===n.dtype){const n=this.readSync(r.real.dataId),i=this.readSync(r.imag.dataId),s=t.util.convertBackendValuesAndArrayBuffer(t.backend_util.mergeRealAndImagArrays(n,i).buffer,"float32");return this.convertAndCacheOnCPU(e,s),s}const s=["opaque","premultiplied"],a=n.resource,o=a.size;t.util.assert(o%4==0,(()=>"Because there is 4 bytes for one pixel, buffer size must be multiple of 4."));const u=o/4,l=new ArrayBuffer(o),d=256,h=256,p=s.map((e=>new OffscreenCanvas(d,h))),c=new OffscreenCanvas(d,h);this.ensureComputePassEnded(),p.map(((e,t)=>{const n=e.getContext("webgpu");return n.configure({device:this.device,format:"bgra8unorm",usage:GPUTextureUsage.COPY_DST,alphaMode:s[t]}),n.getCurrentTexture()})).map(((e,t)=>{const n=(n,i,r)=>{this.ensureCommandEncoderReady(),this.currentCommandEncoder.copyBufferToTexture({buffer:a,bytesPerRow:1024,offset:r},{texture:e},{width:n,height:i}),this.submitQueue();const o=c.getContext("2d",{willReadFrequently:!0});o.clearRect(0,0,n,i),o.drawImage(p[t],0,0);const u=o.getImageData(0,0,n,i).data,d=s[t],h=new Uint8ClampedArray(l,r,n*i*4);for(let e=0;e<h.length;e+=4)if("premultiplied"===d)h[e+3]=u[e+3];else{const t=u[e];h[e]=u[e+2],h[e+1]=u[e+1],h[e+2]=t}},i=Math.floor(u/65536);let r=d,o=h,f=0;for(let e=0;e<i;e++)n(r,o,f),f+=262144;const m=u%65536;o=Math.floor(m/d),o>0&&(n(r,o,f),f+=1024*o),r=m%d,r>0&&n(r,1,f)}));const f=t.util.convertBackendValuesAndArrayBuffer(l,n.dtype);return this.convertAndCacheOnCPU(e,f),f}async read(e){if(!this.tensorMap.has(e))throw new Error(`Tensor ${e} was not registered!`);const n=this.tensorMap.get(e),{values:i}=n;if(null!=i)return i;let r;if("complex64"===n.dtype){const e=await Promise.all([this.read(n.complexTensorInfos.real.dataId),this.read(n.complexTensorInfos.imag.dataId)]),i=e[0],s=e[1];r=t.backend_util.mergeRealAndImagArrays(i,s)}else{const e=await this.getBufferData(n.resource);r=t.util.convertBackendValuesAndArrayBuffer(e,n.dtype)}return this.convertAndCacheOnCPU(e,r),r}copyBuffer(e){const t=e.size,n=e.usage,i=this.bufferManager.acquireBuffer(t,n);return this.ensureCommandEncoderReady(),this.ensureComputePassEnded(),this.currentCommandEncoder.copyBufferToBuffer(e,0,i,0,t),this.submitQueue(),i}createTensorFromGPUData(e,n,i){let r=e.buffer;if("complex64"===i)throw new Error("Cannot write to a complex64 dtype. ");const s={id:this.nextDataId()};this.tensorMap.set(s,{dtype:i,shape:n,values:null,refCount:1,external:e.zeroCopy});const a=this.tensorMap.get(s),o=D(a.dtype)*t.util.sizeFromShape(a.shape);if(e.buffer.size<o)throw new Error(`GPUBuffer size(${e.buffer.size}) is smaller than tensor size(${o})!`);if((e.buffer.usage&(GPUBufferUsage.STORAGE|GPUBufferUsage.COPY_SRC))!=(GPUBufferUsage.STORAGE|GPUBufferUsage.COPY_SRC))throw new Error("GPUBuffer.usage should include GPUBufferUsage.STORAGE | GPUBufferUsage.COPY_SRC!");return!0!==e.zeroCopy&&(r=this.copyBuffer(r)),a.resource=r,t.engine().makeTensorFromDataId(s,n,i,this)}readToGPU(e){const n=this.tensorMap.get(e),{values:i,dtype:r,shape:s,resource:a}=n;if("complex64"===r)throw new Error("Does not support reading buffer for complex64 dtype.");if(null==a)throw null!=i?new Error("Data is not on GPU but on CPU."):new Error("There is no data on GPU or CPU.");const o=a,u=o.size,l=o.usage,d=this.bufferManager.acquireBuffer(u,l);this.ensureCommandEncoderReady(),this.ensureComputePassEnded(),this.currentCommandEncoder.copyBufferToBuffer(a,0,d,0,u),this.submitQueue();const h=this.makeTensorInfo(s,r),p=t.engine().makeTensorFromTensorInfo(h);return this.tensorMap.get(h.dataId).resource=d,{tensorRef:p,buffer:d}}bufferSync(e){const n=this.readSync(e.dataId);if("string"===e.dtype)try{const i=n.map((e=>t.util.decodeString(e)));return t.buffer(e.shape,e.dtype,i)}catch(e){throw new Error("Failed to decode encoded string bytes into utf-8")}return t.buffer(e.shape,e.dtype,n)}async time(e){this.supportTimeQuery||console.warn("This device doesn't support timestamp-query-inside-passes extension. Start Chrome browser with flag --disable-dawn-features=disallow_unsafe_apis then try again. Otherwise, zero will be shown for the kernel time when profiling mode is enabled. Using performance.now is not workable for webgpu since it doesn't support synchronous data read from GPU.");const n=this.activeTimers,i=[];let r=!1;null==this.programTimersStack?(this.programTimersStack=i,r=!0):this.activeTimers.push(i),this.activeTimers=i,e();const s=t.util.flatten(this.activeTimers.map((e=>e.query))).filter((e=>null!=e)),a=t.util.flatten(this.activeTimers.map((e=>e.name))).filter((e=>null!=e));this.activeTimers=n,r&&(this.programTimersStack=null);const o={uploadWaitMs:this.uploadWaitMs,downloadWaitMs:this.downloadWaitMs,kernelMs:null,wallMs:null},u=await Promise.all(s);return o.kernelMs=t.util.sum(u),o.getExtraProfileInfo=()=>u.map(((e,t)=>({name:a[t],ms:e}))).map((e=>`${e.name}: ${e.ms}`)).join(", "),this.uploadWaitMs=0,this.downloadWaitMs=0,o}makeTensorInfo(e,n,i){"string"===n&&null!=i&&i.length>0&&t.util.isString(i[0])&&(i=i.map((e=>t.util.encodeString(e))));return{dataId:this.write(i,e,n),shape:e,dtype:n}}tensorToBinding(e){if(!e)return null;const t=this.tensorMap.get(e.dataId).resource;return t instanceof GPUBuffer?{buffer:t}:t instanceof GPUTexture?t.createView():t}async getQueryTime(e){return this.supportTimeQuery?this.getTimeFromQuerySet(e):0}uploadToGPU(e){const n=this.tensorMap.get(e);if(null!=n.resource)return;const i=D(n.dtype)*t.util.sizeFromShape(n.shape);let r;const s=GPUBufferUsage.STORAGE|GPUBufferUsage.COPY_SRC|GPUBufferUsage.COPY_DST;if(n.values){if(r=this.bufferManager.acquireBuffer(i,s,!0),"unmapped"===r.mapState){const e=this.bufferManager.acquireBuffer(i,GPUBufferUsage.MAP_WRITE|GPUBufferUsage.COPY_SRC,!0,!1),t=e.getMappedRange();"int32"===n.dtype||"bool"===n.dtype?new Int32Array(t).set(n.values):new Float32Array(t).set(n.values),e.unmap(),this.ensureCommandEncoderReady(),this.ensureComputePassEnded(),this.currentCommandEncoder.copyBufferToBuffer(e,0,r,0,i),this.stagingPendingDisposal.push(e)}else{const e=r.getMappedRange();"int32"===n.dtype||"bool"===n.dtype?new Int32Array(e).set(n.values):new Float32Array(e).set(n.values),r.unmap()}n.values=null}else r=this.bufferManager.acquireBuffer(i,s);n.resource=r}makeUniforms(e){let n=0,i=0;const r=[];let s=1;e.forEach((e=>{let a;switch(0===e.data.length&&(e.data=[1]),e.data.length){case 1:a=4;break;case 2:a=8;break;case 3:case 4:case 5:case 6:a=16;break;default:t.util.assert(!1,(()=>`Unsupported ${e.data.length}D shape`))}5!==i&&6!==i||(a=16),a>s&&(s=a),n=Math.ceil(n/a)*a,i=e.data.length,r.push(n),n+=4*e.data.length})),n=Math.ceil(n/s)*s;const a=new ArrayBuffer(n);e.forEach(((e,t)=>{const n=r[t];"int32"===e.type?new Int32Array(a,n,e.data.length).set(e.data):"uint32"===e.type?new Uint32Array(a,n,e.data.length).set(e.data):new Float32Array(a,n,e.data.length).set(e.data)}));const o=this.bufferManager.acquireBuffer(n,GPUBufferUsage.COPY_DST|GPUBufferUsage.UNIFORM);return this.queue.writeBuffer(o,0,a,0,n),this.uniformPendingDisposal.push(o),{offset:0,size:n,buffer:o}}runWebGPUProgram(e,n,i,r,s){if(s||(s=this.makeTensorInfo(e.outputShape,i)),0===t.util.sizeFromShape(s.shape))return this.tensorMap.get(s.dataId).values=t.util.getTypedArrayFromDType(s.dtype,0),s;this.uploadToGPU(s.dataId),e.dispatch=((e,n)=>{const i=e.limits.maxComputeWorkgroupsPerDimension,r=n.dispatchLayout,s=n.dispatch;if(s.every((e=>e<=i)))return s;t.util.assert(s[0]>i&&void 0===r.y&&void 0===r.z,(()=>"Dispatch size exceeds WebGPU limits in Y or Z dimension."));let a=Math.ceil(Math.sqrt(s[0]));return a>i?(a=Math.ceil(Math.cbrt(s[0])),t.util.assert(a<=i,(()=>"Total dispatch size exceeds WebGPU maximum.")),[a,a,a]):[a,a,1]})(this.device,e);const a=n.map(((t,n)=>{if("complex64"===t.dtype)throw new Error("GPGPUProgram does not support complex64 input. For complex64 dtypes, please separate the program into real and imaginary parts.");return this.uploadToGPU(t.dataId),{dtype:this.tensorMap.get(t.dataId).dtype,shape:t.shape,name:e.variableNames[n]}}));e.shaderKey=function(e,n,i){let r=e.shaderKey;if(e.isFromPixels)return r;const s=[],a=[];n.forEach((e=>{s.push(e.shape),a.push(e.dtype)})),s.push(i.shape),a.push(i.dtype);const o=n.map((e=>t.backend_util.getBroadcastDims(e.shape,i.shape))),u=n.map((e=>t.util.arraysEqual(e.shape,i.shape))).join("_"),l=o.map((e=>e.join("_"))).join(";"),d=S(e)?"flatDispatch":"";return r+="_"+(e.workgroupSize?e.workgroupSize.join(","):"")+s.map((e=>e.length)).join(",")+a.join(",")+e.variableNames.join(",")+l+u+d,r}(e,a,s);const o=t.env().getBool("WEBGPU_ENGINE_COMPILE_ONLY");return e.shaderKey in this.pipelineCache||(this.pipelineCache[e.shaderKey]=c(this.device,e,a,s,o)),e.pipeline=this.pipelineCache[e.shaderKey],o||this.recordAndSubmit(e,s,n,r),s}recordAndSubmit(e,n,i,r){if(e.pipeline instanceof Promise)throw new Error("Please call checkCompileCompletionAsync to ensure parallel compilation is done!");let s=[],a=[];if(!e.isFromPixels){s.push({type:"float32",data:[NaN]},{type:"float32",data:[1/0]}),a=i.concat(n).map((e=>e.shape));const r="int32";if(a.map((e=>{s.push({type:r,data:e});const n=t.util.computeStrides(e);s.push({type:r,data:n})})),e.size){const n=t.util.sizeFromShape(e.outputShape);s.push({type:r,data:[e.outputComponent?n/e.outputComponent:n]})}}r&&(s=[...s,...r]);const o=[this.tensorToBinding(n),...i.map((e=>this.tensorToBinding(e))),this.makeUniforms(s)];i.forEach((e=>{this.commandQueueOwnedIds.add(e.dataId)})),this.commandQueueOwnedIds.add(n.dataId);const u=this.device.createBindGroup({layout:e.pipeline.getBindGroupLayout(0),entries:o.map(((e,t)=>({binding:t,resource:e})))});this.ensureCommandEncoderReady();const l=this.getComputePass(),d=null!=this.activeTimers;d&&this.supportTimeQuery&&l.writeTimestamp(this.querySet,0),l.setPipeline(e.pipeline),l.setBindGroup(0,u),l.dispatchWorkgroups(e.dispatch[0],e.dispatch[1],e.dispatch[2]),d&&this.supportTimeQuery&&l.writeTimestamp(this.querySet,1),this.dispatchNumberInEncoder++,t.env().get("WEBGPU_DEFERRED_SUBMIT_BATCH_SIZE")<=this.dispatchNumberInEncoder&&this.submitQueue(),d&&this.activeTimers.push({name:e.constructor.name,query:this.getQueryTime(this.querySet)})}async getTimeFromQuerySet(e){const t=this.bufferManager.acquireBuffer(16,GPUBufferUsage.COPY_SRC|GPUBufferUsage.QUERY_RESOLVE),n=this.bufferManager.acquireBuffer(16,GPUBufferUsage.MAP_READ|GPUBufferUsage.COPY_DST);this.ensureCommandEncoderReady(),this.ensureComputePassEnded(),this.currentCommandEncoder.resolveQuerySet(e,0,2,t,0),this.currentCommandEncoder.copyBufferToBuffer(t,0,n,0,16),this.submitQueue(),await n.mapAsync(GPUMapMode.READ);const i=new BigUint64Array(n.getMappedRange()),r=Number(i[1]-i[0]);return n.unmap(),this.bufferManager.releaseBuffer(n),this.bufferManager.releaseBuffer(t),r/1e6}shouldExecuteOnCPU(e,n=W){return t.env().getBool("WEBGPU_CPU_FORWARD")&&e.every((e=>null==this.tensorMap.get(e.dataId).resource&&t.util.sizeFromShape(e.shape)<n))}numDataIds(){return this.tensorMap.numDataIds()-this.tensorDataPendingDisposal.length}dispose(){this.disposed||(this.bufferManager.dispose(),this.textureManager.dispose(),this.disposed=!0)}}var B;L.nextDataId=0,T()&&t.registerBackend("webgpu",(async()=>{const e={powerPreference:t.env().get("WEBGPU_USE_LOW_POWER_GPU")?"low-power":"high-performance"},n=await navigator.gpu.requestAdapter(e),i={};n.features.has("timestamp-query-inside-passes")&&(i.requiredFeatures=["timestamp-query-inside-passes"]);const r=n.limits;i.requiredLimits={maxComputeWorkgroupStorageSize:r.maxComputeWorkgroupStorageSize,maxComputeWorkgroupsPerDimension:r.maxComputeWorkgroupsPerDimension,maxStorageBufferBindingSize:r.maxStorageBufferBindingSize,maxBufferSize:r.maxBufferSize,maxComputeWorkgroupSizeX:r.maxComputeWorkgroupSizeX,maxComputeInvocationsPerWorkgroup:r.maxComputeInvocationsPerWorkgroup};const s=await n.requestDevice(i),a=await n.requestAdapterInfo();return new L(s,a)}),3),function(e){e[e.ADD=0]="ADD",e[e.ATAN2=1]="ATAN2",e[e.COMPLEX_MULTIPLY_IMAG=2]="COMPLEX_MULTIPLY_IMAG",e[e.COMPLEX_MULTIPLY_REAL=3]="COMPLEX_MULTIPLY_REAL",e[e.DIV=4]="DIV",e[e.ELU_DER=5]="ELU_DER",e[e.EQUAL=6]="EQUAL",e[e.GREATER=7]="GREATER",e[e.GREATER_EQUAL=8]="GREATER_EQUAL",e[e.INT_DIV=9]="INT_DIV",e[e.LESS=10]="LESS",e[e.LESS_EQUAL=11]="LESS_EQUAL",e[e.LOGICAL_AND=12]="LOGICAL_AND",e[e.LOGICAL_OR=13]="LOGICAL_OR",e[e.MAX=14]="MAX",e[e.MIN=15]="MIN",e[e.MOD=16]="MOD",e[e.MUL=17]="MUL",e[e.NOT_EQUAL=18]="NOT_EQUAL",e[e.POW=19]="POW",e[e.PRELU=20]="PRELU",e[e.SQUARED_DIFFERENCE=21]="SQUARED_DIFFERENCE",e[e.SUB=22]="SUB"}(B||(B={}));function O(e,t){do{let n;switch(e){case B.ATAN2:n="var resultTemp = atan2(a, b);";break;case B.MAX:n="var resultTemp = max(a, b);";break;case B.MIN:n="var resultTemp = min(a, b);";break;case B.MOD:n=t?"\n  let isNaN = !vec4<bool>(b);\n  var resultTemp = vec4<f32>(a % b);\n  if (!((a[0] < 0. && b[0] < 0.) || (a[0] >= 0. && b[0] > 0.))) {\n    resultTemp[0] = (resultTemp[0] + b[0]) % b[0];\n  }\n  if (!((a[1] < 0. && b[1] < 0.) || (a[1] >= 0. && b[1] > 0.))) {\n    resultTemp[1] = (resultTemp[1] + b[1]) % b[1];\n  }\n  if (!((a[2] < 0. && b[2] < 0.) || (a[2] >= 0. && b[2] > 0.))) {\n    resultTemp[2] = (resultTemp[2] + b[2]) % b[2];\n  }\n  if (!((a[3] < 0. && b[3] < 0.) || (a[3] >= 0. && b[3] > 0.))) {\n    resultTemp[3] = (resultTemp[3] + b[3]) % b[3];\n  }\n":"\n  let isNaN = b == 0.;\n  var resultTemp = a % b;\n  resultTemp = select((resultTemp + b) % b, resultTemp,\n      (a < 0. && b < 0.) || (a >= 0. && b > 0.));\n";break;case B.NOT_EQUAL:n=t?"\n  var resultTemp = vec4<f32>(a != b);\n  let valueForNaN = 1.0;\n":"\n  var resultTemp = f32(a != b);\n  let valueForNaN = 1.0;\n";break;case B.POW:n=t?"\n  let isModRound1Bool = vec4<i32>(round(abs(b) % vec4<f32>(2.0))) == vec4<i32>(1);\n  let isModRound1 = vec4<f32>(isModRound1Bool);\n  let multiplier = sign(a) * isModRound1 + (vec4<f32>(1.0) - isModRound1);\n  var resultTemp = multiplier * pow(abs(a), b);\n\n  // Ensure that a^0 = 1, including 0^0 = 1 as this correspond to TF and JS\n  let isExpZero = b == vec4<f32>(0.0);\n  if (isExpZero.r) {\n    resultTemp.r = 1.0;\n  }\n  if (isExpZero.g) {\n    resultTemp.g = 1.0;\n  }\n  if (isExpZero.b) {\n    resultTemp.b = 1.0;\n  }\n  if (isExpZero.a) {\n    resultTemp.a = 1.0;\n  }\n  let isNaN = (a < vec4<f32>(0.0)) & (floor(b) < b);\n":"\n  let isNaN = a < 0.0 && floor(b) < b;\n  if (b == 0.0) {\n    return 1.0;\n  }\n  var resultTemp = select(sign(a) * pow(abs(a), b), pow(abs(a), b),\n      round(abs(b) % 2.0) != 1.0);\n";break;default:continue}return`\n      let isNaN = false;\n      let valueForNaN = uniforms.NAN;\n      {\n        ${n}\n        ${t?"\n  resultTemp = select(\n      resultTemp, vec4<f32>(valueForNaN),\n      vec4<bool>(isNaN) | isnanVec4(a) | isnanVec4(b));\n  ":"\n  resultTemp = select(resultTemp, valueForNaN, isNaN | isnan(a) | isnan(b));"}\n        return resultTemp;\n      }\n    `}while(0);switch(e){case B.ADD:return"return a + b;";case B.COMPLEX_MULTIPLY_IMAG:return"return areal * bimag + aimag * breal;";case B.COMPLEX_MULTIPLY_REAL:return"return areal * breal - aimag * bimag;";case B.DIV:return"return a / b;";case B.ELU_DER:return t?"return select(a * (b + vec4<f32>(1.0)), a, b >= vec4<f32>(0.));":"return select(a * (b + 1.0), a, b >= 0.);";case B.EQUAL:return t?"return vec4<f32>(a == b);":"return f32(a == b);";case B.GREATER:return t?"return vec4<f32>(a > b);":"return f32(a > b);";case B.GREATER_EQUAL:return t?"return vec4<f32>(a >= b);":"return f32(a >= b);";case B.INT_DIV:return t?"\n  let ia = vec4<i32>(round(a));\n  let ib = vec4<i32>(round(b));\n  let cond = ib != vec4<i32>(0);\n  var resultTemp = vec4<i32>(0);\n  let s = sign(a) * sign(b);\n\n  // Windows (D3D) wants guaranteed non-zero int division at compile-time.\n  if (cond[0]) {\n    resultTemp[0] = idiv(ia[0], ib[0], s[0]);\n  }\n  if (cond[1]) {\n    resultTemp[1] = idiv(ia[1], ib[1], s[1]);\n  }\n  if (cond[2]) {\n    resultTemp[2] = idiv(ia[2], ib[2], s[2]);\n  }\n  if (cond[3]) {\n    resultTemp[3] = idiv(ia[3], ib[3], s[3]);\n  }\n  return vec4<f32>(resultTemp);\n":"\n  let s = sign(a) * sign(b);\n  let ia = i32(round(a));\n  let ib = i32(round(b));\n  return f32(idiv(ia, ib, s));\n";case B.LESS:return t?"return vec4<f32>(a < b);":"return f32(a < b);";case B.LESS_EQUAL:return t?"return vec4<f32>(a <= b);":"return f32(a <= b);";case B.LOGICAL_AND:return t?"return (vec4<f32>(a >= vec4<f32>(1.0)) *\n  vec4<f32>(b >= vec4<f32>(1.0)));":"return f32(a >= 1.0 && b >= 1.0);";case B.LOGICAL_OR:return t?"return min(vec4<f32>(a >= vec4<f32>(1.0)) +\n  vec4<f32>(b >= vec4<f32>(1.0)), vec4<f32>(1.0));":"return f32(a >= 1.0 || b >= 1.0);";case B.MUL:return"return a * b;";case B.PRELU:return t?"\n  let aLessThanZero = vec4<f32>(a < vec4<f32>(0.0));\n  return (aLessThanZero * (b * a)) + ((vec4<f32>(1.0) - aLessThanZero) * a);\n":"if (a < 0.0) { return b * a; }  return a;";case B.SQUARED_DIFFERENCE:return"return (a - b) * (a - b);";case B.SUB:return"return a - b;";default:throw new Error(`BinaryType ${e} is not implemented!`)}}var U;!function(e){e[e.ABS=0]="ABS",e[e.ACOS=1]="ACOS",e[e.ACOSH=2]="ACOSH",e[e.ASIN=3]="ASIN",e[e.ASINH=4]="ASINH",e[e.ATAN=5]="ATAN",e[e.ATANH=6]="ATANH",e[e.CEIL=7]="CEIL",e[e.COS=8]="COS",e[e.COSH=9]="COSH",e[e.ELU=10]="ELU",e[e.ERF=11]="ERF",e[e.EXP=12]="EXP",e[e.EXPM1=13]="EXPM1",e[e.FLOOR=14]="FLOOR",e[e.IS_FINITE=15]="IS_FINITE",e[e.IS_INF=16]="IS_INF",e[e.IS_NAN=17]="IS_NAN",e[e.LINEAR=18]="LINEAR",e[e.LOG=19]="LOG",e[e.LOG1P=20]="LOG1P",e[e.LOGICAL_NOT=21]="LOGICAL_NOT",e[e.NEG=22]="NEG",e[e.RELU=23]="RELU",e[e.RELU6=24]="RELU6",e[e.LEAKYRELU=25]="LEAKYRELU",e[e.RECIPROCAL=26]="RECIPROCAL",e[e.ROUND=27]="ROUND",e[e.RSQRT=28]="RSQRT",e[e.SELU=29]="SELU",e[e.SIGMOID=30]="SIGMOID",e[e.SIGN=31]="SIGN",e[e.SIN=32]="SIN",e[e.SINH=33]="SINH",e[e.SOFTPLUS=34]="SOFTPLUS",e[e.SQRT=35]="SQRT",e[e.SQUARE=36]="SQUARE",e[e.STEP=37]="STEP",e[e.TAN=38]="TAN",e[e.TANH=39]="TANH",e[e.TO_INT=40]="TO_INT"}(U||(U={}));const M=`\n  // Error function is calculated approximately with elementary function.\n  // See "Handbook of Mathematical Functions with Formulas,\n  // Graphs, and Mathematical Tables", Abramowitz and Stegun.\n  let p = ${t.backend_util.ERF_P};\n  let a1 = ${t.backend_util.ERF_A1};\n  let a2 = ${t.backend_util.ERF_A2};\n  let a3 = ${t.backend_util.ERF_A3};\n  let a4 = ${t.backend_util.ERF_A4};\n  let a5 = ${t.backend_util.ERF_A5};\n\n  let sign = sign(a);\n  let absA = abs(a);\n  let t = 1.0 / (1.0 + p * absA);\n  return sign * (1.0 - (((((a5 * t + a4) * t) + a3) * t + a2) * t + a1) * t * exp(-absA * absA));\n`,V=`\n  if (a >= 0.0) {\n    return ${t.backend_util.SELU_SCALE} * a;\n  } else {\n    return ${t.backend_util.SELU_SCALEALPHA} * (exp(a) - 1.0);\n  }\n`;function G(e,t){switch(e){case U.ABS:return"return abs(a);";case U.ACOS:return"\n  if (abs(a) > 1.) {\n    return uniforms.NAN;\n  }\n  return acos(a);\n";case U.ACOSH:return"\n  if (a < 1.) {\n    return uniforms.NAN;\n  }\n  return acosh(a);\n";case U.ASIN:return"\n  if (abs(a) > 1.) {\n    return uniforms.NAN;\n  }\n  return asin(a);\n";case U.ASINH:return"return asinh(a);";case U.ATAN:return"\n  if (isnan(a)) {\n    return uniforms.NAN;\n  }\n  return atan(a);\n";case U.ATANH:return"\n  if (abs(a) > 1.) {\n    return uniforms.NAN;\n  }\n  if (a == 1.) {\n    return uniforms.INFINITY;\n  }\n  if (a == -1.) {\n    return -uniforms.INFINITY;\n  }\n  return atanh(a);\n";case U.COS:return"return cos(a);";case U.COSH:return"\n  let e2x = exp(-a);\n  return (e2x + 1.0 / e2x) / 2.0;\n";case U.CEIL:return"return ceil(a);";case U.ELU:return t?"\n  var resFloat = exp(a) - vec4<f32>(1.0);\n  if (a.r >= 0.0) {\n    resFloat.r = a.r;\n  }\n  if (a.g >= 0.0) {\n    resFloat.g = a.g;\n  }\n  if (a.b >= 0.0) {\n    resFloat.b = a.b;\n  }\n  if (a.a >= 0.0) {\n    resFloat.a = a.a;\n  }\n  return resFloat;\n":"if (a >= 0.0) { return a; }  return (exp(a) - 1.0);";case U.ERF:return M;case U.EXP:return"return exp(a);";case U.EXPM1:return"return exp(a) - 1.0;";case U.FLOOR:return"return floor(a);";case U.IS_FINITE:return"return f32(!isnan(a) && !isinf(a));";case U.IS_INF:return"return f32(isinf(a));";case U.IS_NAN:return"return f32(isnan(a));";case U.LINEAR:return"return a;";case U.LOG:return"if (a < 0.0) { return uniforms.NAN; }\n  return log(a);";case U.LOG1P:return"\n  if (isnan(a)) { return a; }\n  return log(1.0 + a);\n";case U.LOGICAL_NOT:return"return f32(!(a >= 1.0));";case U.NEG:return"return -a;";case U.LEAKYRELU:return t?"\n  let aLessThanZero = vec4<f32>(a < vec4<f32>(0.0));\n  return (aLessThanZero * (uniforms.alpha * a)) + ((vec4<f32>(1.0) - aLessThanZero) * a);\n":"if (a < 0.0) { return uniforms.alpha * a; } return a;";case U.RECIPROCAL:return"return 1.0 / a;";case U.RELU:return t?"\n  return select(a, vec4<f32>(0.0), a < vec4<f32>(0.0));\n":"return select(a, 0.0, a < 0.0);";case U.RELU6:return t?"return clamp(a, vec4<f32>(0.0, 0.0, 0.0, 0.0), vec4<f32>(6.0, 6.0, 6.0, 6.0));":"return clamp(a, 0.0, 6.0);";case U.ROUND:return"return round(a);";case U.RSQRT:return"return inverseSqrt(a);";case U.SELU:return V;case U.SIGMOID:return"return 1.0 / (1.0 + exp(-1.0 * a));";case U.SIGN:return"return sign(a);";case U.SIN:return"return sin(a);";case U.SINH:return"\n  let e2x = exp(a);\n  return (e2x - 1.0 / e2x) / 2.0;\n";case U.SOFTPLUS:return"\n  let epsilon = 1.1920928955078125e-7;\n  let threshold = log(epsilon) + 2.0;\n\n  let too_large = a > -threshold;\n  let too_small = a < threshold;\n  let exp_a = exp(a);\n\n  if (too_large) {\n    return a;\n  } else if (too_small) {\n    return exp_a;\n  } else {\n    return log(exp_a + 1.0);\n  }\n";case U.SQRT:return"return sqrt(a);";case U.SQUARE:return"return a * a;";case U.STEP:return"\n  if (isnan(a)) {\n    return a;\n  }\n\n  return select(uniforms.stepAlpha, 1.0, a > 0.0);\n";case U.TAN:return"return tan(a);";case U.TANH:return"\n  let e2x = exp(-2.0 * abs(a));\n  return sign(a) * (1.0 - e2x) / (1.0 + e2x);\n";case U.TO_INT:return"return f32(i32((a)));";default:throw new Error(`BinaryType ${e} is not implemented!`)}}function H(e,t=!1,n=!1,i=3){if(null===e)return"";let r="";if("linear"===e)r=G(U.LINEAR);else if("relu"===e)r=G(U.RELU,n);else if("elu"===e)r=G(U.ELU,n);else if("relu6"===e)r=G(U.RELU6,n);else if("prelu"===e)r=O(B.PRELU,n);else if("sigmoid"===e)r=G(U.SIGMOID,n);else{if("leakyrelu"!==e)throw new Error(`Activation ${e} has not been implemented for the WebGPU backend.`);r=G(U.LEAKYRELU,n)}const s=f(n?4:1);let a="";return a=t?`\n      fn activation(a : ${s}, coords : vec${i}<i32>) -> ${s} {\n        let b = getPreluActivationWeightsByOutputCoords(coords);\n        ${r}\n      }`:`\n      fn activation(a : ${s}, coords : vec${i}<i32>) -> ${s} {\n        ${r}\n      }`,a}function X(e,t){return`\n      ${e?"value = value + getBiasByOutputCoords(coords);":""}\n      ${t?"value = activation(value, coords);":""}\n      `}function K(e,n,i=!1,r=!1,s=!1,a=1){t.util.assert(e&&1===a||!e,(()=>`transposeA ${e} is not compatible with component size ${a}`));const o=`\n      ${e?"value = getA(batch, col, row);":"value = getA(batch, row, col);"}\n\n    `,u=n?"value = getB(batch, col, row);":"value = getB(batch, row, col);";return`\n  fn mm_readA(batch: i32, row: i32, colIn: i32) -> ${f(a)} {\n    var value = ${f(a)}(0.0);\n    let col = colIn * ${a};\n    ${i&&s?o:`\n    ${e?"if(row < uniforms.dimAOuter && col < uniforms.dimInner)":"if(row < uniforms.aShape[1] && col < uniforms.aShape[2])"}\n    {\n      ${o}\n    }\n    `}\n    return value;\n  }\n\n  fn mm_readB(batch: i32, row: i32, colIn: i32) -> ${f(a)} {\n    let col = colIn * ${a};\n    var value = ${f(a)}(0.0);\n    ${u}\n    return value;\n  }\n  `}function q(e,t,n,i,r=!1,s=!1,a=!1,o=1){return`\n  ${K(n,i,r,s,a,o)}\n  fn mm_write(batch: i32, row: i32, colIn: i32, valueIn: ${f(o)}) {\n    let col = colIn * ${o};\n    ${r&&s?"":"if (row < uniforms.dimAOuter && col < uniforms.dimBOuter)"}\n    {\n      var value = valueIn;\n      let coords = vec3<i32>(batch, row, col);\n      ${X(e,t)}\n      setOutputAtCoords(coords[0], coords[1], coords[2], value);\n    }\n  }\n  `}function Y(e,n,i=!1,r=32,s=!1,a=32,o=!1){const u=n[1]*e[1],l=n[0]*e[0],d=i?u:r,h=i?r:u,p=d/n[0],c=r/n[1],f=e[1];return t.util.assert((i&&4===p&&4===e[1]||!i&&(3===p||4===p))&&d%n[0]==0&&r%n[1]==0&&4===e[0],(()=>`If transposeA ${i} is true, innerElementSize ${p} and workPerThread[1] ${e[1]} must be 4.\n          Otherwise, innerElementSize ${p} must be 3 or 4.\n      tileAWidth ${d} must be divisible by workgroupSize[0]${n[0]}. tileInner ${r} must be divisible by workgroupSize[1] ${n[1]}. colPerThread ${e[0]} must be 4.`)),`\n  var<workgroup> mm_Asub : array<array<vec${p}<f32>, ${d/p}>, ${h}>;\n  var<workgroup> mm_Bsub : array<array<vec4<f32>, ${l/e[0]}>, ${r}>;\n\n  ${x()} {\n    let localRow = i32(localId.y);\n    let tileRow = localRow * ${f};\n    let tileCol = i32(localId.x);\n\n    let globalRow = i32(globalId.y) * ${f};\n    let globalCol = i32(globalId.x);\n    let batch = ${s?"0":"i32(globalId.z)"};\n    let batchA = ${s||!o?"batch":"batch % uniforms.aShape[0]"};\n    let batchB = ${s||!o?"batch":"batch % uniforms.bShape[0]"};\n    let globalRowStart = i32(workgroupId.y) * ${u};\n\n    let numTiles = ${s?`${Math.ceil(a/r)}`:`(uniforms.dimInner - 1) / ${r} + 1`};\n    var kStart = ${s?`i32(globalId.z) * ${a}`:"0"};\n\n    var acc: array<vec4<f32>, ${f}>;\n\n    // Loop over shared dimension.\n    let tileRowB = localRow * ${c};\n    for (var t = 0; t < numTiles; t++) {\n        // Load one tile of A into local memory.\n        for (var innerRow = 0; innerRow < ${f}; innerRow++) {\n            let inputRow = tileRow + innerRow;\n            let inputCol = tileCol;\n            ${((e,t)=>e?`\n        mm_Asub[inputRow][inputCol] = mm_readA(batchA,\n          kStart + inputRow,\n          globalRowStart / ${t} + inputCol);\n        `:`\n        mm_Asub[inputRow][inputCol] = mm_readA(batchA,\n          globalRow + innerRow,\n          kStart / ${t} + inputCol);\n        `)(i,p)}\n        }\n\n        // Load one tile of B into local memory.\n        for (var innerRow = 0; innerRow < ${c}; innerRow++) {\n            let inputRow = tileRowB + innerRow;\n            let inputCol = tileCol;\n            mm_Bsub[inputRow][inputCol] = mm_readB(batchB, kStart + inputRow, globalCol);\n        }\n        kStart = kStart + ${r};\n        workgroupBarrier();\n\n        // Compute acc values for a single thread.\n        for (var k = 0; k < ${r/p}; k++) {\n            let BCached0 = mm_Bsub[k * ${p}][tileCol];\n            let BCached1 = mm_Bsub[k * ${p} + 1][tileCol];\n            let BCached2 = mm_Bsub[k * ${p} + 2][tileCol];\n            ${3===p?"":`let BCached3 = mm_Bsub[k * ${p} + 3][tileCol];`}\n\n            ${((e,t,n)=>e?`\n        let ACached0 = mm_Asub[k * ${t}][localRow];\n        let ACached1 = mm_Asub[k * ${t} + 1][localRow];\n        let ACached2 = mm_Asub[k * ${t} + 2][localRow];\n        ${3===t?"":`let ACached3 = mm_Asub[k * ${t} + 3][localRow];`}\n        for (var i = 0; i < ${n}; i++) {\n          acc[i] = fma(BCached0, vec4<f32>(ACached0[i]), acc[i]);\n          acc[i] = fma(BCached1, vec4<f32>(ACached1[i]), acc[i]);\n          acc[i] = fma(BCached2, vec4<f32>(ACached2[i]), acc[i]);\n          ${3===t?"":"acc[i] = fma(BCached3, vec4<f32>(ACached3[i]), acc[i]);"}\n        }`:`\n        for (var i = 0; i < ${n}; i++) {\n          let ACached = mm_Asub[tileRow + i][k];\n          acc[i] = fma(BCached0, vec4<f32>(ACached.x), acc[i]);\n          acc[i] = fma(BCached1, vec4<f32>(ACached.y), acc[i]);\n          acc[i] = fma(BCached2, vec4<f32>(ACached.z), acc[i]);\n          ${3===t?"":"acc[i] = fma(BCached3, vec4<f32>(ACached.w), acc[i]);"}\n        }`)(i,p,f)}\n        }\n\n        workgroupBarrier();\n    }\n\n    for (var innerRow = 0; innerRow < ${f}; innerRow++) {\n        mm_write(batch, globalRow + innerRow, globalCol, acc[innerRow]);\n    }\n  }`}const j=e=>e?"\n        mm_Asub[inputRow][inputCol] = mm_readA(batchA,\n          kStart + inputRow,\n          globalRowStart + inputCol);\n        ":"\n        mm_Asub[inputRow][inputCol] = mm_readA(batchA,\n          globalRowStart + inputRow,\n          kStart + inputCol);\n        ";function Q(e,n,i=!1,r=32,s=!1,a=32,o=!1,u=!1){const l=e[1]*n[1],d=e[0]*n[0],h=i?l:r,p=i?r:l;t.util.assert(p%n[1]==0&&h%n[0]==0&&r%n[1]==0,(()=>`tileAHight ${p} must be divisible by workgroupSize[1]${n[1]}, tileAWidth ${h} must be divisible by workgroupSize[0]${n[0]}, tileInner ${r} must be divisible by workgroupSize[1]${n[1]}`));const c=p/n[1],f=h/n[0],m=r/n[1],g=e[1],b=e[0],y=o?`\n      let localRow = i32(localId.y);\n      let localCol = i32(localId.x);\n      let globalRowStart = i32(workgroupId.y) * ${l};\n      let globalColStart = i32(workgroupId.x) * ${d};\n\n      // Loop over shared dimension.\n      for (var t = 0; t < numTiles; t++) {\n        // Load one tile of A into local memory.\n        for (var inputRow = localRow; inputRow < ${p}; inputRow = inputRow + ${n[1]}) {\n          for (var inputCol = localCol; inputCol < ${h}; inputCol = inputCol + ${n[0]}) {\n            ${j(i)}\n          }\n        }\n        // Load one tile of B into local memory.\n        for (var inputRow = localRow; inputRow < ${r}; inputRow = inputRow + ${n[1]}) {\n              for (var inputCol = localCol; inputCol < ${d}; inputCol = inputCol + ${n[0]}) {\n            mm_Bsub[inputRow][inputCol] = mm_readB(batchB,\n              kStart + inputRow,\n              globalColStart + inputCol);\n          }\n        }\n        kStart = kStart + ${r};\n        workgroupBarrier();\n\n        // Compute acc values for a single thread.\n        var BCached : array<f32, ${b}>;\n        for (var k = 0; k < ${r}; k++) {\n          for (var inner = 0; inner < ${b}; inner++) {\n            BCached[inner] = mm_Bsub[k][localCol + inner * ${n[0]}];\n          }\n          for (var innerRow = 0; innerRow < ${g}; innerRow++) {\n            let ACached = ${i?`mm_Asub[k][localRow + innerRow * ${n[1]}];`:`mm_Asub[localRow + innerRow * ${n[1]}][k];`}\n            for (var innerCol = 0; innerCol < ${b}; innerCol++) {\n              acc[innerRow][innerCol] =\n                  fma(ACached, BCached[innerCol], acc[innerRow][innerCol]);\n            }\n          }\n        }\n        workgroupBarrier();\n      }\n      for (var innerRow = 0; innerRow < ${g}; innerRow++) {\n        let gRow = globalRowStart + localRow + innerRow * ${n[1]};\n        for (var innerCol = 0; innerCol < ${b}; innerCol++) {\n          let gCol = globalColStart + localCol + innerCol * ${n[0]};\n          mm_write(batch, gRow, gCol, acc[innerRow][innerCol]);\n        }\n      }\n      `:`\n  let tileRow = i32(localId.y) * ${g};\n  let tileCol = i32(localId.x) * ${b};\n\n  let globalRow = i32(globalId.y) * ${g};\n  let globalCol = i32(globalId.x) * ${b};\n  let globalRowStart = i32(workgroupId.y) * ${l};\n\n  let tileRowA = i32(localId.y) * ${c};\n  let tileColA = i32(localId.x) * ${f};\n  let tileRowB = i32(localId.y) * ${m};\n  // Loop over shared dimension.\n  for (var t = 0; t < numTiles; t++) {\n    // Load one tile of A into local memory.\n    for (var innerRow = 0; innerRow < ${c}; innerRow++) {\n      for (var innerCol = 0; innerCol < ${f}; innerCol++) {\n        let inputRow = tileRowA + innerRow;\n        let inputCol = tileColA + innerCol;\n        ${j(i)}\n      }\n    }\n\n    // Load one tile of B into local memory.\n    for (var innerRow = 0; innerRow < ${m}; innerRow++) {\n      for (var innerCol = 0; innerCol < ${b}; innerCol++) {\n        let inputRow = tileRowB + innerRow;\n        let inputCol = tileCol + innerCol;\n        mm_Bsub[inputRow][inputCol] = mm_readB(batchB,\n          kStart + inputRow,\n          globalCol + innerCol);\n      }\n    }\n    kStart = kStart + ${r};\n    workgroupBarrier();\n\n    // Compute acc values for a single thread.\n    var BCached : array<f32, ${b}>;\n    for (var k = 0; k < ${r}; k++) {\n      for (var inner = 0; inner < ${b}; inner++) {\n        BCached[inner] = mm_Bsub[k][tileCol + inner];\n      }\n\n      for (var innerRow = 0; innerRow < ${g}; innerRow++) {\n        ${(e=>e?"let ACached = mm_Asub[k][tileRow + innerRow];":"let ACached = mm_Asub[tileRow + innerRow][k];")(i)}\n        for (var innerCol = 0; innerCol < ${b}; innerCol++) {\n          acc[innerRow][innerCol] =\n              fma(ACached, BCached[innerCol], acc[innerRow][innerCol]);\n        }\n      }\n    }\n\n    workgroupBarrier();\n  }\n\n  for (var innerRow = 0; innerRow < ${g}; innerRow++) {\n    for (var innerCol = 0; innerCol < ${b}; innerCol++) {\n      mm_write(batch, globalRow + innerRow, globalCol + innerCol,\n          acc[innerRow][innerCol]);\n    }\n  }\n  `;return`\n    var<workgroup> mm_Asub : array<array<f32, ${h}>, ${p}>;\n    var<workgroup> mm_Bsub : array<array<f32, ${d}>, ${r}>;\n\n    ${x()} {\n      let batch = ${s?"0":"i32(globalId.z)"};\n      let batchA = ${s||!u?"batch":"batch % uniforms.aShape[0]"};\n      let batchB = ${s||!u?"batch":"batch % uniforms.bShape[0]"};\n      let numTiles = ${s?`${Math.ceil(a/r)}`:`(uniforms.dimInner - 1) / ${r} + 1`};\n      var kStart = ${s?`i32(globalId.z) * ${a}`:"0"};\n\n      var acc : array<array<f32, ${b}>, ${g}>;\n\n      // Without this initialization strange values show up in acc.\n      for (var innerRow = 0; innerRow < ${g}; innerRow++) {\n        for (var innerCol = 0; innerCol < ${b}; innerCol++) {\n          acc[innerRow][innerCol] = 0.0;\n        }\n      }\n      ${y}\n    }\n  `}class Z{constructor(e,t,n=!1,i=!1,r=null,s=null,a=null,o=!1){this.variableNames=["A","B"],this.uniforms="dimAOuter : i32, dimBOuter : i32, dimInner : i32,",this.outputShape=t,this.dispatchLayout={x:[2],y:[1],z:[0]};const u=n?e[1]:e[2];if(this.isVec4=(u%4==0&&!n||t[1]%4==0&&n)&&t[2]%4==0&&!i,this.outputComponent=this.isVec4?4:1,this.isVectorA=1===t[1]&&!n,!this.isVec4&&this.isVectorA)this.elementsPerThread=[1,1,1],this.workgroupSize=[32,1,1];else{const e=P(t[1],u,t[2],n);this.workgroupSize=e.workgroupSize,this.elementsPerThread=e.elementsPerThread}this.dispatch=$(this.dispatchLayout,this.outputShape,this.workgroupSize,this.elementsPerThread);const l=null!=r,d=null!=a;l&&this.variableNames.push("bias"),d&&this.variableNames.push("preluActivationWeights"),this.sequentialAccessByThreads=o,this.transposeA=n,this.transposeB=i,this.addBias=l,this.activation=s,this.hasPreluActivationWeights=d,[this.fitAOuter,this.fitBOuter,this.fitInner]=this.getShapeFit(t[1],t[2],u),this.shaderKey=`matMulPacked_${this.elementsPerThread}_${n}_${i}_${this.activation}_${this.fitAOuter}_${this.fitBOuter}_${this.fitInner}_${this.isVec4}_${this.isVectorA}_${this.sequentialAccessByThreads}`}getShapeFit(e,t,n){const i=this.workgroupSize[1]*this.elementsPerThread[1],r=this.workgroupSize[0]*this.elementsPerThread[0];!this.isVec4&&this.isVectorA?this.tileInner=4*this.workgroupSize[0]:this.tileInner=r;return[e%i==0,t%r==0,n%this.tileInner==0]}getUserCode(){const e=`\n      ${H(this.activation,this.hasPreluActivationWeights,this.isVec4)}\n      ${q(this.addBias,this.activation,!1,this.transposeB,this.fitAOuter,this.fitBOuter,this.fitInner,this.isVec4?4:1)}\n      ${this.isVec4?Y(this.elementsPerThread,this.workgroupSize,this.transposeA,this.tileInner,!1,null,!0):this.isVectorA?function(e,n=!1){t.util.assert(1===e[1]&&1===e[2],(()=>`A linear work group size is required. But got ${e}.`));const i=4*e[0];return`\n    var<workgroup> mm_Asub : array<vec4<f32>, ${e[0]}>;\n\n    ${x()} {\n      let tileCol = i32(localId.x);\n      let globalCol = i32(globalId.x);\n      let globalRow = i32(globalId.y);\n\n      let numTiles = (uniforms.dimInner - 1) / ${i} + 1;\n      let batch = i32(globalId.z);\n      let batchA = batch % uniforms.aShape[0];\n      let batchB = batch % uniforms.bShape[0];\n      // Without this initialization strange values show up in acc.\n      var acc = 0.0;\n\n      // Loop over shared dimension.\n      for (var t = 0; t < numTiles; t++) {\n        // Load one tile of A into local memory.\n        let colA = t * ${i} + tileCol * 4;\n        mm_Asub[tileCol] = vec4<f32>(${(e=>e?"\n      mm_readA(batchA, colA, globalRow),\n      mm_readA(batchA, colA + 1, globalRow),\n      mm_readA(batchA, colA + 2, globalRow),\n      mm_readA(batchA, colA + 3, globalRow)\n  ":"\n      mm_readA(batchA, globalRow, colA),\n      mm_readA(batchA, globalRow, colA + 1),\n      mm_readA(batchA, globalRow, colA + 2),\n      mm_readA(batchA, globalRow, colA + 3)\n  ")(n)});\n        workgroupBarrier();\n\n        // Compute acc values for a single thread.\n        for (var k = 0; k < ${i/4}; k++) {\n          let rowB = t * ${i} + k * 4;\n          let BCached = vec4<f32>(mm_readB(batchB, rowB, globalCol),\n                              mm_readB(batchB, rowB + 1, globalCol),\n                              mm_readB(batchB, rowB + 2, globalCol),\n                              mm_readB(batchB, rowB + 3, globalCol));\n\n          let ACached = mm_Asub[k];\n          acc = acc + dot(ACached, BCached);\n        }\n\n        workgroupBarrier();\n      }\n\n      mm_write(batch, globalRow, globalCol, acc);\n    }\n  `}(this.workgroupSize,this.transposeA):Q(this.elementsPerThread,this.workgroupSize,this.transposeA,this.tileInner,!1,null,this.sequentialAccessByThreads,!0)}\n    `;return e}}class J{constructor(e,t=!1,n=!1,i=null,r=null,s=null){this.variableNames=["A","B"],this.uniforms="dimAOuter : i32, dimBOuter : i32, dimInner : i32,",this.workgroupSize=[256,1,1],this.outputShape=e,this.dispatchLayout={x:[],y:[1,2],z:[0]},this.dispatch=$(this.dispatchLayout,this.outputShape,this.workgroupSize);const a=null!=i,o=null!=s;a&&this.variableNames.push("bias"),o&&this.variableNames.push("preluActivationWeights"),this.transposeA=t,this.transposeB=n,this.addBias=a,this.activation=r,this.hasPreluActivationWeights=o,this.shaderKey=`matMulReduce_${this.activation}_${t}_${n}`}getUserCode(){var e;return`\n      ${H(this.activation,this.hasPreluActivationWeights)}\n      ${q(this.addBias,this.activation,this.transposeA,this.transposeB)}\n      ${e=this.workgroupSize[0],`\n    var<workgroup> sumValues : array<f32, ${e}>;\n    ${x()} {\n      let coords = getOutputCoords();\n      let batch = coords[0];\n      let batchA = batch % uniforms.aShape[0];\n      let batchB = batch % uniforms.bShape[0];\n      let row = coords[1];\n      let col = coords[2];\n      var sum = 0.0;\n      let Length = uniforms.dimInner;\n      for (var k = i32(localId.x); k < Length; k = k + ${e}) {\n        let dataA = mm_readA(batchA, row, k);\n        let dataB = mm_readB(batchB, k, col);\n        sum = sum + dataA * dataB;\n      }\n      sumValues[localId.x] = sum;\n      workgroupBarrier();\n\n      for(var currentSize = ${e/2}u; currentSize > 1u;\n          currentSize = currentSize / 2u) {\n        if (localId.x < currentSize)\n        {\n          sumValues[localId.x] = sumValues[localId.x] + sumValues[localId.x + currentSize];\n        }\n        workgroupBarrier();\n      }\n\n      if (localId.x == 0u) {\n        sum = sumValues[0] + sumValues[1];\n        mm_write(batch, row, col, sum);\n      }\n    }\n  `}\n    `}}class ee{constructor(e,t,n,i=!1,r=!1,s=null,a=null,o=null){this.variableNames=["A","B"],this.uniforms="dimAOuter : i32, dimBOuter : i32, dimInner : i32,",this.workgroupSize=[16,8,1],this.outputShape=n,this.dispatchLayout={x:[2],y:[1],z:[0]},this.dispatch=[Math.ceil(n[2]/this.workgroupSize[0]),Math.ceil(n[1]/this.workgroupSize[1]),n[0]];const u=null!=s;u&&this.variableNames.push("bias");const l=null!=o;l&&this.variableNames.push("preluActivationWeights"),this.transposeA=i,this.transposeB=r,this.addBias=u,this.activation=a,this.hasPreluActivationWeights=l,this.shaderKey=`matMulSmallOutputSize_${this.activation}_${i}_${r}`}getUserCode(){return`\n      ${H(this.activation,this.hasPreluActivationWeights)}\n      ${q(this.addBias,this.activation,this.transposeA,this.transposeB)}\n      ${function(e){const t=e[1],n=e[0],i=t>n?t:n;return`\n  var<workgroup> mm_Asub : array<array<f32, ${i}>, ${t}>;\n  var<workgroup> mm_Bsub : array<array<f32, ${n}>, ${i}>;\n\n  // If the output size is small for matrix multiplication, avoid to use vec4\n  // and handle some elements per thread to optimally utilize the ALU.\n  // Read data from global memory to registers firstly, then store them into\n  // shared memory, so it is instruction-Level parallelism for arithmetic\n  // operations and others handle IO operations between barrier api, makes ALU\n  // and load/store units work simultaneously, could improves the performance.\n  ${x()} {\n    let tileRow = i32(localId.y);\n    let tileCol = i32(localId.x);\n    let globalRow = i32(globalId.y);\n    let globalCol = i32(globalId.x);\n    let batch = i32(globalId.z);\n    let batchA = batch % uniforms.aShape[0];\n    let batchB = batch % uniforms.bShape[0];\n\n    // uniforms.dimInner should be greater than 0.\n    let numTiles = (uniforms.dimInner - 1) / ${i} + 1;\n    var acc = 0.0;\n\n    var globalColA = tileCol;\n    var globalRowB = 0;\n    var regA = mm_readA(batchA, globalRow, globalColA);\n    var regB0 = mm_readB(batchB, globalRowB + 2 * tileRow, globalCol);\n    var regB1 = mm_readB(batchB, globalRowB + 2 * tileRow + 1, globalCol);\n    globalColA = globalColA + ${i};\n    globalRowB = globalRowB + ${i};\n\n    for (var t = 0; t < numTiles; t = t + 1) {\n      mm_Asub[tileRow][tileCol] = regA;\n      mm_Bsub[2 * tileRow][tileCol] = regB0;\n      mm_Bsub[2 * tileRow + 1][tileCol] = regB1;\n\n      workgroupBarrier();\n\n      regA = mm_readA(batchA, globalRow, globalColA);\n      regB0 = mm_readB(batchB, globalRowB + 2 * tileRow, globalCol);\n      regB1 = mm_readB(batchB, globalRowB + 2 * tileRow + 1, globalCol);\n      globalColA = globalColA + ${i};\n      globalRowB = globalRowB + ${i};\n\n      for (var k = 0; k < ${i}; k = k + 1) {\n        acc = acc + mm_Asub[tileRow][k] * mm_Bsub[k][tileCol];\n      }\n      workgroupBarrier();\n    }\n\n    mm_write(batch, globalRow, globalCol, acc);\n  }\n  `}(this.workgroupSize)}\n    `}}class te{constructor(e,n,i=!1,r=!1){this.variableNames=["A","B"],this.uniforms="dimAOuter : i32, dimBOuter : i32, dimInner : i32,",this.workgroupSize=[8,8,1],this.atomic=!0,this.splitedDimInner=128,t.util.assert(1===e[0],(()=>"MatMulSplitKProgram only supports batch = 1.")),this.outputShape=e,this.dispatchLayout={x:[2],y:[1],z:[0,3]};const s=(i&&this.outputShape[1]%4==0||!i&&n%4==0)&&this.outputShape[2]%4==0;this.elementsPerThread=[4,4,this.splitedDimInner],this.outputComponent=s?4:1,s||(this.outputShape[1]<16&&(this.elementsPerThread[1]=1),this.outputShape[2]<16&&(this.elementsPerThread[0]=1)),this.dispatch=$(this.dispatchLayout,[this.outputShape[0],this.outputShape[1],this.outputShape[2],n],this.workgroupSize,this.elementsPerThread),this.transposeA=i,this.transposeB=r,this.shaderKey=`matMulSplitK_${i}_${r}_${this.elementsPerThread}_${this.outputComponent}`}getUserCode(){const e=this.outputComponent;return`\n      ${K(!1,this.transposeB,!1,!1,!1,e)}\n      fn mm_write(batch: i32, row : i32, colIn : i32, value : ${f(e)}) {\n        let col = colIn * ${e};\n        if (row < uniforms.dimAOuter && col < uniforms.dimBOuter) {\n          let coords = vec3<i32>(batch, row, col);\n          let flatIndex = getOutputIndexFromCoords(coords);\n          // The problem is that we should initialize output to zero before using.\n          // Otherwise, the original value will be added to the result.\n          for (var i = 0; i < ${e}; i = i + 1) {\n            ${p("&result[flatIndex + i]",""+(e>1?"value[i]":"value"),"float32")}\n          }\n        }\n      }\n      ${4===e?Y(this.elementsPerThread,this.workgroupSize,this.transposeA,32,!0,this.splitedDimInner):Q(this.elementsPerThread,this.workgroupSize,this.transposeA,32,!0,this.splitedDimInner)}\n    `}}class ne{constructor(e,t=null,n=null,i=null){this.uniforms="",this.variableNames=["x"],this.workgroupSize=[64,1,1],this.size=!0,this.outputShape=e,this.dispatchLayout=N(this.outputShape),this.dispatch=$(this.dispatchLayout,this.outputShape,this.workgroupSize),this.addBias=null!=t,this.hasPreluActivationWeights=null!=i,this.activation=n,this.addBias&&this.variableNames.push("bias"),this.hasPreluActivationWeights&&this.variableNames.push("preluActivationWeights"),this.shaderKey=`biasActivation_${n}`}getUserCode(){return`\n    ${H(this.activation,this.hasPreluActivationWeights)}\n    ${x("index")} {\n      if (index < uniforms.size) {\n        let coords = getCoordsFromIndex(index);\n        var value = getXByOutputIndex(index);\n        ${X(this.addBias,this.activation)}\n        setOutputAtIndex(index, value);\n      }\n    }\n    `}}class ie{constructor(e){this.variableNames=[],this.outputShape=[],this.uniforms="value : f32,",this.workgroupSize=[64,1,1],this.size=!0,this.outputShape=e,this.dispatchLayout=N(this.outputShape),this.dispatch=$(this.dispatchLayout,this.outputShape,this.workgroupSize),this.shaderKey="fill"}getUserCode(){return`\n    ${x("index")} {\n      if (index < uniforms.size) {\n        setOutputAtIndex(index, uniforms.value);\n      }\n    }\n  `}}function re(e){const{backend:n,attrs:i}=e,{shape:r,value:s}=i;let{dtype:a}=i;if(a=a||t.util.inferDtype(s),"string"===a){const e=t.util.getArrayFromDType(a,t.util.sizeFromShape(r));return e.fill(s),n.makeTensorInfo(r,a,e)}{const e=new ie(r),t=[{type:"float32",data:[s]}];return n.runWebGPUProgram(e,[],a,t)}}const se={kernelName:t.Fill,backendName:"webgpu",kernelFunc:re};function ae(e){const{inputs:n,attrs:i}=e,{x:r}=n,{shape:s}=i,a=t.util.sizeFromShape(r.shape),o=t.util.inferFromImplicitShape(s,a),u=t.util.sizeFromShape(o);return t.util.assert(a===u,(()=>`The new shape (${o}) has ${u} elements and the old shape (${r.shape}) has ${a} elements. The new shape and old shape must have the same number of elements.`)),e.backend.incRef(r.dataId),{dataId:r.dataId,shape:o,dtype:r.dtype}}const oe={kernelName:t.Reshape,backendName:"webgpu",kernelFunc:ae};function ue({a:e,b:n,transposeA:i,transposeB:r,backend:s,bias:a=null,preluActivationWeights:o=null,leakyreluAlpha:u=0,activation:l=null}){const d=e.shape.length,h=n.shape.length,p=i?e.shape[d-2]:e.shape[d-1],c=r?n.shape[h-1]:n.shape[h-2],f=i?e.shape[d-1]:e.shape[d-2],m=r?n.shape[h-2]:n.shape[h-1],g=e.shape.slice(0,-2),x=n.shape.slice(0,-2),b=t.util.sizeFromShape(g),y=t.util.sizeFromShape(x),w=t.broadcast_util.assertAndGetBroadcastShape(e.shape.slice(0,-2),n.shape.slice(0,-2)).concat([f,m]);t.util.assert(p===c,(()=>`Error in matMul: inner shapes (${p}) and (${c}) of Tensors with shapes ${e.shape} and ${n.shape} and transposeA=${i} and transposeB=${r} must match.`));const C=i?[b,p,f]:[b,f,p],k=r?[y,m,c]:[y,c,m],S=ae({inputs:{x:e},backend:s,attrs:{shape:C}}),v=ae({inputs:{x:n},backend:s,attrs:{shape:k}}),I=[S,v],R=Math.max(b,y),$=[S,v],P=[{type:"int32",data:[f]},{type:"int32",data:[m]},{type:"int32",data:[p]}];let A,z;const N=[R,f,m];let D=t.env().get("WEBGPU_MATMUL_PROGRAM_TYPE");if(D<0){const e=t.env().getNumber("WEBGPU_THRESHOLD_TO_INCREASE_WORKGROUPS_FOR_MATMUL"),n=e>0?e:s.thresholdToIncreaseWorkgroups,i=R*Math.ceil(f/32)*Math.ceil(m/32);D=i<=n||f<=8&&i<=2*n?R*f*m<=128?_.MatMulReduceProgram:1===R&&c>=2e3?_.MatMulSplitKProgram:_.MatMulSmallOutputSizeProgram:_.MatMulPackedProgram}switch(D){case _.MatMulReduceProgram:A=new J(N,i,r,a,l,o);break;case _.MatMulSplitKProgram:if(z=re({backend:s,attrs:{shape:N,value:0,dtype:e.dtype}}),A=new te(N,c,i,r),a||l){z=s.runWebGPUProgram(A,$,e.dtype,P,z);const t=new ne(z.shape,a,l,o);let n=null;const i=[z];a&&i.push(a),o&&i.push(o),"leakyrelu"===l&&(n=[{type:"float32",data:[u]}],t.uniforms+=" alpha : f32,");const r=s.runWebGPUProgram(t,i,z.dtype,n);I.push(z);const d=ae({inputs:{x:r},backend:s,attrs:{shape:w}});I.push(r);for(const e of I)s.disposeData(e.dataId);return d}break;case _.MatMulSmallOutputSizeProgram:A=new ee(C,k,N,i,r,a,l,o);break;case _.MatMulPackedProgram:const t=s.adapterInfo.isIntel();A=new Z(C,N,i,r,a,l,o,t);break;default:throw new Error(`Unsupported MatMulProgramType ${D}.`)}a&&$.push(a),o&&$.push(o),"leakyrelu"===l&&(P.push({type:"float32",data:[u]}),A.uniforms+=" alpha : f32,"),z=s.runWebGPUProgram(A,$,e.dtype,P,z);const T=ae({inputs:{x:z},backend:s,attrs:{shape:w}});I.push(z);for(const e of I)s.disposeData(e.dataId);return T}const le={kernelName:t._FusedMatMul,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:n,attrs:i}=e,{a:r,b:s,bias:a,preluActivationWeights:o}=t,{transposeA:u,transposeB:l,activation:d,leakyreluAlpha:h}=i;return ue({a:r,b:s,transposeA:u,transposeB:l,backend:n,bias:a,preluActivationWeights:o,leakyreluAlpha:h,activation:d})}};class de{constructor(e,n,i){this.variableNames=["AReal","AImag","BReal","BImag"],this.workgroupSize=[128,1,1],this.size=!0,this.outputShape=t.backend_util.assertAndGetBroadcastShape(n,i),this.dispatchLayout=N(this.outputShape),this.dispatch=$(this.dispatchLayout,this.outputShape,this.workgroupSize),this.shaderKey=`binaryOpComplex_${e}`,this.op=e}getUserCode(){return`\n      fn binaryOpComplex(\n          areal : f32, aimag : f32, breal : f32, bimag : f32) -> f32 {\n        ${O(this.op,!1)}\n      }\n\n      ${x("index")} {\n        if(index < uniforms.size) {\n          let areal = getARealByOutputIndex(index);\n          let aimag = getAImagByOutputIndex(index);\n          let breal = getBRealByOutputIndex(index);\n          let bimag = getBImagByOutputIndex(index);\n          setOutputAtIndex(index, binaryOpComplex(areal, aimag, breal, bimag));\n        }\n      }\n    `}}class he{constructor(e,n,i){if(this.size=!0,this.variableNames=["A","B"],this.outputShape=t.backend_util.assertAndGetBroadcastShape(n,i),this.dispatchLayout=N(this.outputShape),this.op=e,this.useSharedMemoryWithA=n.length<=1&&i.length>1&&n[0]<128,this.useSharedMemoryWithB=i.length<=1&&n.length>1&&i[0]<128,this.useSharedMemoryWithA||this.useSharedMemoryWithB)this.outputComponent=1,this.variableComponents=[1,1],this.lastDimensionSize=this.useSharedMemoryWithB?i[0]:n[0],this.shaderKey=`binary_${e}_${this.lastDimensionSize}`,this.type="shared",this.workgroupSize=[256,1,1];else{const r=n.length>0&&n[n.length-1]%4==0,s=i.length>0&&i[i.length-1]%4==0;r&&s?(this.outputComponent=4,this.variableComponents=[4,4]):r&&(t.util.isScalarShape(i)||1===i[i.length-1])||s&&(t.util.isScalarShape(n)||1===n[n.length-1])?(this.outputComponent=4,this.variableComponents=r?[4,1]:[1,4]):(this.outputComponent=1,this.variableComponents=[1,1]),this.type="nonshared",this.shaderKey=`binary_${e}_${this.variableComponents}`,this.workgroupSize=[128,1,1]}this.dispatch=$(this.dispatchLayout,this.outputShape,this.workgroupSize,[this.outputComponent,1,1])}getUserCode(){let e;const t=4===this.outputComponent?"vec4<f32>":"f32",n=`\n    fn binaryOperation(a : ${t}, b : ${t}) -> ${t} {\n      ${O(this.op,4===this.outputComponent)}\n    };\n    `;if("shared"===this.type){const t=this.lastDimensionSize>1?`coords[${this.outputShape.length-1}]`:"0",i=this.useSharedMemoryWithB?`let a = getAByOutputIndex(index);\n          let b = sharedBuf[${t}];`:`let a = sharedBuf[${t}];\n          let b = getBByOutputIndex(index);`;e=`\n        ${n}\n        var<workgroup> sharedBuf : array<f32, ${this.lastDimensionSize}>;\n        ${x("index")} {\n          // Fill in the shared memory buffer.\n          let localIndex = i32(localId.x);\n          if(localIndex < ${this.lastDimensionSize}) {\n            sharedBuf[localIndex] = f32(${this.useSharedMemoryWithB?"B":"A"}[localIndex]);\n          }\n          workgroupBarrier();\n\n          if(index < uniforms.size) {\n            let coords = getCoordsFromIndex(index);\n            ${i}\n            setOutputAtIndex(index, binaryOperation(a, b));\n          }\n        }\n        `}else e=`\n       ${n}\n       ${x("index")} {\n         if (index < uniforms.size) {\n           let coords = getCoordsFromIndex(index * ${this.outputComponent});\n           let a = ${t}(getAByOutputCoords(coords));\n           let b = ${t}(getBByOutputCoords(coords));\n           setOutputAtIndex(index, binaryOperation(a, b));\n         }\n       }\n       `;return e}}function pe(e){const{inputs:t}=e,{x:n}=t;return e.backend.incRef(n.dataId),{dataId:n.dataId,shape:n.shape,dtype:n.dtype}}const ce={kernelName:t.Identity,backendName:"webgpu",kernelFunc:pe};function fe(e){const{inputs:t,backend:n}=e,{real:i,imag:r}=t,s=n.makeTensorInfo(i.shape,"complex64"),a=n.tensorMap.get(s.dataId),o=pe({inputs:{x:i},backend:n}),u=pe({inputs:{x:r},backend:n});return a.complexTensorInfos={real:o,imag:u},s}const me={kernelName:t.Complex,backendName:"webgpu",kernelFunc:fe};class ge{constructor(e,t,n=""){this.variableNames=["A"],this.size=!0;this.workgroupSize=[128,1,1],this.outputShape=e,this.dispatchLayout=N(this.outputShape),this.dispatch=$(this.dispatchLayout,this.outputShape,this.workgroupSize),this.op=t,""!==n&&(this.uniforms=n),this.shaderKey=`unary_${t}`}getUserCode(){return`\n      fn unaryOperation(a : f32) -> f32 {\n        ${G(this.op,!1)}\n      }\n      ${x("index")} {\n        if (index < uniforms.size) {\n          let a = getAByOutputIndex(index);\n          setOutputAtIndex(index, unaryOperation(a));\n        }\n      }\n      `}}function xe({opType:e,cpuKernelImpl:t,dtype:n}){return({inputs:i,backend:r})=>{const{x:s}=i,a=r,o=n||s.dtype;if(a.shouldExecuteOnCPU([s])&&null!=t){const e=a.tensorMap.get(s.dataId),n=t(e.values,o);return a.makeTensorInfo(s.shape,o,n)}const u=new ge(s.shape,e);return a.runWebGPUProgram(u,[s],o)}}function be({opType:e,cpuKernelImpl:n,supportsComplex:i=!1,dtype:r}){return({inputs:s,backend:a})=>{const{a:o,b:u}=s,l=a;if(i&&"complex64"===o.dtype){const n=l.tensorMap.get(o.dataId),i=l.tensorMap.get(u.dataId);let r,s;if(e!==B.MUL)[r,s]=[[n.complexTensorInfos.real,i.complexTensorInfos.real],[n.complexTensorInfos.imag,i.complexTensorInfos.imag]].map((n=>{const[i,r]=n,s={dataId:i.dataId,dtype:i.dtype,shape:o.shape},a={dataId:r.dataId,dtype:r.dtype,shape:u.shape},d=new he(e,o.shape,u.shape);return l.runWebGPUProgram(d,[s,a],t.upcastType(i.dtype,r.dtype))}));else{const e=new de(B.COMPLEX_MULTIPLY_REAL,o.shape,u.shape),t=new de(B.COMPLEX_MULTIPLY_IMAG,o.shape,u.shape),a=[{dataId:n.complexTensorInfos.real.dataId,dtype:n.complexTensorInfos.real.dtype,shape:o.shape},{dataId:n.complexTensorInfos.imag.dataId,dtype:n.complexTensorInfos.imag.dtype,shape:o.shape},{dataId:i.complexTensorInfos.real.dataId,dtype:i.complexTensorInfos.real.dtype,shape:u.shape},{dataId:i.complexTensorInfos.imag.dataId,dtype:i.complexTensorInfos.imag.dtype,shape:u.shape}];r=l.runWebGPUProgram(e,a,"float32"),s=l.runWebGPUProgram(t,a,"float32")}const a=fe({inputs:{real:r,imag:s},backend:l});return l.disposeData(r.dataId),l.disposeData(s.dataId),a}const d=r||t.upcastType(o.dtype,u.dtype);if(("string"===o.dtype||"string"===u.dtype||l.shouldExecuteOnCPU([o,u]))&&null!=n){const e=l.tensorMap.get(o.dataId).values,i=l.tensorMap.get(u.dataId).values,r="string"===o.dtype?t.backend_util.fromUint8ToStringArray(e):e,s="string"===o.dtype?t.backend_util.fromUint8ToStringArray(i):i,[a,h]=n(o.shape,u.shape,r,s,d);return l.makeTensorInfo(h,d,a)}const h=new he(e,o.shape,u.shape);return l.runWebGPUProgram(h,[o,u],d)}}function ye(e){return(n,i,r,s,a)=>{const o=t.backend_util.assertAndGetBroadcastShape(n,i),u=o.length,l=t.util.computeStrides(o),d=t.util.sizeFromShape(o),h=t.util.getTypedArrayFromDType(a,d),p=n.length,c=i.length,f=t.util.computeStrides(n),m=t.util.computeStrides(i),g=t.backend_util.getBroadcastDims(n,o),x=t.backend_util.getBroadcastDims(i,o);if(g.length+x.length===0)for(let t=0;t<h.length;++t)h[t]=e(r[t%r.length],s[t%s.length]);else for(let n=0;n<h.length;++n){const i=t.util.indexToLoc(n,u,l),a=i.slice(-p);g.forEach((e=>a[e]=0));const o=t.util.locToIndex(a,p,f),d=i.slice(-c);x.forEach((e=>d[e]=0));const b=t.util.locToIndex(d,c,m);h[n]=e(r[o],s[b])}return[h,o]}}const we=ye(((e,t)=>e+t));const Ce=ye(((e,t)=>e&t));function ke(e){return(n,i,r)=>{const s=t.util.getArrayFromDType(i,n.length);for(let t=0;t<n.length;++t)s[t]=e(n[t],r);return s}}const Se=ke((e=>Math.ceil(e)));const ve=ye(((e,t)=>e===t?1:0)),Ie=ke((e=>Math.exp(e))),Re=ke((e=>Math.expm1(e))),$e=ke((e=>Math.floor(e))),Pe=ye(((e,t)=>Math.floor(e/t)));const Ae=ye(((e,t)=>e>t?1:0)),ze=ye(((e,t)=>e>=t?1:0)),Ne=ye(((e,t)=>e<t?1:0)),De=ye(((e,t)=>e<=t?1:0));const Te=ke((e=>Math.log(e)));const Fe=ye(((e,t)=>Math.max(e,t))),_e=ye(((e,t)=>Math.min(e,t))),Ee=ye(((e,t)=>e*t));const We=ye(((e,t)=>e!==t?1:0));function Le(e,t,n,i){const r=[];let s=0;const a=t.length-1+n.length,o=new Array(a).fill(null).map((()=>[0]));!function(e,t){for(let n=0;n<e.length;++n){const i=e[n],r=n===e.length-1?t:e[n+1].length;if(0===i.length)throw new Error("Ragged splits may not be empty");if(i[0]<0)throw new Error("Ragged splits must be non-negative");if(i[i.length-1]>r)throw new Error("Ragged splits must not point past values");for(let e=1;e<i.length;++e)if(i[e-1]>i[e])throw new Error("Ragged splits must be sorted in ascending order")}}(n,i);let u=1;for(let e=0;e<t.length-1;++e){u*=t[e];const n=t[e+1];for(let t=1;t<u+1;++t)o[e].push(t*n)}for(let i=0;i<e.length;++i){let a=e[i],u=e[i]+1;for(let e=0;e<n.length;++e){const i=n[e],r=e+t.length-1;if(r>=0){const e=o[r],t=e[e.length-1]-i[a];for(let e=a;e<u;++e)o[r].push(i[e+1]+t)}a=i[a],u=i[u]}u!==a&&(r.push([a,u]),s+=u-a)}return{outSplits:o,valueSlices:r,numValues:s}}function Be(e,t){const n=e.slice(0,t);for(;n.length<t;)n.push(1);for(let i=t;i<e.length;i++)n[t-1]*=e[i];return n}function Oe(e,n,i,r,s){const a=n.slice();a[0]=s;const o=t.util.getArrayFromDType(i,t.util.sizeFromShape(a)),u=e.length;return function(e,t,n,i,r,s){const a=Be(t,2)[1],o=Be(s,2)[1];let u=0;for(const t of n)for(let n=t[0];n<t[1];++n){for(let t=0;t<i;++t)r[u*o+t]=e[n*a+t];++u}}(e,n,r,0===u?0:u/n[0],o,a),[o,a]}const Ue=2147483647;var Me=t.backend_util.RowPartitionType;class Ve{constructor(e,n,i,r,s,a,o,u,l,d){this.shape=e,this.shapeShape=n,this.values=i,this.valuesShape=r,this.valuesDType=s,this.defaultValue=a,this.defaultValueShape=o,this.rowPartitionValues=u,this.rowPartitionValuesShapes=l,this.rowPartitionTypes=t.backend_util.getRowPartitionTypesHelper(d),this.raggedRank=t.backend_util.getRaggedRank(this.rowPartitionTypes)}getRowPartitionTypeByDimension(e){return this.rowPartitionTypes[0]===Me.FIRST_DIM_SIZE?this.rowPartitionTypes[e+1]:this.rowPartitionTypes[e]}getRowPartitionTensor(e){return this.rowPartitionTypes[0]===Me.FIRST_DIM_SIZE?this.rowPartitionValues[e+1]:this.rowPartitionValues[e]}getMaxWidth(e){const t=this.getRowPartitionTensor(e-1);switch(this.getRowPartitionTypeByDimension(e-1)){case Me.VALUE_ROWIDS:return Ve.getMaxWidthValueRowID(t);case Me.ROW_SPLITS:return Ve.getMaxWidthRowSplit(t);default:throw new Error(`Cannot handle partition type ${Me[this.getRowPartitionTypeByDimension(e-1)]}`)}}static getMaxWidthRowSplit(e){const t=e.length;if(0===t||1===t)return 0;let n=0;for(let i=0;i<t-1;++i){const t=e[i+1]-e[i];t>n&&(n=t)}return n}static getMaxWidthValueRowID(e){const t=e.length;if(0===t)return 0;let n=0,i=e[0],r=0;for(let s=1;s<t;++s){const t=e[s];t!==i&&(i=t,r=Math.max(s-n,r),n=s)}return Math.max(t-n,r)}tensorShapeFromTensor(e,t,n=!0){if(0===t.length){if(-1===e[0])return[];throw new Error("The only valid scalar shape tensor is the fully unknown shape specified as -1.")}return He(e,n)}calculateOutputSize(e){const n=this.valuesShape,i=this.defaultValueShape;t.backend_util.validateDefaultValueShape(i,n);const r=this.tensorShapeFromTensor(this.shape,this.shapeShape),s=t.backend_util.combineRaggedTensorToTensorShapes(this.raggedRank,r,n);s[0]<0&&(s[0]=e);for(let e=1;e<=this.raggedRank;++e)s[e]<0&&(s[e]=this.getMaxWidth(e));return s}calculateFirstParentOutputIndex(e,n,i){const r=Math.min(e,i),s=[];let a=0;for(let e=0;e<r;++e,a+=n)s.push(a);for(let t=r;t<e;++t)s.push(-1);return t.util.assert(s.length===e,(()=>"Final length of result must be equal to firstDimension.")),s}calculateOutputIndexRowSplit(e,t,n,i){const r=e.length,s=[];for(let a=0;a<r-1;++a){const r=e[a+1]-e[a];let o=Math.min(i,r),u=t[a];-1===u&&(o=0);for(let e=0;e<o;++e)s.push(u),u+=n;for(let e=0;e<r-o;++e)s.push(-1)}if(r>0&&s.length!==e[r-1])throw new Error("Invalid row split size.");return s}calculateOutputIndexValueRowID(e,t,n,i){const r=e.length,s=[];if(0===r)return[];let a=0,o=e[0];if(o>=t.length)throw new Error(`Got currentValueRowId=${o}, which is not less than ${t.length}`);let u=t[o];s.push(u);for(let l=1;l<r;++l){const r=e[l];if(r===o)u>=0&&(++a,a<i?u+=n:u=-1);else{if(a=0,o=r,r>=t.length)throw new Error(`Got nextValueRowId=${r} which is not less than ${t.length}`);u=t[r]}s.push(u)}if(s.length!==e.length)throw new Error("Invalid row ids.");return s}calculateOutputIndex(e,t,n,i){const r=this.getRowPartitionTensor(e),s=this.getRowPartitionTypeByDimension(e);switch(s){case Me.VALUE_ROWIDS:return this.calculateOutputIndexValueRowID(r,t,n,i);case Me.ROW_SPLITS:if(r.length-1>t.length)throw new Error(`Row partition size is greater than output size: ${r.length-1} > ${t.length}`);return this.calculateOutputIndexRowSplit(r,t,n,i);default:throw new Error(`Unsupported partition type: ${Me[s]}`)}}getFirstDimensionSize(){const e=this.rowPartitionValues[0];if(0===this.rowPartitionTypes.length)throw new Error("No row_partition_types given.");const t=this.rowPartitionTypes[0];switch(t){case Me.FIRST_DIM_SIZE:return e[0];case Me.VALUE_ROWIDS:throw new Error("Cannot handle VALUE_ROWIDS in first dimension.");case Me.ROW_SPLITS:return this.rowPartitionValuesShapes[0][0]-1;default:throw new Error(`Cannot handle type ${Me[t]}`)}}compute(){if(this.rowPartitionValues[0].length<=0)throw new Error("Invalid first partition input. Tensor requires at least one element.");const e=this.getFirstDimensionSize(),n=this.calculateOutputSize(e),i=new Array(this.raggedRank+1);i[i.length-1]=1;for(let e=i.length-2;e>=0;--e)i[e]=i[e+1]*n[e+1];const r=He(n,!1),s=t.util.getArrayFromDType(this.valuesDType,t.util.sizeFromShape(r));if(i[0]*n[0]>0){let t=this.calculateFirstParentOutputIndex(e,i[0],n[0]);for(let e=1;e<=this.raggedRank;++e){t=this.calculateOutputIndex(e-1,t,i[e],n[e])}this.setOutput(this.raggedRank,t,s,r)}return[r,s]}setOutput(e,n,i,r){if(0===i.length)return;const s=this.values,a=i;let o=r.slice();o=o.slice(e+1);const u=t.util.sizeFromShape(o),l=n.length;let d=this.defaultValue;if(d.length!==u&&1!==d.length){const e=this.defaultValueShape;t.tidy((()=>{const n=t.reshape(d,e),i=t.broadcastTo(n,o);d=i.dataSync()}))}let h=0,p=0,c=0;for(let e=0;e<=l;++e){let t=e<l?n[e]:-1;if(t!==c){if(p<c){const e=s.subarray(h*u);Ge(a.subarray(p*u),e,(c-p)*u)}if(e>=l){const e=i.length;t=Math.floor(e/u)}if(t>c)if(1===this.defaultValue.length)a.subarray(c*u,t*u).fill(this.defaultValue[0]),c=t;else for(;t>c;){Ge(a.slice(c*u),d,u),++c}t<0?(h=e+1,p=c):(h=e,p=c,c=p+1)}else++c}}}function Ge(e,t,n){for(let i=0;i<n;i++)e[i]=t[i]}function He(e,t){const n=[];for(let i of e){if(i<0){if(!t)throw new Error(`Dimension ${i} must be >= 0`);if(i<-1)throw new Error(`Dimension ${i} must be >= -1`);i=-1}n.push(i)}return n}const Xe=ke((e=>1/Math.sqrt(e)));const Ke=ke((e=>1/(1+Math.exp(-e))));const qe=ke((e=>Math.sqrt(e))),Ye=ye(((e,t)=>{const n=e-t;return n*n})),je=ke(((e,t)=>{const{pattern:n,replaceGlobal:i,rewrite:r}=t;return e.replace(new RegExp(n,i?"g":""),r)}));class Qe{constructor(e,n,i,r,s,a){this.separator=t.util.encodeString(e),this.nGramWidths=n,this.leftPad=t.util.encodeString(i),this.rightPad=t.util.encodeString(r),this.padWidth=s,this.preserveShort=a}getPadWidth(e){return Math.min(this.padWidth<0?e-1:this.padWidth,e-1)}getNumNGrams(e,t){const n=this.getPadWidth(t);return Math.max(0,e+2*n-t+1)}createNGrams(e,t,n,i,r,s){for(let a=0;a<r;++a){const o=this.getPadWidth(s),u=Math.max(0,o-a),l=Math.max(0,o-(r-(a+1))),d=s-(u+l),h=t+(u>0?0:a-o);let p=0;p+=u*this.leftPad.length;for(let t=0;t<d;++t)p+=e[h+t].length;p+=l*this.rightPad.length;p+=(u+l+d-1)*this.separator.length,n[i+a]=new Uint8Array(p);const c=n[i+a];let f=0;const m=e=>e.forEach((e=>c[f++]=e));for(let e=0;e<u;++e)m(this.leftPad),m(this.separator);for(let t=0;t<d-1;++t)m(e[h+t]),m(this.separator);if(d>0){m(e[h+d-1]);for(let e=0;e<l;++e)m(this.separator),m(this.rightPad)}else{for(let e=0;e<l-1;++e)m(this.rightPad),m(this.separator);m(this.rightPad)}}}compute(e,n){const i=e.length,r=n.length;if(r>0){let e=n[0];if(0!==e)throw new Error(`First split value must be 0, got ${e}`);for(let t=1;t<r;++t){let r=n[t]>=e;if(r=r&&n[t]<=i,!r)throw new Error(`Invalid split value ${n[t]}, must be in [${e}, ${i}]`);e=n[t]}if(e!==i)throw new Error(`Last split value must be data size. Expected ${i}, got ${e}`)}const s=r-1,a=t.util.getArrayFromDType("int32",r);if(0===i||0===r){const e=new Array(i);for(let e=0;e<=s;++e)a[e]=0;return[e,a]}a[0]=0;for(let e=1;e<=s;++e){const t=n[e]-n[e-1];let i=0;this.nGramWidths.forEach((e=>{i+=this.getNumNGrams(t,e)})),this.preserveShort&&t>0&&0===i&&(i=1),a[e]=a[e-1]+i}const o=new Array(a[s]);for(let t=0;t<s;++t){const i=n[t];let r=a[t];if(this.nGramWidths.forEach((s=>{const a=n[t+1]-n[t],u=this.getNumNGrams(a,s);this.createNGrams(e,i,o,r,u,s),r+=u})),this.preserveShort&&r===a[t]){const s=n[t+1]-n[t];if(0===s)continue;const a=s+2*this.padWidth,u=1;this.createNGrams(e,i,o,r,u,a)}}return[o,a]}}function Ze(e,t,n,i){if(!e.length)return;if(0===t.length){for(let t=0;t<e.length;++t)i.push(e.subarray(t,t+1));return}if(1===t.length){const r=t[0];let s=e.indexOf(r);for(;-1!==s;){const t=e.subarray(0,s);n&&0===t.length||i.push(t),s=(e=e.subarray(s+1)).indexOf(r)}return void(n&&0===e.length||i.push(e))}let r=0;for(let s=0;s<e.length+1;s++)if(s===e.length||-1!==t.indexOf(e[s])){const t=e.subarray(r,s);n&&0===t.length||i.push(t),r=s+1}}const Je=ye(((e,t)=>e-t));const et=(e,t)=>{const n=t.value-e.value;return 0===n?e.index-t.index:n};function tt(e,n,i=0,r=e.length-1){for(;r>i;){if(r-i>600){const t=r-i+1,s=n-i+1,a=Math.log(t),o=.5*Math.exp(2*a/3),u=.5*Math.sqrt(a*o*(t-o)/t)*Math.sign(s-t/2);tt(e,n,Math.max(i,Math.floor(n-s*o/t+u)),Math.min(r,Math.floor(n+(t-s)*o/t+u)))}const s=e[n];let a=i,o=r;for(t.util.swap(e,i,n),et(e[r],s)>0&&t.util.swap(e,i,r);a<o;){for(t.util.swap(e,a,o),a++,o--;et(e[a],s)<0;)a+=1;for(;et(e[o],s)>0;)o-=1}0===et(e[i],s)?t.util.swap(e,i,o):(o+=1,t.util.swap(e,o,r)),o<=n&&(i=o+1),n<=o&&(r=o-1)}}var nt={__proto__:null,addImpl:we,bincountImpl:function(e,n,i,r,s){const a=t.util.sizeFromShape(r),o=t.util.makeZerosTypedArray(s,i);for(let t=0;t<e.length;t++){const i=e[t];if(i<0)throw new Error("Input x must be non-negative!");i>=s||(o[i]+=a>0?n[t]:1)}return o},bincountReduceImpl:function(e,n,i,r=!1){const s=e.shape[0],a=e.shape[1],o=t.buffer([s,i],n.dtype);for(let t=0;t<s;t++)for(let s=0;s<a;s++){const a=e.get(t,s);if(a<0)throw new Error("Input x must be non-negative!");a>=i||(r?o.set(1,t,a):n.size>0?o.set(o.get(t,a)+n.get(t,s),t,a):o.set(o.get(t,a)+1,t,a))}return o},bitwiseAndImpl:Ce,castImpl:function(e,n,i,r){if("int32"===r){return[n,"int32",Int32Array.from(e)]}if("bool"===r){const r=t.util.toTypedArray([0],i),[s,a]=ye(((e,t)=>e!==t?1:0))(n,[],e,r,"bool");return[a,"bool",s]}throw new Error(`Error in Cast: failed to cast ${i} to ${r}`)},ceilImpl:Se,concatImpl:function(e,n,i,r){const s=t.util.getArrayFromDType(i,t.util.sizeFromShape(n));if(r&&"string"!==i){let n=0;e.forEach((e=>{const i=t.util.sizeFromShape(e.shape);s.set(e.vals,n),n+=i}))}else{let r=0;e.forEach((e=>{const a="string"===i?t.backend_util.fromUint8ToStringArray(e.vals):e.vals;let o=0;for(let t=0;t<e.shape[0];++t){const i=t*n[1]+r;for(let t=0;t<e.shape[1];++t)s[i+t]=a[o++]}r+=e.shape[1]}))}return s},equalImpl:ve,expImpl:Ie,expm1Impl:Re,floorDivImpl:Pe,floorImpl:$e,gatherNdImpl:function(e,n,i,r,s,a,o,u,l){const d=t.buffer([r,a],i);for(let t=0;t<r;t++){const i=[];let r=0;for(let n=0;n<s;n++){const a=e[t*s+n];r+=a*o[n],i.push(a)}if(r<0||r>=l/a)throw new Error(`Invalid indices: ${i} does not index into ${u}`);for(let e=0;e<a;e++)d.values[t*a+e]=n.get(...n.indexToLoc(r*a+e))}return d},gatherV2Impl:function(e,n,i){const r=t.buffer(i,e.dtype);for(let t=0;t<r.size;++t){const i=r.indexToLoc(t).slice(),s=i[0],a=i[2],o=n.locToIndex([s,a]);i[2]=n.values[o];const u=e.locToIndex(i);0<=u&&u<e.values.length&&(r.values[t]=e.values[u])}return r},greaterEqualImpl:ze,greaterImpl:Ae,lessEqualImpl:De,lessImpl:Ne,linSpaceImpl:function(e,n,i){const r=(n-e)/(i-1),s=t.util.makeZerosTypedArray(i,"float32");s[0]=e;for(let e=1;e<s.length;e++)s[e]=s[e-1]+r;return s},logImpl:Te,maxImpl:function(e,n,i,r){const s=t.util.getTypedArrayFromDType(r,t.util.sizeFromShape(i));for(let t=0;t<s.length;++t){const i=t*n;let r=e[i];for(let t=0;t<n;++t){const n=e[i+t];(Number.isNaN(n)||n>r)&&(r=n)}s[t]=r}return s},maximumImpl:Fe,minimumImpl:_e,multiplyImpl:Ee,negImpl:function(e,n,i){const r=t.util.createScalarValue(-1,i);return Ee([],n,r,e,i)},notEqualImpl:We,prodImpl:function(e,n,i,r){const[s,a]=t.backend_util.computeOutAndReduceShapes(e,r),o=t.upcastType(n,"int32"),u=t.util.makeZerosTypedArray(t.util.sizeFromShape(s),o),l=t.util.sizeFromShape(a);for(let e=0;e<u.length;++e){const t=e*l;let n=1;for(let e=0;e<l;++e)n*=i[t+e];u[e]=n}return{outVals:u,outShape:s,outDtype:o}},raggedGatherImpl:function(e,n,i,r,s,a,o,u){if(0===e.length)throw new Error("paramsNestedSplits must be non empty");if(0===n[0].length)throw new Error("Split tensors must not be scalars");if(function(e,n,i){e.forEach(((e,r)=>{if(e<0||e>=i){const s=t.util.indexToLoc(r,n.length,t.util.computeStrides(n)).join(",");throw new Error(`indices[${s}] = ${e} is not in [0, ${i})`)}}))}(a,o,n[0][0]-1),0===r.length)throw new Error("params.rank must be nonzero");const l=r[0],{outSplits:d,valueSlices:h,numValues:p}=Le(a,o,e,l),c=function(e){const n=[];for(let i=0;i<e.length;++i){const r=e[i].length,s=t.util.getArrayFromDType("int32",r);n.push(s),e[i].forEach(((e,t)=>s[t]=e))}return n}(d),f=Oe(i,r,s,h,p);return[c,f[0],f[1]]},raggedRangeImpl:function(e,n,i,r,s,a,o){if(n.length>1)throw new Error("starts must be a scalar or vector");if(s.length>1)throw new Error("limits must be a scalar or vector");if(o.length>1)throw new Error("deltas must be a scalar or vector");const u=0===n.length,l=0===s.length,d=0===o.length,h=[];u||h.push(n[0]),l||h.push(s[0]),d||h.push(o[0]);for(let e=1;e<h.length;++e)if(h[e]!==h[e-1])throw new Error("starts, limits, and deltas must have the same shape");const p=0===h.length?1:h[0],c=t.util.getArrayFromDType("int32",p+1);c[0]=0;for(let t=0;t<p;++t){const n=u?e[0]:e[t],i=l?r[0]:r[t],s=d?a[0]:a[t];if(0===s)throw new Error("Requires delta != 0");let o;if(s>0&&i<n||s<0&&i>n)o=0;else if(o=Math.ceil(Math.abs((i-n)/s)),o>Ue)throw new Error("Requires ((limit - start) / delta) <= 2147483647");c[t+1]=c[t]+o}const f=c[p],m=t.util.getArrayFromDType(i,f);let g=0;for(let t=0;t<p;++t){const n=c[t+1]-c[t];let i=u?e[0]:e[t];const r=d?a[0]:a[t];for(let e=0;e<n;++e)m[g++]=i,i+=r}return[c,m]},raggedTensorToTensorImpl:function(e,t,n,i,r,s,a,o,u,l){return new Ve(e,t,n,i,r,s,a,o,u,l).compute()},rangeImpl:function(e,n,i,r){if(e===n||e<n&&i<0||n<e&&i>1)return t.util.makeZerosTypedArray(0,r);const s=Math.abs(Math.ceil((n-e)/i)),a=t.util.makeZerosTypedArray(s,r);n<e&&1===i&&(i=-1),a[0]=e;for(let e=1;e<a.length;e++)a[e]=a[e-1]+i;return a},rsqrtImpl:Xe,scatterImpl:function(e,n,i,r,s,a,o,u,l,d){const h=[r/s,s],p=e.values,c=n.values;if(0===r)return t.buffer(i,n.dtype);const f=l instanceof t.TensorBuffer?l:t.buffer(h,n.dtype);"string"==typeof l||"number"==typeof l?f.values.fill(l):"boolean"==typeof l&&f.values.fill(+l);for(let e=0;e<a;e++){const t=[];let a=0;for(let n=0;n<o;n++){const i=p[e*o+n];t.push(i),a+=i*u[n]}if(a<0||a>=r/s)throw new Error(`Invalid indices: ${t} does not index into ${i}`);for(let t=0;t<s;t++)d?f.values[a*s+t]+=c[e*s+t]:f.values[a*s+t]=0===n.rank?c[0]:c[e*s+t]}return f},sigmoidImpl:Ke,simpleAbsImpl:function(e){const t=new Float32Array(e.length);for(let n=0;n<e.length;++n)t[n]=Math.abs(e[n]);return t},sliceImpl:function(e,n,i,r,s){const a=t.slice_util.isSliceContinous(r,n,i),o=t.util.sizeFromShape(i),u=t.util.computeStrides(r);if(a){const i=t.slice_util.computeFlatOffset(n,u);return"string"===s?e.slice(i,i+o):e.subarray(i,i+o)}const l="string"===s?t.backend_util.fromUint8ToStringArray(e):e,d=t.buffer(r,s,l),h=t.buffer(i,s);for(let e=0;e<h.size;++e){const t=h.indexToLoc(e),i=t.map(((e,t)=>e+n[t]));h.set(d.get(...i),...t)}return"string"===s?t.backend_util.fromStringArrayToUint8(h.values):h.values},sparseFillEmptyRowsImpl:function(e,n,i,r,s,a,o){const u=n[0],l=a[0],d=new Array(l),h=new Array(u),p=n[1];if(0===l){if(0!==u)throw new Error(t.backend_util.getSparseFillEmptyRowsIndicesDenseShapeMismatch(u));return[t.util.getArrayFromDType(i,0),[0,p],t.util.getArrayFromDType(s,0),d,h]}let c=!0,f=0;const m=new Array(l).fill(0);for(let n=0;n<u;++n){const i=e[n*p];if(i<0)throw new Error(t.backend_util.getSparseFillEmptyRowsNegativeIndexErrorMessage(n,i));if(i>=l)throw new Error(t.backend_util.getSparseFillEmptyRowsOutOfRangeIndexErrorMessage(n,i,l));++m[i],c=c&&i>=f,f=i}let g=!0;for(let e=0;e<l;++e){const t=0===m[e];d[e]=t,g=g&&!t,m[e]=Math.max(m[e],1),e>0&&(m[e]+=m[e-1])}if(g&&c){const t=e,n=r;for(let e=0;e<u;++e)h[e]=e;return[t,[u,p],n,d,h]}{const n=m[l-1],a=t.util.getArrayFromDType(i,n*p),c=t.util.getArrayFromDType(s,n),f=new Array(l).fill(0);for(let t=0;t<u;++t){const n=e[t*p],i=f[n],s=(0===n?0:m[n-1])+i;f[n]++;for(let n=0;n<p;++n)a[s*p+n]=e[t*p+n];c[s]=r[t],h[t]=s}for(let e=0;e<l;++e){if(0===f[e]){const t=0===e?0:m[e-1];a[t*p+0]=e;for(let e=1;e<p;++e)a[t*p+e]=0;c[t]=o}}return[a,[n,p],c,d,h]}},sparseReshapeImpl:function(e,n,i,r,s){const a=t.util.sizeFromShape(r),o=n[0],u=s.length,l=[];let d=1,h=-1;for(let e=0;e<u;++e){const n=s[e];if(-1===n){if(-1!==h)throw new Error(t.backend_util.getSparseReshapeMultipleNegativeOneOutputDimErrorMessage(h,e));h=e,l.push(1)}else{if(n<0)throw new Error(t.backend_util.getSparseReshapeNegativeOutputDimErrorMessage(e,n));d*=n,l.push(n)}}if(-1!==h){if(d<=0)throw new Error(t.backend_util.getSparseReshapeEmptyTensorZeroOutputDimErrorMessage());const e=Math.trunc(a/d);if(d*e!==a)throw new Error(t.backend_util.getSparseReshapeInputOutputMultipleErrorMessage(r,l));l[h]=e}if(t.util.sizeFromShape(l)!==a)throw new Error(t.backend_util.getSparseReshapeInputOutputMismatchErrorMessage(r,l));const p=r.length,c=[];if(p>0){c[p-1]=1;for(let e=p-2;e>=0;--e)c[e]=c[e+1]*r[e+1]}const f=[];if(u>0){f[u-1]=1;for(let e=u-2;e>=0;--e)f[e]=f[e+1]*l[e+1]}const m=t.util.getArrayFromDType(i,o*u);for(let t=0;t<o;++t){let n=0;for(let i=0;i<p;++i)n+=e[t*p+i]*c[i];for(let e=0;e<u;++e)m[t*u+e]=Math.trunc(n/f[e]),n%=f[e]}return[m,[o,u],l]},sparseSegmentReductionImpl:function(e,n,i,r,s,a=!1,o=0){const u=r.length,l=[n[0],e.length/n[0]],d=l[1],h=u>0?s[u-1]+1:0;if(h<0)throw new Error(t.backend_util.getSparseSegmentReductionNegativeSegmentIdsErrorMessage());const p=n.slice();p[0]=h;const c=p.reduce(((e,t)=>e*t),1),f=t.util.getArrayFromDType(i,c);if(0===u)return h>0&&f.fill(o),[f,p];if(h<=0)throw new Error(t.backend_util.getSparseSegmentReductionNegativeSegmentIdsErrorMessage());let m=0,g=1,x=0,b=s[m];for(;;){let n=0;if(g<u){if(n=s[g],b===n){++g;continue}if(b>=n)throw new Error(t.backend_util.getSparseSegmentReductionNonIncreasingSegmentIdsErrorMessage())}if(b<0||b>=h)throw new Error(t.backend_util.getSparseSegmentReductionSegmentIdOutOfRangeErrorMessage(b,h));b>x&&f.fill(o,x*d,b*d);for(let n=m;n<g;++n){const i=r[n];if(i<0||i>=l[0])throw new Error(t.backend_util.getSparseSegmentReductionIndicesOutOfRangeErrorMessage(n,r[n],l[0]));for(let t=0;t<d;t++)f[b*d+t]+=e[i*d+t]}if(a)for(let e=0;e<d;e++)f[b*d+e]/=g-m;if(m=g,++g,x=b+1,b=n,g>u)break}return x<h&&f.fill(o,x*d,h*d),[f,p]},sqrtImpl:qe,squaredDifferenceImpl:Ye,staticRegexReplaceImpl:je,stridedSliceImpl:function(e,n,i,r){const s=t.buffer(e,n.dtype);for(let e=0;e<s.size;e++){const t=s.indexToLoc(e),a=new Array(t.length);for(let e=0;e<a.length;e++)a[e]=t[e]*i[e]+r[e];s.set(n.get(...a),...t)}return s},stringNGramsImpl:function(e,t,n,i,r,s,a,o){return new Qe(n,i,r,s,a,o).compute(e,t)},stringSplitImpl:function(e,n,i){const r=e.length,s=[];let a=0,o=0;const u=new Array(r);for(let t=0;t<r;++t){const r=s.length;Ze(e[t],n,i,s);const l=s.length-r;u[t]=l,a+=l,o=Math.max(o,l)}const l=t.util.getArrayFromDType("int32",2*a),d=new Array(a),h=[r,o];let p=0;for(let e=0;e<r;++e)for(let t=0;t<u[e];++t)l[2*p]=e,l[2*p+1]=t,d[p]=s[p],++p;return[l,d,h]},stringToHashBucketFastImpl:function(e,n){const i=t.util.getArrayFromDType("int32",e.length);for(let r=0;r<e.length;++r)i[r]=t.util.fingerPrint64(e[r]).modulo(n).getLowBitsUnsigned();return i},subImpl:Je,tileImpl:function(e,n){const i=new Array(e.rank);for(let t=0;t<i.length;t++)i[t]=e.shape[t]*n[t];const r=t.buffer(i,e.dtype);for(let t=0;t<r.values.length;++t){const n=r.indexToLoc(t),i=new Array(e.rank);for(let t=0;t<i.length;t++)i[t]=n[t]%e.shape[t];const s=e.locToIndex(i);r.values[t]=e.values[s]}return r},topKImpl:function(e,n,i,r,s){const a=n[n.length-1],[o,u]=[e.length/a,a],l=t.util.getTypedArrayFromDType(i,o*r),d=t.util.getTypedArrayFromDType("int32",o*r);for(let t=0;t<o;t++){const n=t*u,i=e.subarray(n,n+u);let a=new Array(i.length);i.forEach(((e,t)=>a[t]={value:e,index:t})),r<a.length&&(tt(a,r),a=a.slice(0,r)),s&&a.sort(et);const o=t*r,h=l.subarray(o,o+r),p=d.subarray(o,o+r);for(let e=0;e<r;e++)h[e]=a[e].value,p[e]=a[e].index}const h=n.slice();return h[h.length-1]=r,[t.buffer(h,i,l),t.buffer(h,"int32",d)]},transposeImpl:function(e,n,i,r,s){const a=n.length,o=t.util.sizeFromShape(n),u=t.util.computeStrides(n),l=t.util.computeStrides(s),d=t.util.getTypedArrayFromDType(i,t.util.sizeFromShape(s));for(let n=0;n<o;++n){const i=t.util.indexToLoc(n,a,u),s=new Array(i.length);for(let e=0;e<s.length;e++)s[e]=i[r[e]];d[t.util.locToIndex(s,a,l)]=e[n]}return d},uniqueImpl:function(e,n,i,r){const s=t.util.parseAxisParam(n,i)[0],a=[1,i[0],1];for(let e=0;e<s;e++)a[0]*=i[e];a[1]=i[s];for(let e=s+1;e<i.length;e++)a[2]*=i[e];const o=new Map,u=new Int32Array(i[s]),l=new t.TensorBuffer(a,r,e),d=[],h=1===a[0]&&1===a[2];for(let t=0;t<i[s];t++){let n;if(h)n=e[t].toString();else{const e=[];for(let n=0;n<a[0];n++)for(let i=0;i<a[2];i++)e.push(l.get(n,t,i));n=e.join(",")}const i=o.get(n);if(null!=i)u[t]=i;else{const e=o.size;o.set(n,e),u[t]=e,d.push(t)}}const p=a.slice();p[1]=o.size;const c=new t.TensorBuffer(p,r);d.forEach(((e,t)=>{for(let n=0;n<a[0];n++)for(let i=0;i<a[2];i++)c.set(l.get(n,e,i),n,t,i)}));const f=i.slice();return f[s]=p[1],{outputValues:c.values,outputShape:f,indices:u}}};const{addImpl:it,castImpl:rt,ceilImpl:st,concatImpl:at,equalImpl:ot,expImpl:ut,expm1Impl:lt,floorImpl:dt,floorDivImpl:ht,gatherNdImpl:pt,gatherV2Impl:ct,greaterEqualImpl:ft,greaterImpl:mt,lessEqualImpl:gt,lessImpl:xt,logImpl:bt,maxImpl:yt,maximumImpl:wt,minimumImpl:Ct,multiplyImpl:kt,negImpl:St,notEqualImpl:vt,prodImpl:It,rangeImpl:Rt,rsqrtImpl:$t,scatterImpl:Pt,simpleAbsImpl:At,sliceImpl:zt,stridedSliceImpl:Nt,stringNGramsImpl:Dt,subImpl:Tt,tileImpl:Ft,topKImpl:_t,transposeImpl:Et,uniqueImpl:Wt}=nt,Lt=xe({opType:U.ABS,cpuKernelImpl:At}),Bt={kernelName:t.Abs,backendName:"webgpu",kernelFunc:Lt},Ot=xe({opType:U.ACOS}),Ut={kernelName:t.Acos,backendName:"webgpu",kernelFunc:Ot},Mt=xe({opType:U.ACOSH}),Vt={kernelName:t.Acosh,backendName:"webgpu",kernelFunc:Mt},Gt=be({opType:B.ADD,cpuKernelImpl:it,supportsComplex:!0}),Ht={kernelName:t.Add,backendName:"webgpu",kernelFunc:Gt};class Xt{constructor(e){this.workPerThread=1,this.workgroupSize=[64,1,1],this.size=!0,this.outputShape=e[0],this.variableNames=e.map(((e,t)=>`T${t}`)),this.dispatchLayout=N(this.outputShape),this.dispatch=$(this.dispatchLayout,this.outputShape,this.workgroupSize,[this.workPerThread,1,1]),this.shaderKey="addN"}getUserCode(){const e=[];this.variableNames.forEach((t=>{e.push(`let v${t} = get${t}ByOutputCoords(coords);`)}));const t=this.variableNames.map((e=>`v${e}`)).join(" + ");return`\n      ${x("index")} {\n        for (var i = 0; i < ${this.workPerThread}; i = i + 1) {\n          let flatIndex = index * ${this.workPerThread} + i;\n          if (flatIndex < uniforms.size) {\n            let coords = getCoordsFromIndex(flatIndex);\n            ${e.join("\n        ")}\n            setOutputAtIndex(flatIndex, ${t});\n          }\n        }\n      }\n    `}}const Kt={kernelName:t.AddN,backendName:"webgpu",kernelFunc:function(e){const{inputs:n,backend:i}=e,r=n;if(1===r.length)return pe({inputs:{x:r[0]},backend:i});const s=r.map((e=>e.dtype)).reduce(((e,n)=>t.upcastType(e,n))),a=r.map((e=>e.shape)),o=new Xt(a);return i.runWebGPUProgram(o,r,s)}};class qt{constructor(e,t){this.variableNames=["A"],this.workgroupSize=[16,16,1];const n=new Array(e.length);for(let i=0;i<n.length;i++)n[i]=e[t[i]];this.outputShape=n,this.dispatchLayout={x:[0],y:[1]},this.dispatch=$(this.dispatchLayout,this.outputShape,this.workgroupSize,[1,1,1]),this.shaderKey="transposeShared"}getUserCode(){t.util.assert(this.workgroupSize[0]===this.workgroupSize[1],(()=>`Must be a square tile, current tile shape is ${this.workgroupSize[0]} x ${this.workgroupSize[1]}`));const e=this.workgroupSize[0];return`\n      var<workgroup> tile : array<array<f32, ${this.workgroupSize[0]+1}>, ${this.workgroupSize[0]}>;\n      ${x()} {\n        var x = i32(workgroupId.x) * ${e} + i32(localId.x);\n        var y = i32(workgroupId.y) * ${e} + i32(localId.y);\n        let width = uniforms.outShape[0];\n        let height = uniforms.outShape[1];\n        if (x < width && y < height) {\n          tile[localId.y][localId.x] = f32(A[y * width + x]);\n        }\n        workgroupBarrier();\n\n        x = i32(workgroupId.y) * ${e} + i32(localId.x);\n        y = i32(workgroupId.x) * ${e} + i32(localId.y);\n        if (x < height && y < width) {\n          setOutputAtIndex((y * height + x), tile[localId.x]\n            [localId.y]);\n        }\n      }\n    `}}class Yt{constructor(e,t){this.variableNames=["A"],this.workPerThread=1,this.workgroupSize=[64,1,1],this.size=!0;const n=new Array(e.length);for(let i=0;i<n.length;i++)n[i]=e[t[i]];this.outputShape=n,this.dispatchLayout=N(this.outputShape),this.dispatch=$(this.dispatchLayout,this.outputShape,this.workgroupSize,[this.workPerThread,1,1]),this.newDim=t,this.shaderKey=`transpose_${t}`}getUserCode(){const e=m(this.outputShape.length),t=function(e){const t=e.length;if(t>6)throw Error(`Transpose for rank ${t} is not yet supported`);const n=new Array(t);for(let t=0;t<e.length;t++)n[e[t]]=`resRC.${g(t)}`;return n.join()}(this.newDim);return`\n      ${x("index")} {\n        for(var i = 0; i < ${this.workPerThread}; i = i + 1) {\n          let flatIndex = index * ${this.workPerThread} + i;\n          if(flatIndex < uniforms.size) {\n            let resRC = getCoordsFromIndex(flatIndex);\n            setOutputAtIndex(flatIndex, A[getIndexFromCoords${this.outputShape.length}D(\n              ${e}(${t}), uniforms.aShape)]);\n          }\n        }\n      }\n    `}}function jt(e){const{inputs:n,backend:i,attrs:r}=e,{x:s}=n,{perm:a}=r,o=i,u=s.shape.length,l=new Array(u);for(let e=0;e<l.length;e++)l[e]=s.shape[a[e]];if(i.shouldExecuteOnCPU([s])){const e=o.tensorMap.get(s.dataId).values,t=Et(e,s.shape,s.dtype,a,l);return i.makeTensorInfo(l,s.dtype,t)}if(2===s.shape.length&&t.util.arraysEqual(a,[1,0])){const e=new qt(s.shape,a);return o.runWebGPUProgram(e,[s],s.dtype)}const d=new Yt(s.shape,a);return o.runWebGPUProgram(d,[s],s.dtype)}const Qt={kernelName:t.Transpose,backendName:"webgpu",kernelFunc:jt};class Zt{constructor(e,n,i){this.variableNames=["x"],this.uniforms="reduceSize : i32,",this.size=!0,this.inputShape=[e.batchSize,e.inSize];const[r]=t.backend_util.computeOutAndReduceShapes(this.inputShape,[1]);this.outputShape=0===r.length?[1]:r,e.inSize>=32768&&i>=512?this.workgroupSize=[512,1,1]:e.inSize>=4096?this.workgroupSize=[256,1,1]:this.workgroupSize=[64,1,1],this.dispatchLayout=N(this.outputShape),this.dispatch=$(this.dispatchLayout,this.outputShape,[1,1,1]),this.reduceType=n,this.shaderKey=`reduce_${n}`}getUserCode(){let e="",t="0.0";const n=this.workgroupSize[0];"min"===this.reduceType||"max"===this.reduceType?(e=`\n         if (isnan(candidate)) {\n          bestValue = uniforms.NAN;\n         } else if (!isnan(bestValue) && candidate ${"min"===this.reduceType?"<":">"} bestValue)\n           {  bestValue = candidate; }`,t="f32(x[offset])"):"sum"===this.reduceType||"mean"===this.reduceType?e=" bestValue = bestValue + candidate; ":"prod"===this.reduceType?(e=" bestValue = bestValue * candidate; ",t="1.0"):"all"===this.reduceType?(e=" bestValue = f32(bestValue >= 1.0 && candidate >= 1.0); ",t="1.0"):"any"===this.reduceType&&(e=" bestValue = f32(bestValue >= 1.0 || candidate >= 1.0); ",t="0.0");const i="mean"===this.reduceType?"setOutputAtIndex(outputIndex, bestValue / f32(uniforms.reduceSize));":"setOutputAtIndex(outputIndex, bestValue);";return`\n       fn DIV_CEIL(a : u32, b : u32) -> u32 {\n        return ((a - 1u) / b + 1u);\n       }\n\n       ${`\n         var<workgroup> xBestValues : array<f32, ${n}>;\n       `}\n       fn getOffset(outputIndex : i32) -> i32 {\n         let outputCoords = getCoordsFromIndex(outputIndex);\n         let offset = ${1===this.outputShape.length?"outputCoords":"outputCoords[0]"} * uniforms.reduceSize;\n          return offset;\n       }\n       ${x("index")} {\n         let outputIndex = index / ${n};\n         let offset = getOffset(outputIndex);\n         var bestValue = ${t};\n         let Length = uniforms.reduceSize;\n         let WorkPerThread = DIV_CEIL(u32(Length), ${n}u);\n         for (var k = i32(localId.x); k < Length && outputIndex < uniforms.size;\n             k = k + ${n}) {\n           let candidate = f32(x[offset + k]);\n           ${e}\n         }\n         xBestValues[localId.x] = bestValue;\n         workgroupBarrier();\n\n         var reduceSize = min(u32(Length), ${n}u);\n         for (var currentSize = reduceSize / 2u; reduceSize > 1u;\n             currentSize = reduceSize / 2u) {\n           let interval = DIV_CEIL(reduceSize, 2u);\n           if (localId.x < currentSize) {\n            let candidate = xBestValues[localId.x + interval];\n            ${e}\n            xBestValues[localId.x] = bestValue;\n           }\n           reduceSize = interval;\n           workgroupBarrier();\n         }\n\n         if (localId.x == 0u && outputIndex < uniforms.size) {\n          ${i}\n        }\n       }\n     `}}function Jt(e,n,i,r,s){const a=e.shape.length,o=[],u=t.util.parseAxisParam(n,e.shape);let l=u;const d=t.backend_util.getAxesPermutation(l,a);let h=e;null!=d&&(h=jt({inputs:{x:e},attrs:{perm:d},backend:s}),l=t.backend_util.getInnerMostAxes(l.length,a),o.push(h)),t.backend_util.assertAxesAreInnerMostDims(r,l,a);const[p,c]=t.backend_util.computeOutAndReduceShapes(h.shape,l);let f,m=p;if(i&&(m=t.backend_util.expandShapeToKeepDim(p,u)),"max"!==r&&"prod"!==r||!s.shouldExecuteOnCPU([h])){const n=t.util.sizeFromShape(c),i={windowSize:n,inSize:n,batchSize:t.util.sizeFromShape(h.shape)/n,outSize:1},a="mean"===r?"float32":t.sumOutType(e.dtype),u=[{type:"int32",data:[n]}],l=new Zt(i,r,s.device.limits.maxComputeWorkgroupSizeX),d=s.runWebGPUProgram(l,[h],a,u);o.push(d),f=ae({inputs:{x:d},attrs:{shape:m},backend:s})}else{const n=s.tensorMap.get(h.dataId).values;switch(r){case"max":const i=yt(n,t.util.sizeFromShape(c),m,e.dtype);f=s.makeTensorInfo(m,e.dtype,i);break;case"prod":const{outVals:a,outShape:o,outDtype:u}=It(h.shape,h.dtype,n,l);f=s.makeTensorInfo(o,u,a);break;default:throw new Error(`${r} CPU implementation is not yet supported.`)}}return o.forEach((e=>s.disposeData(e.dataId))),f}const en={kernelName:t.All,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:n,attrs:i}=e,{x:r}=t,{keepDims:s,axis:a}=i;return Jt(r,a,s,"all",n)}};const tn={kernelName:t.Any,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:n,attrs:i}=e,{x:r}=t,{keepDims:s,axis:a}=i;return Jt(r,a,s,"any",n)}};class nn{constructor(e,n,i){this.workgroupSize=[64,1,1],this.variableNames=["x"],this.uniforms="infinityValue : f32,",this.size=!0;const r=[n];this.op="min"===i?"<":">";const[s,a]=t.backend_util.computeOutAndReduceShapes(e,r);this.outputShape=0===s.length?[1]:s,this.dispatchLayout=N(this.outputShape),t.util.sizeFromShape(a)<32||t.util.sizeFromShape(s)>1e3?(this.type="plain",this.dispatch=$(this.dispatchLayout,this.outputShape,this.workgroupSize)):(this.type="shared",this.dispatch=$(this.dispatchLayout,this.outputShape,[1,1,1])),this.inputShape=e,this.shaderKey=`argMinMax_${this.op}_${this.type}`}getUserCode(){const e=this.workgroupSize[0],t=()=>1===this.inputShape.length?"uniforms.xShape":`uniforms.xShape.${g(this.inputShape.length-1)}`,n=()=>{let e="";if(1===this.outputShape.length)1!==this.inputShape.length&&(e+="outputCoords,");else for(let t=0;t<this.outputShape.length;t++)e+=`outputCoords.${g(t)},`;return e};if("shared"===this.type){return`\n      fn DIV_CEIL(a : u32, b : u32) -> u32 {\n        return ((a - 1u) / b + 1u);\n      }\n\n      ${`\n      var<workgroup> xBestIndices : array<i32, ${e}>;\n      var<workgroup> xBestValues : array<f32, ${e}>;\n    `}\n\n      ${x("index")} {\n        let outputIndex = index / ${e};\n        let reduceLength = ${t()};\n\n        var bestIndex = i32(localId.x);\n        var bestValue = uniforms.infinityValue;\n        let outputCoords = getCoordsFromIndex(outputIndex);\n        for (var k = i32(localId.x); k < reduceLength && outputIndex < uniforms.size;\n            k = k + ${e}) {\n          let candidate = getX(${n()} k);\n          if (!isnan(candidate) && candidate ${this.op} bestValue) {\n            bestValue = candidate;\n            bestIndex = k;\n          }\n        }\n        xBestValues[localId.x] = bestValue;\n        xBestIndices[localId.x] = bestIndex;\n        workgroupBarrier();\n\n        var reduceSize = min(u32(reduceLength), ${e}u);\n        for (var currentSize = reduceSize / 2u; reduceSize > 1u;\n            currentSize = reduceSize / 2u) {\n          let interval = DIV_CEIL(reduceSize, 2u);\n          if (localId.x < currentSize) {\n            let candidate = xBestValues[localId.x + interval];\n            if (candidate ${this.op} bestValue) {\n              bestValue = candidate;\n              xBestValues[localId.x] = bestValue;\n              xBestIndices[localId.x] = xBestIndices[localId.x + interval];\n            }\n          }\n          reduceSize = interval;\n          workgroupBarrier();\n        }\n\n        if (localId.x == 0u && outputIndex < uniforms.size) {\n          setOutputAtIndexI32(outputIndex, xBestIndices[localId.x]);\n        }\n      }\n    `}return`\n      ${x("index")} {\n        if (index < uniforms.size) {\n          let outputCoords = getCoordsFromIndex(index);\n          var bestIndex = 0;\n          var bestValue = getX(${n()} 0);\n          let reduceLength = ${t()};\n          for (var i = 1; i < reduceLength; i++) {\n            let candidate = getX(${n()} i);\n            if (candidate ${this.op} bestValue) {\n              bestValue = candidate;\n              bestIndex = i;\n            }\n          }\n          setOutputAtIndexI32(index, bestIndex);\n        }\n      }\n      `}}const rn={kernelName:t.ArgMax,backendName:"webgpu",kernelFunc:function(e){const{inputs:n,backend:i,attrs:r}=e,{x:s}=n,{axis:a}=r;let o=t.util.parseAxisParam(a,s.shape);const u=t.backend_util.getAxesPermutation(o,s.shape.length);let l=s;const d=[];null!=u&&(l=jt({inputs:{x:s},backend:i,attrs:{perm:u}}),d.push(l),o=t.backend_util.getInnerMostAxes(o.length,l.shape.length)),t.backend_util.assertAxesAreInnerMostDims("argMax",[o[0]],l.shape.length);const h=new nn(l.shape,o[0],"max"),p=[{type:"float32",data:[Number.NEGATIVE_INFINITY]}],c=i.runWebGPUProgram(h,[l],"int32",p);return d.forEach((e=>i.disposeData(e.dataId))),c}};const sn={kernelName:t.ArgMin,backendName:"webgpu",kernelFunc:function(e){const{inputs:n,backend:i,attrs:r}=e,{x:s}=n,{axis:a}=r;let o=t.util.parseAxisParam(a,s.shape);const u=t.backend_util.getAxesPermutation(o,s.shape.length);let l=s;const d=[];null!=u&&(l=jt({inputs:{x:s},backend:i,attrs:{perm:u}}),d.push(l),o=t.backend_util.getInnerMostAxes(o.length,l.shape.length)),t.backend_util.assertAxesAreInnerMostDims("argMin",[o[0]],l.shape.length);const h=new nn(l.shape,o[0],"min"),p=[{type:"float32",data:[Number.POSITIVE_INFINITY]}],c=i.runWebGPUProgram(h,[l],"int32",p);return d.forEach((e=>i.disposeData(e.dataId))),c}},an=xe({opType:U.ASIN}),on={kernelName:t.Asin,backendName:"webgpu",kernelFunc:an},un=xe({opType:U.ASINH}),ln={kernelName:t.Asinh,backendName:"webgpu",kernelFunc:un},dn=xe({opType:U.ATAN}),hn={kernelName:t.Atan,backendName:"webgpu",kernelFunc:dn},pn=be({opType:B.ATAN2}),cn={kernelName:t.Atan2,backendName:"webgpu",kernelFunc:pn},fn=xe({opType:U.ATANH}),mn={kernelName:t.Atanh,backendName:"webgpu",kernelFunc:fn};class gn{constructor(e){this.variableNames=["x"],this.uniforms="strides : vec2<i32>,",this.workgroupSize=[256,1,1],this.size=!0,this.outputShape=e.outShape,this.dispatchLayout=N(this.outputShape),this.dispatch=$(this.dispatchLayout,this.outputShape,this.workgroupSize),this.shaderKey="poolWithFilterSizeEqualsOne"}getUserCode(){return`\n      ${x("index")} {\n        if (index < uniforms.size) {\n          let coords = getCoordsFromIndex(index);\n          let batch = coords[0];\n          let d = coords[3];\n\n          let xRCCorner = coords.yz * uniforms.strides;\n          let xRCorner = xRCCorner.x;\n          let xCCorner = xRCCorner.y;\n\n          let value = getX(batch, xRCorner, xCCorner, d);\n          setOutputAtIndex(index, value);\n        }\n      }\n    `}}class xn{constructor(e,t,n=!1,i=!1,r=!1){if(this.variableNames=["x"],this.uniforms="strides : vec2<i32>, pads : vec2<i32>, dilations : vec2<i32>, convDims : vec2<i32>, filterDims : vec2<i32>,",this.workgroupSize=[128,1,1],this.size=!0,"avg"===t&&n)throw new Error("Cannot compute positions for average pool.");this.outputShape=e.outShape,this.dispatchLayout=N(this.outputShape),this.dispatch=$(this.dispatchLayout,this.outputShape,this.workgroupSize),this.poolType=t,this.computePositions=n,this.flattenPositions=i,this.includeBatchIndex=r,this.shaderKey=`pool2D_${t}_${n}_${i}_${r}`}getUserCode(){let e;if("avg"===this.poolType)e="resultValue = resultValue + value; count = count + 1.0;";else if(this.computePositions){e=`let currMaxValue = mix(value, maxValue, maxValueFound);\n      if (value >= currMaxValue) {\n        maxValue = value;\n        maxValueFound = 1.0;\n        maxPosition = ${this.flattenPositions?this.includeBatchIndex?"((batch * uniforms.xShape[1] + xR) * uniforms.xShape[2] + xC) * uniforms.xShape[3] + d":"(xR * uniforms.xShape[2] + xC) * uniforms.xShape[3] + d":"wR * uniforms.filterDims.y + wC"};\n      }`}else e="resultValue = max(value, resultValue);";let t="resultValue";"avg"===this.poolType&&(t="resultValue / max(count, 1.0)");return`\n      ${x("index")} {\n      if (index < uniforms.size) {\n        let coords = getCoordsFromIndex(index);\n          let batch = coords[0];\n          let d = coords[3];\n          let xRCCorner = vec2<i32>(coords.yz) * uniforms.strides - uniforms.pads;\n          let xRCorner = xRCCorner.x;\n          let xCCorner = xRCCorner.y;\n\n          ${this.computePositions?"var maxValue = 0.0;\n            var maxValueFound = 0.0;\n            var maxPosition = 0;":`var resultValue = ${"avg"===this.poolType?"0.0":"-1.0 / pow(10.0, -20.0)"};`}\n\n          var count = 0.0;\n          for (var wR = 0; wR < uniforms.filterDims.x; wR = wR + uniforms.dilations.x) {\n            let xR = xRCorner + wR;\n\n            if (xR < 0 || xR >= uniforms.convDims.x) {\n              continue;\n            }\n\n            for (var wC = 0; wC < uniforms.filterDims.y; wC = wC + uniforms.dilations.y) {\n              let xC = xCCorner + wC;\n              if (xC < 0 || xC >= uniforms.convDims.y) {\n                continue;\n              }\n\n              let value = getX(batch, xR, xC, d);\n              ${e}\n            }\n          }\n\n          ${this.computePositions?"setOutputAtIndexI32(index, maxPosition);":`setOutputAtIndex(index, ${t});`}\n        }\n      }\n    `}}class bn{constructor(e,t,n=!1,i=!1,r=!1){if(this.variableNames=["x"],this.uniforms="strides : vec3<i32>, pads : vec3<i32>, convDims : vec3<i32>, filterDims : vec3<i32>,",this.workgroupSize=[128,1,1],this.size=!0,"avg"===t&&n)throw new Error("Cannot compute positions for average pool.");this.outputShape=e.outShape,this.dispatchLayout=N(this.outputShape),this.dispatch=$(this.dispatchLayout,this.outputShape,this.workgroupSize),this.poolType=t,this.computePositions=n,this.flattenPositions=i,this.includeBatchIndex=r,this.shaderKey=`pool3D_${t}_${n}_${i}_${r}`}getUserCode(){let e;if("avg"===this.poolType)e="resultValue += value; count += 1.0;";else if(this.computePositions){e=`let currMaxValue = mix(value, maxValue, maxValueFound);\n      if (value >= currMaxValue) {\n        maxValue = value;\n        maxValueFound = 1.0;\n        maxPosition = ${this.flattenPositions?this.includeBatchIndex?"(((batch * uniforms.xShape.y + xD) * uniforms.xShape.z + xR) * uniforms.xShape.w + xC) * uniforms.xShape.u + ch":"((xD * uniforms.xShape.z + xR) * uniforms.xShape.w + xC) * uniforms.xShape.u + ch":"wD * uniforms.filterDims.y * uniforms.filterDims.y + wR * uniforms.filterDims.z + wC"};\n      }`}else e="resultValue = max(value, resultValue);";let t="resultValue";"avg"===this.poolType&&(t="resultValue / max(count, 1.0)");return`\n      ${x("index")} {\n        if (index < uniforms.size) {\n          let coords = getCoordsFromIndex(index);\n          let batch = coords.x;\n          let ch = coords.u;\n\n          let xCorner = vec3<i32>(coords.y, coords.z, coords.w) * uniforms.strides - uniforms.pads;\n          let xDCorner = xCorner.x;\n          let xRCorner = xCorner.y;\n          let xCCorner = xCorner.z;\n\n          ${this.computePositions?"var maxValue = 0.0;\n            var maxValueFound = 0.0;\n            var maxPosition = 0;":`var resultValue = ${"avg"===this.poolType?"0.0":"-1.0 / pow(10.0, -20.0)"};`}\n\n          var count = 0.0;\n          for (var wD = 0; wD < uniforms.filterDims.x; wD++) {\n            let xD = xDCorner + wD;\n            if (xD < 0 || xD >= uniforms.convDims.x) {\n              continue;\n            }\n\n            for (var wR = 0; wR < uniforms.filterDims.y; wR++) {\n              let xR = xRCorner + wR;\n              if (xR < 0 || xR >= uniforms.convDims.y) {\n                continue;\n              }\n\n              for (var wC = 0; wC < uniforms.filterDims.z; wC++) {\n                let xC = xCCorner + wC;\n                if (xC < 0 || xC >= uniforms.convDims.z) {\n                  continue;\n                }\n\n                let value = getX(batch, xD, xR, xC, ch);\n                ${e}\n              }\n            }\n          }\n\n          ${this.computePositions?"setOutputAtIndexI32(index, maxPosition);":`setOutputAtIndex(index, ${t});`}\n        }\n      }\n    `}}function yn(e){const{inputs:t,backend:n,attrs:i}=e,{x:r}=t,{reductionIndices:s,keepDims:a}=i;return Jt(r,s,a,"max",n)}const wn={kernelName:t.Max,backendName:"webgpu",kernelFunc:yn};function Cn(e){const{inputs:t,backend:n,attrs:i}=e,{x:r}=t,{keepDims:s,axis:a}=i;return Jt(r,a,s,"mean",n)}const kn={kernelName:t.Mean,backendName:"webgpu",kernelFunc:Cn};function Sn(e,n,i,r){if(1===n.filterWidth&&1===n.filterHeight&&t.util.arraysEqual(n.inShape,n.outShape))return pe({inputs:{x:e},backend:r});if(n.filterWidth===n.inWidth&&n.filterHeight===n.inHeight&&1===n.batchSize&&"VALID"===n.padInfo.type){const s=e.shape.length,a=ae({inputs:{x:e},backend:r,attrs:{shape:[e.shape[s-3]*e.shape[s-2],e.shape[s-1]]}});let o;"avg"===i?o=Cn({inputs:{x:a},backend:r,attrs:{axis:0,keepDims:!1}}):(t.util.assert("max"===i,(()=>`Invalid pool type ${i}`)),o=yn({inputs:{x:a},backend:r,attrs:{reductionIndices:0,keepDims:!1}}));const u=ae({inputs:{x:o},backend:r,attrs:{shape:n.outShape}});return r.disposeData(a.dataId),r.disposeData(o.dataId),u}let s;const a=[{type:"int32",data:[n.strideHeight,n.strideWidth]}];return 1===n.filterHeight&&1===n.filterWidth?s=new gn(n):("avg"===i?s=new xn(n,"avg"):(t.util.assert("max"===i,(()=>`Invalid pool type ${i}`)),s=new xn(n,"max")),a.push({type:"int32",data:[n.padInfo.top,n.padInfo.left]},{type:"int32",data:[n.dilationHeight,n.dilationWidth]},{type:"int32",data:[n.inHeight,n.inWidth]},{type:"int32",data:[n.effectiveFilterHeight,n.effectiveFilterWidth]})),r.runWebGPUProgram(s,[e],e.dtype,a)}const vn={kernelName:t.AvgPool,backendName:"webgpu",kernelFunc:function(e){const{inputs:n,backend:i,attrs:r}=e,{x:s}=n,{filterSize:a,strides:o,pad:u,dimRoundingMode:l}=r;return Sn(s,t.backend_util.computePool2DInfo(s.shape,a,o,1,u,l),"avg",i)}};const In={kernelName:t.AvgPool3D,backendName:"webgpu",kernelFunc:function(e){const{inputs:n,backend:i,attrs:r}=e,{x:s}=n,{filterSize:a,strides:o,pad:u,dataFormat:l,dimRoundingMode:d}=r,h=t.backend_util.computePool3DInfo(s.shape,a,o,[1,1,1],u,d,l),p=new bn(h,"avg"),c=[{type:"int32",data:[h.strideDepth,h.strideHeight,h.strideWidth]},{type:"int32",data:[h.padInfo.front,h.padInfo.top,h.padInfo.left]},{type:"int32",data:[h.inDepth,h.inHeight,h.inWidth]},{type:"int32",data:[h.effectiveFilterDepth,h.effectiveFilterHeight,h.effectiveFilterWidth]}];return i.runWebGPUProgram(p,[s],s.dtype,c)}};class Rn{constructor(e){this.variableNames=["dy"],this.uniforms="strides : vec2<i32>, pads : vec2<i32>, dilations : vec2<i32>, filterDims : vec2<i32>,\n       outHeight : i32, outWidth : i32, avgMultiplier : f32,",this.workgroupSize=[64,1,1],this.size=!0,this.outputShape=e.inShape,this.dispatchLayout=N(this.outputShape),this.dispatch=$(this.dispatchLayout,this.outputShape,this.workgroupSize),this.shaderKey="avgPool2DBackprop"}getUserCode(){return`\n      ${x("index")} {\n      if (index < uniforms.size) {\n        let coords = getCoordsFromIndex(index);\n        let batch = coords[0];\n        let d = coords[3];\n\n        let dyRCCorner = vec2<i32>(coords.yz) - uniforms.pads;\n        let dyRCorner = dyRCCorner.x;\n        let dyCCorner = dyRCCorner.y;\n\n        // Convolve dy(?, ?, d) with pos mask(:, :, d) to get dx(xR, xC, d).\n        // ? = to be determined. : = across all values in that axis.\n        var dotProd = 0.0;\n        for (var wR = 0; wR < uniforms.filterDims[0]; wR = wR + uniforms.dilations[0]) {\n          let dyR = f32(dyRCorner + wR) / f32(uniforms.strides[0]);\n\n          if (dyR < 0.0 || dyR >= f32(uniforms.outHeight) || fract(dyR) > 0.0) {\n            continue;\n          }\n          let idyR = i32(dyR);\n\n          for (var wC = 0; wC < uniforms.filterDims[1]; wC = wC + uniforms.dilations[1]) {\n            let dyC = f32(dyCCorner + wC) / f32(uniforms.strides[1]);\n\n            if (dyC < 0.0 || dyC >= f32(uniforms.outWidth) || fract(dyC) > 0.0) {\n              continue;\n            }\n            let idyC = i32(dyC);\n\n            let dyValue = getDy(batch, idyR, idyC, d);\n\n            dotProd = dotProd + dyValue * uniforms.avgMultiplier;\n          }\n        }\n        setOutputAtIndex(index, dotProd);\n      }\n    }\n    `}}class $n{constructor(e){this.variableNames=["dy"],this.uniforms="strides : vec3<i32>, pads : vec3<i32>, filterDims : vec3<i32>,\n       outDepth : i32, outHeight : i32, outWidth : i32, avgMultiplier : f32,",this.workgroupSize=[64,1,1],this.size=!0,this.outputShape=e.inShape,this.dispatchLayout=N(this.outputShape),this.dispatch=$(this.dispatchLayout,this.outputShape,this.workgroupSize),this.shaderKey="avgPool3DBackprop"}getUserCode(){return`\n      ${x("index")} {\n      if (index < uniforms.size) {\n        let coords = getCoordsFromIndex(index);\n        let batch = coords.x;\n        let ch = coords.u;\n\n        let dyCorner = vec3<i32>(coords.y, coords.z, coords.w) - uniforms.pads;\n        let dyDCorner = dyCorner.x;\n        let dyRCorner = dyCorner.y;\n        let dyCCorner = dyCorner.z;\n\n        // Convolve dy(?, ?, ?, d) with pos mask(:, :, :, ch) to get\n        // dx(xD, xR, xC, ch).\n        // ? = to be determined. : = across all values in that axis.\n        var dotProd = 0.0;\n        for (var wD = 0; wD < uniforms.filterDims[0]; wD++) {\n          let dyD = f32(dyDCorner + wD) / f32(uniforms.strides[0]);\n\n          if (dyD < 0.0 || dyD >= f32(uniforms.outDepth) || fract(dyD) > 0.0) {\n            continue;\n          }\n          let idyD = i32(dyD);\n\n          for (var wR = 0; wR < uniforms.filterDims[1]; wR++) {\n            let dyR = f32(dyRCorner + wR) / f32(uniforms.strides[1]);\n\n            if (dyR < 0.0 || dyR >= f32(uniforms.outHeight) || fract(dyR) > 0.0) {\n              continue;\n            }\n            let idyR = i32(dyR);\n\n            for (var wC = 0; wC < uniforms.filterDims[2]; wC++) {\n              let dyC = f32(dyCCorner + wC) / f32(uniforms.strides[2]);\n\n              if (dyC < 0.0 || dyC >= f32(uniforms.outWidth) || fract(dyC) > 0.0) {\n                continue;\n              }\n              let idyC = i32(dyC);\n\n              let dyValue = getDy(batch, idyD, idyR, idyC, ch);\n              dotProd += dyValue * uniforms.avgMultiplier;\n            }\n          }\n        }\n        setOutputAtIndex(index, dotProd);\n      }\n    }\n    `}}const Pn={kernelName:t.AvgPool3DGrad,backendName:"webgpu",kernelFunc:function(e){const{inputs:n,backend:i,attrs:r}=e,{dy:s,input:a}=n,o=a,{filterSize:u,strides:l,pad:d,dimRoundingMode:h}=r,p=t.backend_util.computePool3DInfo(o.shape,u,l,1,d,h),c=new $n(p),f=1/(p.filterDepth*p.filterHeight*p.filterWidth),m=[{type:"int32",data:[p.strideDepth,p.strideHeight,p.strideWidth]},{type:"int32",data:[p.effectiveFilterDepth-1-p.padInfo.front,p.effectiveFilterHeight-1-p.padInfo.top,p.effectiveFilterWidth-1-p.padInfo.left]},{type:"int32",data:[p.effectiveFilterDepth,p.effectiveFilterHeight,p.effectiveFilterWidth]},{type:"int32",data:[p.outDepth]},{type:"int32",data:[p.outHeight]},{type:"int32",data:[p.outWidth]},{type:"float32",data:[f]}];return i.runWebGPUProgram(c,[s],o.dtype,m)}};const An={kernelName:t.AvgPoolGrad,backendName:"webgpu",kernelFunc:function(e){const{inputs:n,backend:i,attrs:r}=e,{dy:s,input:a}=n,o=a;F([s,a],"avgPoolGrad");const{filterSize:u,strides:l,pad:d}=r,h=t.backend_util.computePool2DInfo(o.shape,u,l,1,d),p=new Rn(h),c=1/(h.filterHeight*h.filterWidth),f=[{type:"int32",data:[h.strideHeight,h.strideWidth]},{type:"int32",data:[h.effectiveFilterHeight-1-h.padInfo.top,h.effectiveFilterWidth-1-h.padInfo.left]},{type:"int32",data:[h.dilationHeight,h.dilationWidth]},{type:"int32",data:[h.effectiveFilterHeight,h.effectiveFilterWidth]},{type:"int32",data:[h.outHeight]},{type:"int32",data:[h.outWidth]},{type:"float32",data:[c]}];return i.runWebGPUProgram(p,[s],o.dtype,f)}};const zn={kernelName:t.BatchMatMul,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:n,attrs:i}=e,{a:r,b:s}=t,{transposeA:a,transposeB:o}=i;return ue({a:r,b:s,transposeA:a,transposeB:o,backend:n})}};class Nn{constructor(e,t){this.variableNames=["source"],this.workPerThread=1,this.workgroupSize=[64,1,1],this.size=!0,this.outputShape=t,this.rank=t.length,this.dispatchLayout=N(this.outputShape),this.dispatch=$(this.dispatchLayout,this.outputShape,this.workgroupSize,[this.workPerThread,1,1]),this.start=e,this.uniforms=`start : ${m(e.length)}, `,this.shaderKey="slice"}getUserCode(){const e=m(this.rank),t=function(e){if(1===e)return"sourceLoc";if(e<=6)return Dn.slice(0,e).map((e=>`sourceLoc.${e}`)).join(",");throw Error(`Slicing for rank ${e} is not yet supported`)}(this.rank);let n;n=1===this.start.length?this.outputShape.map(((e,t)=>"sourceLoc = uniforms.start + coords;")):this.outputShape.map(((e,t)=>`sourceLoc.${Dn[t]} = uniforms.start.${g(t)} + coords.${Dn[t]};`));return`\n      ${x("index")} {\n        if (index < uniforms.size) {\n          var sourceLoc : ${e};\n          let coords = getCoordsFromIndex(index);\n          ${n.join("\n")}\n          setOutputAtIndex(index, getSource(${t}));\n        }\n      }\n    `}}const Dn=["x","y","z","w","u","v"];function Tn(e){const{inputs:n,backend:i,attrs:r}=e,{x:s}=n,{begin:a,size:o}=r,[u,l]=t.slice_util.parseSliceParams(s,a,o);if(t.slice_util.assertParamsValid(s,u,l),i.shouldExecuteOnCPU([s])||"string"===s.dtype){const e=i.tensorMap.get(s.dataId),t=zt(e.values,u,l,s.shape,s.dtype);return i.makeTensorInfo(l,s.dtype,t)}if(0===t.util.sizeFromShape(l))return i.makeTensorInfo(l,s.dtype,[]);const d=new Nn(u,l),h=[{type:"int32",data:u}];return i.runWebGPUProgram(d,[s],s.dtype,h)}const Fn={kernelName:t.Slice,backendName:"webgpu",kernelFunc:Tn},_n={kernelName:t.BatchToSpaceND,backendName:"webgpu",kernelFunc:e=>{const{inputs:n,backend:i,attrs:r}=e,{x:s}=n,{blockShape:a,crops:o}=r;t.util.assert(s.shape.length<=4,(()=>"batchToSpaceND for rank > 4 with a WebGPU backend not implemented yet"));const u=a.reduce(((e,t)=>e*t)),l=t.backend_util.getReshaped(s.shape,a,u),d=t.backend_util.getPermuted(l.length,a.length),h=t.backend_util.getReshapedPermuted(s.shape,a,u),p=t.backend_util.getSliceBeginCoords(o,a.length),c=t.backend_util.getSliceSize(h,o,a.length),f=[],m=ae({inputs:{x:s},backend:i,attrs:{shape:l}}),g=jt({inputs:{x:m},backend:i,attrs:{perm:d}}),x=ae({inputs:{x:g},backend:i,attrs:{shape:h}}),b=Tn({inputs:{x:x},backend:i,attrs:{begin:p,size:c}});return f.push(m),f.push(g),f.push(x),f.forEach((e=>i.disposeData(e.dataId))),b}},En=`\n  fn bincount_write(index: i32, value: f32) {\n    ${p("&result[index]","value","float32")}\n  }\n`;class Wn{constructor(e,t,n=!1){this.outputShape=[],this.variableNames=["x"],this.uniforms="binCountSize : i32,",this.workgroupSize=[64,1,1],this.atomic=!0,this.hasWeights=!0,this.binaryOutput=!1,this.outputShape=e,this.rank=e.length,this.dispatchLayout=N(this.outputShape),this.dispatch=$(this.dispatchLayout,this.outputShape,this.workgroupSize),this.binaryOutput=n,n&&(this.atomic=!1),this.hasWeights=t,this.hasWeights&&this.variableNames.push("w"),this.shaderKey=`bincount_${this.hasWeights}_${this.binaryOutput}_${this.rank}`}getUserCode(){return`\n    ${this.binaryOutput?"\n  fn bincount_write(index: i32, value: f32) {\n    atomicStore(&result[index], bitcast<i32>(value));\n  }\n":En}\n  ${x("index")} {\n    ${1===this.rank?`if (index < uniforms.xShape) {\n      let indexVal = i32(getX(index));\n      if (indexVal < uniforms.binCountSize) {\n        let value = ${this.binaryOutput?1:this.hasWeights?"getW(index)":"1."};\n        bincount_write(indexVal, value);\n      }\n    }`:`let coord = getCoordsFromIndex(index);\n    if (coordsInBounds2D(coord, uniforms.xShape)) {\n      let indexVal = i32(getX(coord[0], coord[1]));\n      if (indexVal < uniforms.binCountSize) {\n        let value = ${this.binaryOutput?1:this.hasWeights?"getW(coord[0], coord[1])":"1."};\n        bincount_write(coord.x * uniforms.binCountSize + indexVal, value);\n      }\n    }`}\n  }\n  `}}const Ln={kernelName:t.Bincount,backendName:"webgpu",kernelFunc:function(e){const{inputs:n,backend:i,attrs:r}=e,{x:s,weights:a}=n,{size:o}=r,u=t.util.sizeFromShape(s.shape),l=t.util.sizeFromShape(a.shape)>0,d=[o],h=a.dtype,p=re({backend:i,attrs:{shape:d,value:0,dtype:h}}),c=new Wn([u],l),f=[{type:"int32",data:[o]}],m=l?[s,a]:[s];return i.runWebGPUProgram(c,m,h,f,p)}};class Bn{constructor(e){this.outputShape=[],this.variableNames=["s0","s1"],this.uniforms="s0Size : i32, s1Size : i32, ",this.workgroupSize=[64,1,1],this.size=!0,this.outputShape=[e],this.dispatchLayout=N(this.outputShape),this.dispatch=$(this.dispatchLayout,this.outputShape,this.workgroupSize),this.shaderKey="broadcastArgs"}getUserCode(){return`\n  ${x("index")} {\n    if (index < uniforms.size) {\n      var s0 = 1.0;\n      var s1 = 1.0;\n      let indexS0 = index - uniforms.size + uniforms.s0Size;\n      let indexS1 = index - uniforms.size + uniforms.s1Size;\n      if (indexS0 >= 0) {\n        s0 = getS0(indexS0);\n      }\n      if (indexS1 >= 0) {\n        s1 = getS1(indexS1);\n      }\n\n      if (s0 == 1.0) {\n        setOutputAtIndex(index, s1);\n      } else if (s1 == 1.0) {\n        setOutputAtIndex(index, s0);\n      } else if (s0 != s1) {\n        setOutputAtIndex(index, uniforms.NAN);\n      } else {\n        setOutputAtIndex(index, s0);\n      }\n    }\n  }\n  `}}const On={kernelName:t.BroadcastArgs,backendName:"webgpu",kernelFunc:function(e){const{inputs:n,backend:i}=e,{s0:r,s1:s}=n;if(i.shouldExecuteOnCPU([r,s])){const e=i.tensorMap.get(r.dataId),n=i.tensorMap.get(s.dataId),a=e.values,o=n.values,u=t.backend_util.assertAndGetBroadcastShape(Array.from(a),Array.from(o));return i.makeTensorInfo([u.length],"int32",Int32Array.from(u))}const a=t.util.sizeFromShape(r.shape),o=t.util.sizeFromShape(s.shape),u=Math.max(a,o),l=new Bn(u),d=[{type:"int32",data:[a]},{type:"int32",data:[o]}];return i.runWebGPUProgram(l,[r,s],"int32",d)}},Un=be({opType:B.NOT_EQUAL,dtype:"bool",cpuKernelImpl:vt}),Mn={kernelName:t.NotEqual,backendName:"webgpu",kernelFunc:Un};function Vn(e){const{inputs:t,backend:n}=e,{input:i}=t;return pe({inputs:{x:n.tensorMap.get(i.dataId).complexTensorInfos.real},backend:n})}const Gn={kernelName:t.Real,backendName:"webgpu",kernelFunc:Vn};const Hn={kernelName:t.Cast,backendName:"webgpu",kernelFunc:function e(n){const{inputs:r,backend:s,attrs:a}=n,{x:o}=r,{dtype:u}=a;if("complex64"===u){if("complex64"===o.dtype)return pe({inputs:{x:o},backend:s});const t=i.zeros(o.shape),n=e({inputs:{x:o},backend:s,attrs:{dtype:"float32"}}),r=fe({inputs:{real:n,imag:t},backend:s});return t.dispose(),s.disposeData(n.dataId),r}if("complex64"===o.dtype){const t=Vn({inputs:{input:o},backend:s}),n=e({inputs:{x:t},backend:s,attrs:{dtype:u}});return s.disposeData(t.dataId),n}if(!t.util.hasEncodingLoss(o.dtype,u)){const e=pe({inputs:{x:o},backend:s});return{dataId:e.dataId,shape:e.shape,dtype:u}}if(s.shouldExecuteOnCPU([o])){const e=s.tensorMap.get(o.dataId).values,[t,n,i]=rt(e,o.shape,o.dtype,u);return s.makeTensorInfo(t,n,i)}if("int32"===u)return function(e,t){const n=new ge(e.shape,U.TO_INT),i=t.runWebGPUProgram(n,[e],"int32");return{dataId:i.dataId,shape:i.shape,dtype:i.dtype}}(o,s);if("bool"===u){const e=s.makeTensorInfo([],"bool",t.util.getTypedArrayFromDType("bool",1)),n=Un({inputs:{a:o,b:e},backend:s});return s.disposeData(e.dataId),n}throw new Error(`Error in Cast: failed to cast ${o.dtype} to ${u}`)}},Xn=xe({opType:U.CEIL,cpuKernelImpl:st}),Kn={kernelName:t.Ceil,backendName:"webgpu",kernelFunc:Xn};class qn{constructor(e){this.variableNames=["A"],this.uniforms="minVal : f32, maxVal : f32,",this.workPerThread=4,this.workgroupSize=[64,1,1],this.outputComponent=4,this.size=!0,this.outputShape=e,this.dispatchLayout=N(this.outputShape),this.dispatch=$(this.dispatchLayout,this.outputShape,this.workgroupSize,[this.workPerThread,1,1]),this.shaderKey="clipVec4"}getUserCode(){return`\n      ${x("index")} {\n        if(index < uniforms.size) {\n          let value = getAByOutputIndex(index);\n          var clampedValue = clamp(\n              value, vec4<f32>(uniforms.minVal), vec4<f32>(uniforms.maxVal));\n          clampedValue = select(clampedValue, value, isnanVec4(value));\n          setOutputAtIndex(index, clampedValue);\n        }\n      }\n    `}}class Yn{constructor(e){this.variableNames=["A"],this.uniforms="minVal : f32, maxVal : f32,",this.workgroupSize=[64,1,1],this.size=!0,this.outputShape=e,this.dispatchLayout=N(this.outputShape),this.dispatch=$(this.dispatchLayout,this.outputShape,this.workgroupSize),this.shaderKey="clip"}getUserCode(){return`\n      ${x("index")} {\n        if(index < uniforms.size) {\n          let value = getAByOutputIndex(index);\n          if (isnan(value)) {\n            setOutputAtIndex(index, value);\n            return;\n          }\n          setOutputAtIndex(index, clamp(value, uniforms.minVal, uniforms.maxVal));\n        }\n      }\n    `}}const jn={kernelName:t.ClipByValue,backendName:"webgpu",kernelFunc:function(e){const{inputs:n,backend:i,attrs:r}=e,{x:s}=n,{clipValueMin:a,clipValueMax:o}=r;let u;const l=[{type:"float32",data:[a]},{type:"float32",data:[o]}];return u=t.util.sizeFromShape(s.shape)%4==0?new qn(s.shape):new Yn(s.shape),i.runWebGPUProgram(u,[s],s.dtype,l)}};class Qn{constructor(e){this.outputShape=[],this.variableNames=["real","imag"],this.workgroupSize=[64,1,1],this.size=!0,this.outputShape=e,this.dispatchLayout=N(this.outputShape),this.dispatch=$(this.dispatchLayout,this.outputShape,this.workgroupSize),this.shaderKey="complexAbs"}getUserCode(){return`\n    ${x("index")} {\n      if (index < uniforms.size) {\n        let re = abs(getRealByOutputIndex(index));\n        let im = abs(getImagByOutputIndex(index));\n        let mx = max(re, im);\n\n        // The length function in wgsl may be not underflow-safe on some GPUs.\n        // So the safe solution is to ensure underflow-safety in all cases.\n        setOutputAtIndex(index, select(mx * length(vec2<f32>(1, min(re, im)/mx)), 0.0, mx == 0.0));\n      }\n    }\n  `}}function Zn(e,t){return{dataId:t.dataId,dtype:t.dtype,shape:e.shape}}const Jn={kernelName:t.ComplexAbs,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:n}=e,{x:i}=t,r=n.tensorMap.get(i.dataId),s=new Qn(i.shape),a=[Zn(i,r.complexTensorInfos.real),Zn(i,r.complexTensorInfos.imag)];return n.runWebGPUProgram(s,a,a[0].dtype)}};class ei{constructor(e){this.uniforms="",this.workPerThread=1,this.workgroupSize=[64,1,1],this.size=!0,this.outputShape=t.backend_util.computeOutShape(e,1),this.variableNames=e.map(((e,t)=>`T${t}`)),this.dispatchLayout=N(this.outputShape),this.dispatch=$(this.dispatchLayout,this.outputShape,this.workgroupSize,[this.workPerThread,1,1]),this.offsetLength=e.length-1;for(let e=0;e<this.offsetLength;e++)this.uniforms+=`offset${e} : i32,`;this.shaderKey="concat"}getUserCode(){const e=[];if(this.offsetLength>0){e.push("if (yC < uniforms.offset0){ setOutputAtCoords(coords.x, coords.y, getT0(yR, yC)); }");for(let t=1;t<this.offsetLength;t++)e.push(`else if (yC < uniforms.offset${[t]}){ setOutputAtCoords(coords.x, coords.y, getT${t}(yR, yC - uniforms.offset${t-1})); }`);const t=this.offsetLength,n=this.offsetLength-1;e.push(`else { setOutputAtCoords(coords.x, coords.y, getT${t}(yR, yC - uniforms.offset${n})); }`)}else e.push("setOutputAtCoords(coords.x, coords.y, getT0(yR, yC));");return`\n      ${x("index")} {\n        for(var i = 0; i < ${this.workPerThread}; i = i + 1) {\n          let flatIndex = index * ${this.workPerThread} + i;\n          if(flatIndex < uniforms.size) {\n            let coords = getCoordsFromIndex(flatIndex);\n            let yR = coords.x;\n            let yC = coords.y;\n\n            ${e.join("\n        ")}\n          }\n        }\n      }\n    `}}function ti(e){const{inputs:t,backend:n}=e,{input:i}=t;return pe({inputs:{x:n.tensorMap.get(i.dataId).complexTensorInfos.imag},backend:n})}const ni={kernelName:t.Imag,backendName:"webgpu",kernelFunc:ti};function ii(e,n,i){const r=e[0].dtype;if("complex64"===r){const t=e.map((e=>Vn({inputs:{input:e},backend:i}))),r=e.map((e=>ti({inputs:{input:e},backend:i}))),s=ii(t,n,i),a=ii(r,n,i),o=fe({inputs:{real:s,imag:a},backend:i});return t.forEach((e=>i.disposeData(e.dataId))),r.forEach((e=>i.disposeData(e.dataId))),i.disposeData(s.dataId),i.disposeData(a.dataId),o}let s=i.shouldExecuteOnCPU(e);if("string"===r&&(s=!0),s){const s=e.map((e=>{const r=t.util.sizeFromShape(e.shape.slice(n));return ae({inputs:{x:e},backend:i,attrs:{shape:[-1,r]}})})),a=s.map((e=>({vals:i.readSync(e.dataId),shape:e.shape}))),o=t.backend_util.computeOutShape(s.map((e=>e.shape)),1),u=1===s[0].shape[0],l=at(a,o,r,u),d=t.backend_util.computeOutShape(e.map((e=>e.shape)),n),h=i.makeTensorInfo(d,r,l);return s.forEach((e=>i.disposeData(e.dataId))),h}const a=i.device.limits.maxStorageBuffersPerShaderStage-1;if(e.length>a){const t=[];for(let r=0;r<e.length;r+=a){const s=e.slice(r,r+a);t.push(ii(s,n,i))}const r=ii(t,n,i);for(const e of t)i.disposeData(e.dataId);return r}const{tensors2D:o,outShape:u}=function(e,n,i){const r=t.backend_util.computeOutShape(e.map((e=>e.shape)),n);return{tensors2D:e.map((e=>ae({inputs:{x:e},backend:i,attrs:{shape:[t.util.sizeFromShape(e.shape.slice(0,n)),t.util.sizeFromShape(e.shape.slice(n))]}}))),outShape:r}}(e,n,i),l=o.map((e=>e.shape)),d=new ei(l),h=[],p=new Array(l.length-1);if(p.length>0){p[0]=l[0][1],h.push({type:"int32",data:[p[0]]});for(let e=1;e<p.length;e++)p[e]=p[e-1]+l[e][1],h.push({type:"int32",data:[p[e]]})}const c=i.runWebGPUProgram(d,o,o[0].dtype,h);o.forEach((e=>i.disposeData(e.dataId)));const f=ae({inputs:{x:c},backend:i,attrs:{shape:u}});return i.disposeData(c.dataId),f}function ri(e){const{inputs:n,backend:i,attrs:r}=e,{axis:s}=r,a=t.util.parseAxisParam(s,n[0].shape)[0],o=n.map((e=>e.shape));t.backend_util.assertParamsConsistent(o,a);const u=t.backend_util.computeOutShape(n.map((e=>e.shape)),a);if(0===t.util.sizeFromShape(u))return i.makeTensorInfo(u,n[0].dtype,[]);const l=n.filter((e=>t.util.sizeFromShape(e.shape)>0));return 1===l.length?pe({inputs:{x:l[0]},backend:i}):ii(l,a,i)}const si={kernelName:t.Concat,backendName:"webgpu",kernelFunc:ri};class ai{constructor(e,t,n,i,r=!1,s=null,a=!1,o=!1){this.variableNames=["x","W"],this.uniforms="filterDims : vec2<i32>, pads : vec2<i32>, strides : vec2<i32>, dilations : vec2<i32>, dimAOuter : i32, dimBOuter : i32, dimInner : i32,",this.outputShape=e.outShape,this.isChannelsLast="channelsLast"===e.dataFormat,this.isVec4=((e.inChannels%4==0||e.inChannels%3==0)&&this.isChannelsLast||e.outWidth%4==0&&!this.isChannelsLast)&&e.outChannels%4==0,this.dispatchLayout=this.isChannelsLast?{x:[3],y:[1,2],z:[0]}:{x:[2,3],y:[1],z:[0]},this.workgroupSize=A(this.dispatchLayout,this.outputShape,this.isVec4),this.elementsPerThread=z(this.dispatchLayout,this.outputShape,this.isVec4),this.dispatch=$(this.dispatchLayout,this.outputShape,this.workgroupSize,this.elementsPerThread),this.isVec4?(this.outputComponent=4,this.isChannelsLast&&e.inChannels%4!=0?(this.innerElementSize=3,this.variableComponents=[1,4]):(this.innerElementSize=4,this.variableComponents=[4,4]),r&&(this.variableNames.push("bias"),this.variableComponents.push(4)),a&&(this.variableNames.push("preluActivationWeights"),this.variableComponents.push(4))):(this.innerElementSize=this.elementsPerThread[0],r&&this.variableNames.push("bias"),a&&this.variableNames.push("preluActivationWeights")),this.sequentialAccessByThreads=o,this.addBias=r,this.activation=s,this.hasPreluActivationWeights=a,this.tileAOuter=this.workgroupSize[1]*this.elementsPerThread[1],this.tileBOuter=this.workgroupSize[0]*this.elementsPerThread[0],this.tileInner=Math.max(this.workgroupSize[0]*this.innerElementSize,this.workgroupSize[1]),this.fitAOuter=t%this.tileAOuter==0,this.fitBOuter=n%this.tileBOuter==0,this.fitInner=i%this.tileInner==0,this.shaderKey=`conv2DMM_${this.elementsPerThread}_${this.activation}}_${this.fitAOuter}_${this.fitBOuter}_${this.fitInner}_${this.isVec4}_${this.innerElementSize}_${this.isChannelsLast}_${this.sequentialAccessByThreads}`}getUserCode(){const e=this.isVec4?Y(this.elementsPerThread,this.workgroupSize,!this.isChannelsLast,this.tileInner):Q(this.elementsPerThread,this.workgroupSize,!this.isChannelsLast,this.tileInner,!1,null,this.sequentialAccessByThreads),t=this.isVec4?[this.innerElementSize,4,4]:[1,1,1];return`\n    ${function(e,t,n,i,r=!1,s=null,a=!1,o=4,u=4,l=4){const d=e?"\n      let coord = vec4<i32>(batch, xRow, xCol, xCh);\n      ":"\n      let coord = vec4<i32>(batch, xCh, xRow, xCol);\n      ",h=e?"\n      let coords = vec4<i32>(\n        batch,\n        row / outWidth,\n        row % outWidth,\n        col);\n      ":"\n      let coords = vec4<i32>(\n        batch,\n        row,\n        col / outWidth,\n        col % outWidth);\n      ",p=e?"uniforms.xShape[1]":"uniforms.xShape[2]",c=e?"uniforms.xShape[2]":"uniforms.xShape[3]",m=e?"row":"col",g=e?"col":"row",x=`\n      let inChannels = uniforms.wShape[2];\n      let outWidth = ${e?"uniforms.outShape[2]":"uniforms.outShape[3]"};\n      let outRow = ${m} / outWidth;\n      let outCol = ${m} % outWidth;\n\n      let WRow = ${g} / (uniforms.filterDims[1] * inChannels);\n      let WCol = ${g} / inChannels % uniforms.filterDims[1];\n      let xRow = outRow * uniforms.strides[0] + uniforms.dilations[0] * WRow - uniforms.pads[0];\n      let xCol = outCol * uniforms.strides[1] + uniforms.dilations[1] * WCol - uniforms.pads[1];\n      let xCh = ${g} % inChannels;\n      var resData = ${f(o)}(0.0);\n      // The bounds checking is always needed since we use it to pad zero for\n      // the 'same' padding type.\n      if (xRow >= 0 && xRow < ${p} && xCol >= 0 && xCol < ${c}) {\n        ${d}\n        let xIndex = getIndexFromCoords4D(coord, uniforms.xShape);\n        ${(e=>{switch(e){case 1:return"resData = x[xIndex];";case 3:return"resData = vec3<f32>(x[xIndex], x[xIndex + 1], x[xIndex + 2]);";case 4:return"resData = x[xIndex / 4];";default:throw new Error(`innerElementSize ${e} is not supported.`)}})(o)}\n      }\n      return resData;`,b=e?t&&i?`\n      let col = colIn * ${o};\n      ${x}`:`\n      let col = colIn * ${o};\n      if (row < uniforms.dimAOuter && col < uniforms.dimInner) {\n        ${x}\n      }\n      return ${f(o)}(0.0);`:i&&n?`\n      let col = colIn * ${o};\n      ${x}`:`\n      let col = colIn * ${o};\n      if (row < uniforms.dimInner && col < uniforms.dimBOuter) {\n        ${x}\n      }\n      return ${f(o)}(0.0);`,y=`${(e=>{switch(e){case 1:return"return W[row * uniforms.wShape[3] + colIn];";case 4:return"return W[row * uniforms.wShape[3] / 4 + colIn];";default:throw new Error(`innerElementSize ${e} is not supported.`)}})(u)}`,w=f(l),C=f(e?o:u),k=f(e?u:o);return`\n      ${H(s,a,4===l,4)}\n      fn mm_readA(batch: i32, row : i32, colIn : i32) -> ${C} {\n        ${e?b:y}\n      }\n\n      fn mm_readB(batch: i32, row : i32, colIn : i32) -> ${k} {\n        ${e?y:b}\n      }\n\n      fn mm_write(batch: i32, row : i32, colIn : i32, valueIn : ${w}) {\n        let col = colIn * ${l};\n        if (row < uniforms.dimAOuter && col < uniforms.dimBOuter)\n        {\n        var value = valueIn;\n        let outWidth = ${e?"uniforms.outShape[2]":"uniforms.outShape[3]"};\n        ${h}\n        ${X(r,s)}\n        setOutputAtCoords(coords[0], coords[1], coords[2], coords[3], value);\n        }\n      }`}(this.isChannelsLast,this.fitAOuter,this.fitBOuter,this.fitInner,this.addBias,this.activation,this.hasPreluActivationWeights,t[0],t[1],t[2])}\n    ${e}\n  `}}class oi{constructor(e,t=!1,n=null,i=!1){this.variableNames=["x","W"],this.uniforms="filterDims: vec2<i32>, pads: vec2<i32>, strides: vec2<i32>, dilations: vec2<i32>,",this.workgroupSize=[4,4,8],this.outputShape=e.outShape,this.isChannelsLast="channelsLast"===e.dataFormat,this.dispatchLayout=this.isChannelsLast?{x:[2],y:[1],z:[0,3]}:{x:[3],y:[2],z:[0,1]},this.dispatch=$(this.dispatchLayout,this.outputShape,this.workgroupSize),this.addBias=t,this.activation=n,this.hasPreluActivationWeights=i,t&&this.variableNames.push("bias"),i&&this.variableNames.push("preluActivationWeights"),this.shaderKey=`conv2dnaive_${this.activation}_${this.isChannelsLast}`}getUserCode(){return`\n       ${H(this.activation,this.hasPreluActivationWeights,!1,4)}\n       fn readInp(batch : i32, row : i32, col : i32, chan : i32) -> f32{\n         let coords = vec4<i32>(batch, row, col, chan);\n         if (coordsInBounds4D(coords, uniforms.xShape)) {\n           return  getX(batch, row, col, chan);\n         } else {\n          return 0.0;\n         }\n       }\n       fn readFilt(row : i32, col : i32, xChannel : i32, outChannel : i32) -> f32{\n         let coords = vec4<i32>(row, col, xChannel, outChannel);\n         if(coordsInBounds4D(coords, uniforms.wShape)) {\n           return getW(row, col, xChannel, outChannel);\n          } else {\n            return 0.0;\n          }\n       }\n       fn writeResult(batch : i32, row : i32, col : i32, chan : i32, valueIn : f32) {\n         let coords = ${this.isChannelsLast?"vec4<i32>(batch, row, col, chan);":"vec4<i32>(batch, chan, row, col);"}\n         if (coordsInBounds4D(coords, uniforms.outShape)) {\n           var value = valueIn;\n           ${X(this.addBias,this.activation)}\n           setOutputAtCoords(coords.x, coords.y, coords.z, coords.w, value);\n         }\n       }\n       ${x("index")} {\n         let coords = getOutputCoords();\n         let batch = coords[0];\n         let outChannel = ${this.isChannelsLast?"coords[3];":"coords[1];"}\n         let outRow = ${this.isChannelsLast?"coords[1];":"coords[2];"}\n         let outCol = ${this.isChannelsLast?"coords[2];":"coords[3];"}\n         var acc : f32 = 0.0;\n         for (var row = 0; row < uniforms.filterDims[0]; row = row + 1) {\n           for (var col = 0; col < uniforms.filterDims[1]; col = col + 1) {\n             let xRow = outRow * uniforms.strides[0] + uniforms.dilations[0] * row - uniforms.pads[0];\n             let xCol = outCol * uniforms.strides[1] + uniforms.dilations[1] * col - uniforms.pads[1];\n             for (var xChannel = 0; xChannel < ${this.isChannelsLast?"uniforms.xShape[3];":"uniforms.xShape[1];"} xChannel = xChannel + 1) {\n               ${this.isChannelsLast?"let v = readInp(batch, xRow, xCol, xChannel);":"let v = readInp(batch, xChannel, xRow, xCol);"}\n               let f = readFilt(row, col, xChannel, outChannel);\n               acc = acc + v * f;\n             }\n           }\n         }\n         writeResult(batch, outRow, outCol, outChannel, acc);\n       }\n     `}}class ui{constructor(e,t){this.variableNames=["x"],this.uniforms="pads : vec2<i32>, strides : vec2<i32>, dilations : vec2<i32>, outWidth : i32, itemsPerBlockRow : i32,\n       inChannels : i32,",this.workgroupSize=[64,1,1],this.size=!0,this.outputShape=e,this.dispatchLayout=N(this.outputShape),this.dispatch=$(this.dispatchLayout,this.outputShape,this.workgroupSize),this.isChannelsLast=t,this.shaderKey=`im2col_${this.isChannelsLast}`}getUserCode(){const e=this.isChannelsLast?1:2,t=this.isChannelsLast?2:3,n=this.isChannelsLast?"coords[1]":"coords[2]",i=this.isChannelsLast?"coords[2]":"coords[1]",r=this.isChannelsLast?"getX(batch, xRow, xCol, ch)":"getX(batch, ch, xRow, xCol)";return`\n    ${x("index")} {\n      let coords = getCoordsFromIndex(index);\n      if(index < uniforms.size) {\n        let batch = coords[0];\n        let row = ${n};\n        let col = ${i};\n        let offsetY = (row / uniforms.outWidth) * uniforms.strides[0] - uniforms.pads[0];\n        let xRow = offsetY + uniforms.dilations[0] * (col / uniforms.itemsPerBlockRow);\n        var value = 0.0;\n        if(xRow < uniforms.xShape[${e}] && xRow >= 0) {\n          let offsetX = (row % uniforms.outWidth) * uniforms.strides[1] -\n              uniforms.pads[1];\n          let xCol = offsetX + uniforms.dilations[1] * ((col %\n              uniforms.itemsPerBlockRow) / uniforms.inChannels);\n          let ch = col % uniforms.inChannels;\n          if(xCol < uniforms.xShape[${t}] && xCol >= 0) {\n            value = ${r};\n          }\n        }\n        setOutputAtIndex(index, value);\n      }\n    }\n   `}}function li(e,t){const n=e.length;return n>=3?t?[...e.slice(0,-3),e[n-3]*e[n-2],e[n-1]]:[...e.slice(0,-3),e[n-3],e[n-2]*e[n-1]]:!t&&1===n&&e[0]>1?[e[0],1]:null}function di({x:e,filter:n,convInfo:i,backend:r,bias:s=null,preluActivationWeights:a=null,leakyreluAlpha:o=0,activation:u=null}){const l=null!=s,d=null!=a,h="channelsLast"===i.dataFormat,p=h&&i.filterHeight===i.inHeight&&i.filterWidth===i.inWidth&&"VALID"===i.padInfo.type,c=t.env().getBool("WEBGPU_USE_NAIVE_CONV2D_DEBUG");if(!c&&(p||1===i.filterHeight&&1===i.filterWidth&&1===i.dilationHeight&&1===i.dilationWidth&&1===i.strideHeight&&1===i.strideWidth&&("SAME"===i.padInfo.type||"VALID"===i.padInfo.type)))return function({x:e,filter:t,convInfo:n,backend:i,bias:r=null,preluActivationWeights:s=null,leakyreluAlpha:a=0,activation:o=null}){const u="channelsLast"===n.dataFormat,l=!u,d=[];let h,p;if(u&&n.filterHeight===n.inHeight&&n.filterWidth===n.inWidth&&"VALID"===n.padInfo.type){const r=n.inHeight*n.inWidth*n.inChannels;h=ae({inputs:{x:e},backend:i,attrs:{shape:[1,n.batchSize,r]}}),p=ae({inputs:{x:t},backend:i,attrs:{shape:[1,r,n.outChannels]}})}else h=ae({inputs:{x:e},backend:i,attrs:{shape:u?[n.batchSize,n.inHeight*n.inWidth,n.inChannels]:[n.batchSize,n.inChannels,n.inHeight*n.inWidth]}}),p=ae({inputs:{x:t},backend:i,attrs:{shape:[1,n.inChannels,n.outChannels]}});if(d.push(h),d.push(p),null!=s){const e=li(s.shape,u);null!=e&&(s=ae({inputs:{x:s},backend:i,attrs:{shape:e}}),d.push(s))}if(null!=r){const e=li(r.shape,u);null!=e&&(r=ae({inputs:{x:r},backend:i,attrs:{shape:e}}),d.push(r))}const c=ue({a:u?h:p,b:u?p:h,transposeA:l,transposeB:!1,backend:i,bias:r,activation:o,preluActivationWeights:s,leakyreluAlpha:a}),f=ae({inputs:{x:c},backend:i,attrs:{shape:n.outShape}});d.push(c);for(const e of d)i.disposeData(e.dataId);return f}({x:e,filter:n,convInfo:i,backend:r,bias:s,activation:u,preluActivationWeights:a,leakyreluAlpha:o});const f=t.env().getNumber("WEBGPU_THRESHOLD_TO_INCREASE_WORKGROUPS_FOR_MATMUL"),m=f>0?f:r.thresholdToIncreaseWorkgroups,g=i.batchSize*Math.ceil(i.outHeight*i.outWidth/32)*Math.ceil(i.outChannels/32);if(t.env().getBool("WEBGPU_CONV_SEPARATE_IM2COL_SHADER")||g<=m)return function({x:e,filter:t,convInfo:n,backend:i,bias:r=null,preluActivationWeights:s=null,leakyreluAlpha:a=0,activation:o=null}){const{filterWidth:u,filterHeight:l,inChannels:d,strideWidth:h,strideHeight:p,padInfo:c,outWidth:f,outHeight:m,dilationWidth:g,dilationHeight:x,dataFormat:b}=n,y="channelsLast"===b,w=u*l*d,C=m*f,k=y?[n.batchSize,C,w]:[n.batchSize,w,C],S=new ui(k,y),v=[{type:"int32",data:[c.top,c.left]},{type:"int32",data:[p,h]},{type:"int32",data:[x,g]},{type:"int32",data:[f]},{type:"int32",data:[d*u]},{type:"int32",data:[d]}],I=i.runWebGPUProgram(S,[e],e.dtype,v),R=[];R.push(I);const $=ae({inputs:{x:t},backend:i,attrs:{shape:[1,w,-1]}});if(R.push($),null!=s){const e=li(s.shape,y);null!=e&&(s=ae({inputs:{x:s},backend:i,attrs:{shape:e}}),R.push(s))}if(null!=r){const e=li(r.shape,y);null!=e&&(r=ae({inputs:{x:r},backend:i,attrs:{shape:e}}),R.push(r))}const P=ue({a:y?I:$,b:y?$:I,transposeA:!y,transposeB:!1,backend:i,bias:r,activation:o,preluActivationWeights:s,leakyreluAlpha:a}),A=ae({inputs:{x:P},backend:i,attrs:{shape:n.outShape}});R.push(P);for(const e of R)i.disposeData(e.dataId);return A}({x:e,filter:n,convInfo:i,backend:r,bias:s,preluActivationWeights:a,leakyreluAlpha:o,activation:u});let x;const b=[i.padInfo.top,i.padInfo.left],y=[{type:"int32",data:[i.filterHeight,i.filterWidth]},{type:"int32",data:[...b]},{type:"int32",data:[i.strideHeight,i.strideWidth]},{type:"int32",data:[i.dilationHeight,i.dilationWidth]}];if(c)x=new oi(i,l,u,d);else{const e=h?i.outHeight*i.outWidth:i.outChannels,t=h?i.outChannels:i.outHeight*i.outWidth,n=i.filterHeight*i.filterWidth*i.inChannels;y.push({type:"int32",data:[e]},{type:"int32",data:[t]},{type:"int32",data:[n]});const s=r.adapterInfo.isIntel();x=new ai(i,e,t,n,l,u,d,s)}const w=[],C=[e,n];l&&(h||1!==s.shape.length||(s=ae({inputs:{x:s},backend:r,attrs:{shape:[s.shape[0],1,1]}}),w.push(s)),C.push(s)),d&&(h||1!==a.shape.length||(a=ae({inputs:{x:a},backend:r,attrs:{shape:[a.shape[0],1,1]}}),w.push(a)),C.push(a)),"leakyrelu"===u&&(y.push({type:"float32",data:[o]}),x.uniforms+=" alpha : f32,");const k=r.runWebGPUProgram(x,C,e.dtype,y);for(const e of w)r.disposeData(e.dataId);return k}const hi={kernelName:t.Conv2D,backendName:"webgpu",kernelFunc:function(e){const{inputs:n,attrs:i,backend:r}=e,{x:s,filter:a}=n,{strides:o,pad:u,dataFormat:l,dilations:d,dimRoundingMode:h}=i,p=t.backend_util.convertConv2DDataFormat(l);return di({x:s,filter:a,convInfo:t.backend_util.computeConv2DInfo(s.shape,a.shape,o,d,u,h,!1,p),backend:r})}};class pi{constructor(e){this.variableNames=["dy","W"],this.uniforms="filterDims : vec2<i32>, pads : vec2<i32>, strides : vec2<i32>, outBackprop : vec4<i32>,",this.workgroupSize=[64,1,1],this.size=!1,this.isVec4=!1,this.workPerThread=1,this.outputShape=e.inShape,this.isChannelsLast="channelsLast"===e.dataFormat,this.isVec4=this.isChannelsLast&&e.outChannels%4==0&&e.inChannels%4==0,this.isVec4?(this.workPerThread=2,this.outputComponent=4,this.workgroupSize=[4,4,4],this.dispatchLayout={x:[3],y:[2],z:[0,1]},this.dispatch=$(this.dispatchLayout,this.outputShape,this.workgroupSize,[4,this.workPerThread,1])):(this.size=!0,this.workPerThread=1,this.workgroupSize=[64,1,1],this.dispatchLayout=N(this.outputShape),this.dispatch=$(this.dispatchLayout,this.outputShape,this.workgroupSize)),this.shaderKey=`conv2DDerInput_${this.isChannelsLast}_${this.isVec4}_${this.workPerThread}`}getUserCode(){const e=this.isChannelsLast?1:2,t=this.isChannelsLast?2:3,n=this.isChannelsLast?3:1,i=`\n    ${x()} {\n      let batch = i32(globalId.z) / uniforms.outShape[1];\n      let r = i32(globalId.z) % uniforms.outShape[1];\n      let c = i32(globalId.y) * ${this.workPerThread};\n      let d1 = i32(globalId.x) * 4;\n\n      let dyCorner = vec2<i32>(r, c) - uniforms.pads;\n\n      // Convolve dy(?, ?, d2) with w(:, :, d1, d2) to compute dx(xR, xC, d1).\n      // ? = to be determined. : = across all values in that axis.\n      var dotProd: array<vec4<f32>, ${this.workPerThread}>;\n      for (var i = 0; i < ${this.workPerThread}; i++) {\n        dotProd[i] = vec4<f32>(0.0);\n      }\n      for (var wR = 0; wR < uniforms.filterDims.x; wR = wR + 1) {\n        let dyR = f32(dyCorner.x + wR) / f32(uniforms.strides.x);\n        let wRPerm = uniforms.filterDims.x - 1 - wR;\n        if (dyR < 0.0 || dyR >= f32(uniforms.outBackprop[1]) ||\n            fract(dyR) > 0.0) {\n          continue;\n        }\n        let idyR = i32(dyR);\n\n        for (var wC = 0; wC < uniforms.filterDims.y; wC = wC + 1) {\n          let dyC = f32(dyCorner.y + wC) / f32(uniforms.strides.y);\n          let dyC2 = f32(dyCorner.y + 1 + wC) / f32(uniforms.strides.y);\n          let wCPerm = uniforms.filterDims.y - 1 - wC;\n          var bDyCVal = true;\n          var bDyCVal2 = true;\n          if (dyC < 0.0 || dyC >= f32(uniforms.outBackprop[2]) ||\n              fract(dyC) > 0.0) {\n            bDyCVal = false;\n          }\n          if (dyC2 < 0.0 || dyC2 >= f32(uniforms.outBackprop[2]) ||\n              fract(dyC2) > 0.0) {\n            bDyCVal2 = false;\n          }\n\n          let idyC = i32(dyC);\n          let idyC2 = i32(dyC2);\n          if (bDyCVal && bDyCVal2) {\n            let d2Length = uniforms.outBackprop[3];\n            for (var d2 = 0; d2 < d2Length; d2 = d2 + 4) {\n              let wValue0 = getW(wRPerm, wCPerm, d1, d2);\n              let wValue1 = getW(wRPerm, wCPerm, d1 + 1, d2);\n              let wValue2 = getW(wRPerm, wCPerm, d1 + 2, d2);\n              let wValue3 = getW(wRPerm, wCPerm, d1 + 3, d2);\n              var xValue =  getDy(batch, idyR, idyC, d2);\n              let tmpval = vec4<f32>(dot(xValue, wValue0),\n                                     dot(xValue, wValue1),\n                                     dot(xValue, wValue2),\n                                     dot(xValue, wValue3));\n              dotProd[0] = dotProd[0] + tmpval;\n              xValue = getDy(batch, idyR, idyC2, d2);\n              dotProd[1] = dotProd[1] + vec4<f32>(dot(xValue, wValue0),\n                                                  dot(xValue, wValue1),\n                                                  dot(xValue, wValue2),\n                                                  dot(xValue, wValue3));\n            }\n          } else if (bDyCVal) {\n            let d2Length = uniforms.outBackprop[3];\n            for (var d2 = 0; d2 < d2Length; d2 = d2 + 4) {\n              let wValue0 = getW(wRPerm, wCPerm, d1, d2);\n              let wValue1 = getW(wRPerm, wCPerm, d1 + 1, d2);\n              let wValue2 = getW(wRPerm, wCPerm, d1 + 2, d2);\n              let wValue3 = getW(wRPerm, wCPerm, d1 + 3, d2);\n              var xValue =  getDy(batch, idyR, idyC, d2);\n              let tmpval = vec4<f32>(dot(xValue, wValue0),\n                                     dot(xValue, wValue1),\n                                     dot(xValue, wValue2),\n                                     dot(xValue, wValue3));\n              dotProd[0] = dotProd[0] + tmpval;\n            }\n          } else if (bDyCVal2) {\n            let d2Length = uniforms.outBackprop[3];\n            for (var d2 = 0; d2 < d2Length; d2 = d2 + 4) {\n              let wValue0 = getW(wRPerm, wCPerm, d1, d2);\n              let wValue1 = getW(wRPerm, wCPerm, d1 + 1, d2);\n              let wValue2 = getW(wRPerm, wCPerm, d1 + 2, d2);\n              let wValue3 = getW(wRPerm, wCPerm, d1 + 3, d2);\n              var xValue =  getDy(batch, idyR, idyC2, d2);\n              let tmpval = vec4<f32>(dot(xValue, wValue0),\n                                     dot(xValue, wValue1),\n                                     dot(xValue, wValue2),\n                                     dot(xValue, wValue3));\n              dotProd[1] = dotProd[1] + tmpval;\n            }\n          }\n        }\n      }\n\n      for (var i = 0; i < ${this.workPerThread}; i = i + 1) {\n        let coords = vec4<i32>(batch, r, c + i, d1);\n        if (coordsInBounds4D(coords, uniforms.outShape)) {\n          setOutputAtCoords(coords[0], coords[1], coords[2], coords[3], dotProd[i]);\n        }\n      }\n    }\n    `;return this.isVec4?`\n    ${i}\n    `:`\n    ${x("index")} {\n      if(index < uniforms.size) {\n        let coords = getCoordsFromIndex(index);\n        let batch = coords[0];\n        let d1 = coords[${n}];\n\n        let dyCorner = vec2<i32>(coords[${e}], coords[${t}]) - uniforms.pads;\n        let dyRCorner = dyCorner.x;\n        let dyCCorner = dyCorner.y;\n\n        // Convolve dy(?, ?, d2) with w(:, :, d1, d2) to compute dx(xR, xC, d1).\n        // ? = to be determined. : = across all values in that axis.\n        var dotProd = 0.0;\n        for (var wR = 0; wR < uniforms.filterDims.x; wR = wR + 1) {\n          let dyR = (f32(dyRCorner) + f32(wR)) / f32(uniforms.strides.x);\n          let wRPerm = uniforms.filterDims.x - 1 - wR;\n          if (dyR < 0.0 || dyR >= f32(uniforms.outBackprop[1]) || fract(dyR) > 0.0 ||\n              wRPerm < 0) {\n            continue;\n          }\n          let idyR = i32(dyR);\n\n          for (var wC = 0; wC < uniforms.filterDims.y; wC = wC + 1) {\n            let dyC = (f32(dyCCorner) + f32(wC)) / f32(uniforms.strides.y);\n            let wCPerm = uniforms.filterDims.y - 1 - wC;\n            if (dyC < 0.0 || dyC >= f32(uniforms.outBackprop[2]) ||\n                fract(dyC) > 0.0 || wCPerm < 0) {\n              continue;\n            }\n            let idyC = i32(dyC);\n\n            for (var d2 = 0; d2 < uniforms.outBackprop[3]; d2 = d2 + 1) {\n              let xValue = ${this.isChannelsLast?"getDy(batch, idyR, idyC, d2)":"getDy(batch, d2, idyR, idyC)"};\n              let wValue = getW(wRPerm, wCPerm, d1, d2);\n              dotProd = dotProd + xValue * wValue;\n            }\n          }\n        }\n        setOutputAtIndex(index, dotProd);\n      }\n    }\n  `}}class ci{constructor(e){this.variableNames=["x","dy"],this.uniforms="pads : vec2<i32>, strides : vec2<i32>, batchSize : i32, outHeight : i32, outWidth : i32, inHeight : i32, inWidth : i32,",this.workgroupSize=[64,1,1],this.size=!0,this.outputShape=e.filterShape,this.dispatchLayout=N(this.outputShape),this.dispatch=$(this.dispatchLayout,this.outputShape,this.workgroupSize),this.isChannelsLast="channelsLast"===e.dataFormat,this.shaderKey=`conv2DDerFilter_${this.isChannelsLast}`}getUserCode(){return`\n    ${x("index")} {\n      if(index < uniforms.size) {\n        let coords = getCoordsFromIndex(index);\n        let wR = coords[0];\n        let wC = coords[1];\n        let d1 = coords[2];\n        let d2 = coords[3];\n\n        // Convolve x(?, ?, d1) with dy(:, :, d2) to get dw(wR, wC, d1, d2).\n        // ? = to be determined. : = across all values in that axis.\n        var dotProd = 0.0;\n        for (var b = 0; b < uniforms.batchSize; b = b + 1) {\n          for (var yR = 0; yR < uniforms.outHeight; yR = yR + 1) {\n            let xR = wR + yR * uniforms.strides[0] - uniforms.pads[0];\n            if (xR < 0 || xR >= uniforms.inHeight) {\n              continue;\n            }\n\n            for (var yC = 0; yC < uniforms.outWidth; yC = yC + 1) {\n              let xC = wC + yC * uniforms.strides[1] - uniforms.pads[1];\n\n              if (xC < 0 || xC >= uniforms.inWidth) {\n                continue;\n              }\n\n              if (${this.isChannelsLast}) {\n                let dyValue = getDy(b, yR, yC, d2);\n                let xValue = getX(b, xR, xC, d1);\n                dotProd = dotProd + xValue * dyValue;\n              } else {\n                let dyValue = getDy(b, d2, yR, yC);\n                let xValue = getX(b, d1, xR, xC);\n                dotProd = dotProd + xValue * dyValue;\n              }\n            }\n          }\n        }\n        setOutputAtIndex(index, dotProd);\n      }\n    }\n  `}}class fi{constructor(e){this.variableNames=["x","dy"],this.uniforms="pads : vec3<i32>, strides : vec3<i32>, batchSize : i32, outDepth : i32,\n       outHeight : i32, outWidth : i32, inDepth : i32, inHeight : i32, inWidth : i32,",this.workgroupSize=[64,1,1],this.size=!0,this.outputShape=e.filterShape,this.dispatchLayout=N(this.outputShape),this.dispatch=$(this.dispatchLayout,this.outputShape,this.workgroupSize),this.shaderKey="conv3DDerFilter"}getUserCode(){return`\n    ${x("index")} {\n      if(index < uniforms.size) {\n        let coords = getCoordsFromIndex(index);\n        let wF = coords.x;\n        let wR = coords.y;\n        let wC = coords.z;\n        let d1 = coords.w;\n        let d2 = coords.u;\n\n        var dotProd = 0.0;\n        for (var b = 0; b < uniforms.batchSize; b++) {\n          for (var yF = 0; yF < uniforms.outDepth; yF++) {\n            let xF = wF + yF * uniforms.strides[0] - uniforms.pads[0];\n            if (xF < 0 || xF >= uniforms.inDepth) {\n              continue;\n            }\n\n            for (var yR = 0; yR < uniforms.outHeight; yR++) {\n              let xR = wR + yR * uniforms.strides[1] - uniforms.pads[1];\n              if (xR < 0 || xR >= uniforms.inHeight) {\n                continue;\n              }\n\n              for (var yC = 0; yC < uniforms.outWidth; yC++) {\n                let xC = wC + yC * uniforms.strides[2] - uniforms.pads[2];\n                if (xC < 0 || xC >= uniforms.inWidth) {\n                  continue;\n                }\n\n                let dyValue = getDy(b, yF, yR, yC, d2);\n                let xValue = getX(b, xF, xR, xC, d1);\n                dotProd += xValue * dyValue;\n              }\n            }\n          }\n        }\n        setOutputAtIndex(index, dotProd);\n      }\n    }\n  `}}class mi{constructor(e){this.variableNames=["dy","W"],this.uniforms="filterDims : vec3<i32>, pads : vec3<i32>, strides : vec3<i32>,\n      outDepth : i32, outHeight : i32, outWidth : i32, outChannels : i32,",this.workgroupSize=[64,1,1],this.size=!0,this.outputShape=e.inShape,this.dispatchLayout=N(this.outputShape),this.dispatch=$(this.dispatchLayout,this.outputShape,this.workgroupSize),this.shaderKey="conv3DDerInput"}getUserCode(){return`\n    ${x("index")} {\n      if(index < uniforms.size) {\n        let coords = getCoordsFromIndex(index);\n        let batch = coords.x;\n        let d1 = coords.u;\n\n        let dyCorner = vec3<i32>(coords.y, coords.z, coords.w) - uniforms.pads;\n        let dyFCorner = dyCorner.x;\n        let dyRCorner = dyCorner.y;\n        let dyCCorner = dyCorner.z;\n\n        var dotProd = 0.0;\n        for (var wF = 0; wF < uniforms.filterDims[0]; wF++) {\n          let dyF = f32(dyFCorner + wF) / f32(uniforms.strides[0]);\n          if (dyF < 0.0 || dyF >= f32(uniforms.outDepth) || fract(dyF) > 0.0) {\n            continue;\n          }\n          let idyF = i32(dyF);\n\n          let wFPerm = uniforms.filterDims[0] - 1 - wF;\n\n          for (var wR = 0; wR < uniforms.filterDims[1]; wR++) {\n            let dyR = f32(dyRCorner + wR) / f32(uniforms.strides[1]);\n\n            if (dyR < 0.0 || dyR >= f32(uniforms.outHeight) || fract(dyR) > 0.0) {\n              continue;\n            }\n            let idyR = i32(dyR);\n\n            let wRPerm = uniforms.filterDims[1] - 1 - wR;\n\n            for (var wC = 0; wC < uniforms.filterDims[2]; wC++) {\n              let dyC = f32(dyCCorner + wC) / f32(uniforms.strides[2]);\n\n              if (dyC < 0.0 || dyC >= f32(uniforms.outWidth) || fract(dyC) > 0.0) {\n                continue;\n              }\n              let idyC = i32(dyC);\n\n              let wCPerm = uniforms.filterDims[2] - 1 - wC;\n\n              for (var d2 = 0; d2 < uniforms.outChannels; d2++) {\n                let xValue = getDy(batch, idyF, idyR, idyC, d2);\n                let wValue = getW(wFPerm, wRPerm, wCPerm, d1, d2);\n                dotProd += xValue * wValue;\n              }\n            }\n          }\n        }\n        setOutputAtIndex(index, dotProd);\n      }\n    }\n  `}}const gi={kernelName:t.Conv2DBackpropFilter,backendName:"webgpu",kernelFunc:function(e){const{inputs:n,backend:i,attrs:r}=e,{x:s,dy:a}=n,{strides:o,pad:u,dataFormat:l,dimRoundingMode:d,filterShape:h}=r,p=t.backend_util.convertConv2DDataFormat(l),c=t.backend_util.computeConv2DInfo(s.shape,h,o,1,u,d,!1,p),f=new ci(c),m=[{type:"int32",data:[c.padInfo.top,c.padInfo.left]},{type:"int32",data:[c.strideHeight,c.strideWidth]},{type:"int32",data:[c.batchSize]},{type:"int32",data:[c.outHeight]},{type:"int32",data:[c.outWidth]},{type:"int32",data:[c.inHeight]},{type:"int32",data:[c.inWidth]}];return i.runWebGPUProgram(f,[s,a],s.dtype,m)}};class xi{constructor(e){this.variableNames=["x","W"],this.uniforms="filterDims : vec2<i32>, pads : vec2<i32>, strides : vec2<i32>, outBackprop : vec4<i32>, dimAOuter : i32, dimBOuter : i32, dimInner : i32,",this.outputShape=e.inShape,t.util.assert("channelsLast"===e.dataFormat,(()=>"TODO: NCHW is unimplemented")),this.isVec4=e.inChannels%4==0&&e.outChannels%4==0,this.dispatchLayout={x:[3],y:[1,2],z:[0]},this.workgroupSize=A(this.dispatchLayout,this.outputShape,this.isVec4),this.elementsPerThread=z(this.dispatchLayout,this.outputShape,this.isVec4),this.dispatch=$(this.dispatchLayout,this.outputShape,this.workgroupSize,this.elementsPerThread),this.isVec4&&(this.outputComponent=4,this.variableComponents=[4,1]),this.shaderKey=`conv2DDerInputMM_${this.isVec4}_${this.elementsPerThread}`}getUserCode(){const e=this.isVec4?Y(this.elementsPerThread,this.workgroupSize):Q(this.elementsPerThread,this.workgroupSize);return`\n    ${function(e=4){const t=`if (row < uniforms.dimAOuter && col < uniforms.dimInner) {\n        \n      let outRow = row / uniforms.outShape[2];\n      let outCol = row % uniforms.outShape[2];\n\n      let WRow = col / (uniforms.filterDims[1] * uniforms.outBackprop[3]);\n      let WCol = col / uniforms.outBackprop[3] % uniforms.filterDims[1];\n      let xR = f32(outRow - uniforms.pads[0] + WRow) / f32(uniforms.strides[0]);\n      let xC = f32(outCol - uniforms.pads[1] + WCol) / f32(uniforms.strides[1]);\n      if (xR < 0.0 || xR >= f32(uniforms.outBackprop[1]) || fract(xR) > 0.0) {\n        return ${f(e)}(0.0);\n      }\n      if (xC < 0.0 || xC >= f32(uniforms.outBackprop[2]) || fract(xC) > 0.0) {\n        return ${f(e)}(0.0);\n      }\n      let coord = vec4<i32>(\n          batch,\n          i32(xR),\n          i32(xC),\n          col % uniforms.outBackprop[3]);\n      return x[getIndexFromCoords4D(coord, uniforms.xShape)/${e}];\n      }\n      return ${f(e)}(0.0);`;return`\n  fn mm_readA(batch: i32, row : i32, colIn : i32) -> ${f(e)} {\n    let col = colIn * ${e};\n    ${t}\n  }\n\n  fn mm_readB(batch: i32, row : i32, colIn : i32) -> ${f(e)} {\n    let col = colIn * ${e};\n    let coordX = uniforms.filterDims.x - 1 -\n        row / (uniforms.filterDims[1] * uniforms.outBackprop[3]);\n    let coordY = uniforms.filterDims.y - 1 -\n        (row / uniforms.outBackprop[3]) % uniforms.filterDims[1];\n    if (row < uniforms.dimInner && col < uniforms.dimBOuter &&\n        coordX >= 0 && coordY >= 0) {\n      let rowInner = row % uniforms.outBackprop[3];\n      let coord = vec4<i32>(coordX, coordY, col, rowInner);\n      ${(e=>{switch(e){case 1:return"return W[getIndexFromCoords4D(coord, uniforms.wShape)];";case 4:return"\n            let coord1 = vec4<i32>(coordX, coordY, col + 1, rowInner);\n            let coord2 = vec4<i32>(coordX, coordY, col + 2, rowInner);\n            let coord3 = vec4<i32>(coordX, coordY, col + 3, rowInner);\n            let v0 = W[getIndexFromCoords4D(coord, uniforms.wShape)];\n            let v1 = W[getIndexFromCoords4D(coord1, uniforms.wShape)];\n            let v2 = W[getIndexFromCoords4D(coord2, uniforms.wShape)];\n            let v3 = W[getIndexFromCoords4D(coord3, uniforms.wShape)];\n            return vec4<f32>(v0, v1, v2, v3);\n            ";default:throw new Error(`innerElementSize ${e} is not supported.`)}})(e)}\n    }\n    return ${f(e)}(0.0);\n  }\n\n  fn mm_write(batch: i32, row : i32, colIn : i32, valueInput : ${f(e)}) {\n    let col = colIn * ${e};\n    if (row < uniforms.dimAOuter && (col + ${e-1}) < uniforms.dimBOuter) {\n      var value = valueInput;\n      let outCoord = vec4<i32>(\n          batch,\n          row / uniforms.outShape[2],\n          row % uniforms.outShape[2],\n          col);\n      result[getIndexFromCoords4D(outCoord, uniforms.outShape)/${e}] = value;\n    }\n  }`}(this.isVec4?4:1)}\n    ${e}\n    `}}const bi={kernelName:t.Conv2DBackpropInput,backendName:"webgpu",kernelFunc:function(e){const{inputs:n,backend:i,attrs:r}=e,{dy:s,filter:a}=n,{inputShape:o,strides:u,pad:l,dataFormat:d,dimRoundingMode:h}=r,p=t.backend_util.convertConv2DDataFormat(d),c=t.backend_util.computeConv2DInfo(o,a.shape,u,1,l,h,!1,p),f=[{type:"int32",data:[c.filterHeight,c.filterWidth]},{type:"int32",data:[c.filterHeight-1-c.padInfo.top,c.filterWidth-1-c.padInfo.left]},{type:"int32",data:[c.strideHeight,c.strideWidth]},{type:"int32",data:[c.batchSize,c.outHeight,c.outWidth,c.outChannels]}];let m;if(t.env().getBool("WEBGPU_USE_NAIVE_CONV2D_TRANSPOSE")||"channelsLast"!==c.dataFormat)m=new pi(c);else{m=new xi(c);const e=c.inHeight*c.inWidth,t=c.inChannels,n=c.filterHeight*c.filterWidth*c.outChannels;f.push({type:"uint32",data:[e]},{type:"uint32",data:[t]},{type:"uint32",data:[n]})}return i.runWebGPUProgram(m,[s,a],"float32",f)}};class yi{constructor(e){this.variableNames=["x","W"],this.uniforms="filterDims: vec3<i32>, pads: vec3<i32>, strides: vec3<i32>, dilations: vec3<i32>,",this.workgroupSize=[64,1,1],this.size=!0,this.outputShape=e.outShape,this.dispatchLayout=N(this.outputShape),this.dispatch=$(this.dispatchLayout,this.outputShape,this.workgroupSize),this.shaderKey="conv3dnaive"}getUserCode(){return`\n    ${x("index")} {\n      if (index < uniforms.size) {\n        let coords = getOutputCoords();\n        let batch = coords.x;\n        let d2 = coords.u;\n\n        let xFRCCorner = vec3<i32>(coords.y, coords.z, coords.w) * uniforms.strides - uniforms.pads;\n        let xFCorner = xFRCCorner.x;\n        let xRCorner = xFRCCorner.y;\n        let xCCorner = xFRCCorner.z;\n\n        let inputDepthNearestVec4 = (uniforms.xShape.u / 4) * 4;\n        let inputDepthVec4Remainder = uniforms.xShape.u % 4;\n\n        var dotProd = 0.0;\n        for (var wF = 0; wF < uniforms.filterDims[0]; wF++) {\n          let xF = xFCorner + wF * uniforms.dilations[0];\n          if (xF < 0 || xF >= uniforms.xShape.y) {\n            continue;\n          }\n\n          for (var wR = 0; wR < uniforms.filterDims[1]; wR++) {\n            let xR = xRCorner + wR * uniforms.dilations[1];\n            if (xR < 0 || xR >= uniforms.xShape.z) {\n              continue;\n            }\n\n            for (var wC = 0; wC < uniforms.filterDims[2]; wC++) {\n              let xC = xCCorner + wC * uniforms.dilations[2];\n              if (xC < 0 || xC >= uniforms.xShape.w) {\n                continue;\n              }\n\n              for (var d1 = 0; d1 < inputDepthNearestVec4; d1 += 4) {\n                let xValues = vec4<f32>(\n                  getX(batch, xF, xR, xC, d1),\n                  getX(batch, xF, xR, xC, d1 + 1),\n                  getX(batch, xF, xR, xC, d1 + 2),\n                  getX(batch, xF, xR, xC, d1 + 3)\n                );\n                let wValues = vec4<f32>(\n                  getW(wF, wR, wC, d1, d2),\n                  getW(wF, wR, wC, d1 + 1, d2),\n                  getW(wF, wR, wC, d1 + 2, d2),\n                  getW(wF, wR, wC, d1 + 3, d2)\n                );\n\n                dotProd += dot(xValues, wValues);\n              }\n\n              if (inputDepthVec4Remainder == 1) {\n                dotProd += getX(batch, xF, xR, xC, inputDepthNearestVec4) *\n                  getW(wF, wR, wC, inputDepthNearestVec4, d2);\n              } else if (inputDepthVec4Remainder == 2) {\n                let xValues = vec2<f32>(\n                  getX(batch, xF, xR, xC, inputDepthNearestVec4),\n                  getX(batch, xF, xR, xC, inputDepthNearestVec4 + 1)\n                );\n                let wValues = vec2<f32>(\n                  getW(wF, wR, wC, inputDepthNearestVec4, d2),\n                  getW(wF, wR, wC, inputDepthNearestVec4 + 1, d2)\n                );\n                dotProd += dot(xValues, wValues);\n              } else if (inputDepthVec4Remainder == 3) {\n                let xValues = vec3<f32>(\n                  getX(batch, xF, xR, xC, inputDepthNearestVec4),\n                  getX(batch, xF, xR, xC, inputDepthNearestVec4 + 1),\n                  getX(batch, xF, xR, xC, inputDepthNearestVec4 + 2)\n                );\n                let wValues = vec3<f32>(\n                  getW(wF, wR, wC, inputDepthNearestVec4, d2),\n                  getW(wF, wR, wC, inputDepthNearestVec4 + 1, d2),\n                  getW(wF, wR, wC, inputDepthNearestVec4 + 2, d2)\n                );\n                dotProd += dot(xValues, wValues);\n              }\n            }\n          }\n        }\n        setOutputAtIndex(index, dotProd);\n      }\n    }`}}const wi={kernelName:t.Conv3D,backendName:"webgpu",kernelFunc:function(e){const{inputs:n,backend:i,attrs:r}=e,{x:s,filter:a}=n,{strides:o,pad:u,dilations:l}=r,d=t.backend_util.computeConv3DInfo(s.shape,a.shape,o,l,u),h=[d.padInfo.front,d.padInfo.top,d.padInfo.left],p=[{type:"int32",data:[d.filterDepth,d.filterHeight,d.filterWidth]},{type:"int32",data:[...h]},{type:"int32",data:[d.strideDepth,d.strideHeight,d.strideWidth]},{type:"int32",data:[d.dilationDepth,d.dilationHeight,d.dilationWidth]}],c=new yi(d),f=t.upcastType(s.dtype,a.dtype);return i.runWebGPUProgram(c,[s,a],f,p)}};const Ci={kernelName:t.Conv3DBackpropFilterV2,backendName:"webgpu",kernelFunc:function(e){const{inputs:n,backend:i,attrs:r}=e,{x:s,dy:a}=n,{strides:o,pad:u,filterShape:l}=r,d=t.backend_util.computeConv3DInfo(s.shape,l,o,1,u),h=new fi(d),p=[{type:"int32",data:[d.padInfo.front,d.padInfo.top,d.padInfo.left]},{type:"int32",data:[d.strideDepth,d.strideHeight,d.strideWidth]},{type:"int32",data:[d.batchSize]},{type:"int32",data:[d.outDepth]},{type:"int32",data:[d.outHeight]},{type:"int32",data:[d.outWidth]},{type:"int32",data:[d.inDepth]},{type:"int32",data:[d.inHeight]},{type:"int32",data:[d.inWidth]}];return i.runWebGPUProgram(h,[s,a],a.dtype,p)}};const ki={kernelName:t.Conv3DBackpropInputV2,backendName:"webgpu",kernelFunc:function(e){const{inputs:n,backend:i,attrs:r}=e,{dy:s,filter:a}=n,{strides:o,pad:u,inputShape:l}=r,d=t.backend_util.computeConv3DInfo(l,a.shape,o,1,u),h=new mi(d),p=[{type:"int32",data:[d.filterDepth,d.filterHeight,d.filterWidth]},{type:"int32",data:[d.filterDepth-1-d.padInfo.front,d.filterHeight-1-d.padInfo.top,d.filterWidth-1-d.padInfo.left]},{type:"int32",data:[d.strideDepth,d.strideHeight,d.strideWidth]},{type:"int32",data:[d.outDepth]},{type:"int32",data:[d.outHeight]},{type:"int32",data:[d.outWidth]},{type:"int32",data:[d.outChannels]}];return i.runWebGPUProgram(h,[s,a],s.dtype,p)}},Si=xe({opType:U.COS}),vi={kernelName:t.Cos,backendName:"webgpu",kernelFunc:Si},Ii=xe({opType:U.COSH}),Ri={kernelName:t.Cosh,backendName:"webgpu",kernelFunc:Ii};class $i{constructor(e,t,n,i){this.variableNames=["Image","Boxes","BoxInd"],this.uniforms="extrapolationValue : f32,",this.workgroupSize=[64,1,1],this.size=!0;const[r]=t;this.outputShape=[r,n[0],n[1],e],this.dispatchLayout=N(this.outputShape),this.dispatch=$(this.dispatchLayout,this.outputShape,this.workgroupSize),this.methodId="bilinear"===i?1:0,this.cropHeightBiggerThan1=this.outputShape[1]>1,this.cropWidthBiggerThan1=this.outputShape[2]>1,this.shaderKey=`cropAndResize_${this.methodId}_${this.cropHeightBiggerThan1}_${this.cropWidthBiggerThan1}`}getUserCode(){const[e,t]=["f32(uniforms.imageShape[1] - 1)","f32(uniforms.imageShape[2] - 1)"],[n,i,r]=this.cropHeightBiggerThan1?[`(${e} / f32(uniforms.outShape[1] - 1))`,"(y2-y1) * height_ratio",`y1*${e} + f32(y)*(height_scale)`]:["0.0","0.0",`0.5 * (y1+y2) * ${e}`],[s,a,o]=this.cropWidthBiggerThan1?[`(${t} / f32(uniforms.outShape[2] - 1))`,"(x2-x1) * width_ratio",`x1*${t} + f32(x)*(width_scale)`]:["0.0","0.0",`0.5 * (x1+x2) * ${t}`];return`\n    ${x("index")} {\n      if (index < uniforms.size) {\n        let coords = getCoordsFromIndex(index);\n        let height_ratio = f32(${n});\n        let width_ratio = f32(${s});\n        let b = coords[0];\n        let y = coords[1];\n        let x = coords[2];\n        let d = coords[3];\n        // get box vals\n        let y1 = getBoxes(b, 0);\n        let x1 = getBoxes(b, 1);\n        let y2 = getBoxes(b, 2);\n        let x2 = getBoxes(b, 3);\n        // get image in batch index\n        let bInd = i32(round(getBoxInd(b)));\n        if(bInd < 0 || bInd >= uniforms.outShape[0]) {\n          return;\n        }\n        let height_scale = ${i};\n        let width_scale = ${a};\n        let in_y = ${r};\n        if( in_y < 0.0 || in_y > ${e} ) {\n          setOutputAtIndex(index, uniforms.extrapolationValue);\n          return;\n        }\n        let in_x = ${o};\n        if( in_x < 0.0 || in_x > ${t} ) {\n          setOutputAtIndex(index, uniforms.extrapolationValue);\n          return;\n        }\n        let sourceFracIndexCR = vec2<f32>(in_x,in_y);\n        if(${this.methodId} == 1) {\n          // Compute the four integer indices.\n          let sourceFloorCR = vec2<i32>(sourceFracIndexCR);\n          let sourceCeilCR = vec2<i32>(ceil(sourceFracIndexCR));\n          let topLeft = getImage(bInd, sourceFloorCR.y, sourceFloorCR.x, d);\n          let bottomLeft = getImage(bInd, sourceCeilCR.y, sourceFloorCR.x, d);\n          let topRight = getImage(bInd, sourceFloorCR.y, sourceCeilCR.x, d);\n          let bottomRight = getImage(bInd, sourceCeilCR.y, sourceCeilCR.x, d);\n          let fracCR = sourceFracIndexCR - vec2<f32>(sourceFloorCR);\n          let top = topLeft + (topRight - topLeft) * fracCR.x;\n          let bottom = bottomLeft + (bottomRight - bottomLeft) * fracCR.x;\n          let newValue = top + (bottom - top) * fracCR.y;\n          setOutputAtIndex(index, newValue);\n        } else {\n          // Compute the coordinators of nearest neighbor point.\n          let sourceNearestCR = vec2<i32>(floor(\n            sourceFracIndexCR + vec2<f32>(0.5,0.5)));\n          let newValue = getImage(\n            bInd, sourceNearestCR.y, sourceNearestCR.x, d);\n          setOutputAtIndex(index, newValue);\n        }\n      }\n    }\n    `}}const Pi={kernelName:t.CropAndResize,backendName:"webgpu",kernelFunc:e=>{const{inputs:t,backend:n,attrs:i}=e,{image:r,boxes:s,boxInd:a}=t,{cropSize:o,method:u,extrapolationValue:l}=i,d=new $i(r.shape[3],s.shape,o,u),h=[{type:"float32",data:[l]}];return n.runWebGPUProgram(d,[r,s,a],"float32",h)}};var Ai;!function(e){e.Prod="*",e.Sum="+"}(Ai||(Ai={}));class zi{constructor(e,t,n,i){this.variableNames=["x"],this.uniforms="index : f32,",this.size=!0,this.workgroupSize=[128,1,1],this.outputShape=t,this.dispatchLayout=N(this.outputShape),this.dispatch=$(this.dispatchLayout,this.outputShape,this.workgroupSize),this.exclusive=n,this.reverse=i,this.op=e,this.shaderKey=`cum_${this.op}_${this.exclusive}_${this.reverse}`}getUserCode(){const e=this.outputShape.length,t=this.op===Ai.Prod?"1.0":"0.0",n=this.exclusive?t:`getX(${Ni(e,"coords",this.op)})`,i=this.outputShape[this.outputShape.length-1];let r="",s="";return this.exclusive?(r=this.reverse?"end != "+(i-1):"end != 0",s=this.reverse?"end + 1":"end - 1"):(r=this.reverse?`end + pow2 < ${i}`:"end >= pow2",s=this.reverse?"end + pow2":"end - pow2"),`\n      ${x("index")} {\n       if (index < uniforms.size) {\n         var coords = getCoordsFromIndex(index);\n\n         let end = ${Di(e,"coords",this.op)};\n         var val = ${n};\n         let pow2 = i32(pow(2.0, uniforms.index));\n         if (${r}) {\n           let idx = ${s};\n           ${Di(e,"coords",this.op)} = idx;\n           val ${this.op}= getX(${Ni(e,"coords",this.op)});\n         }\n         setOutputAtIndex(index, val);\n       }\n      }\n    `}}function Ni(e,t,n){if(1===e)return`${t}`;if(2===e)return`${t}.x, ${t}.y`;if(3===e)return`${t}.x, ${t}.y, ${t}.z`;if(4===e)return`${t}.x, ${t}.y, ${t}.z, ${t}.w`;throw Error(`Cumulative ${n} for rank ${e} is not yet supported`)}function Di(e,t,n){if(1===e)return`${t}`;if(2===e)return`${t}.y`;if(3===e)return`${t}.z`;if(4===e)return`${t}.w`;throw Error(`Cumulative ${n} for rank ${e} is not yet supported`)}function Ti(e,n,i,r,s,a){const o=n.shape.length,u=t.backend_util.getAxesPermutation([r],o);let l=n;null!=u&&(l=jt({inputs:{x:n},backend:i,attrs:{perm:u}}));const d=t.backend_util.getInnerMostAxes(1,o)[0];if(d!==o-1)throw new Error(`WebGPU cumprod shader expects an inner-most axis=${n.shape.length-1} but got axis=${r}`);const h=l.shape[d];let p=pe({inputs:{x:l},backend:i});for(let t=0;t<=Math.ceil(Math.log2(h))-1;t++){const n=new zi(e,l.shape,!1,a),r=p,s=[{type:"float32",data:[t]}];p=i.runWebGPUProgram(n,[p],p.dtype,s),i.disposeData(r.dataId)}if(s){const t=new zi(e,l.shape,s,a),n=p,r=[{type:"float32",data:[0]}];p=i.runWebGPUProgram(t,[p],p.dtype,r),i.disposeData(n.dataId)}if(null!=u){const e=jt({inputs:{x:p},backend:i,attrs:{perm:t.backend_util.getUndoAxesPermutation(u)}});return i.disposeData(p.dataId),i.disposeData(l.dataId),e}return p}const Fi={kernelName:t.Cumprod,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:n,attrs:i}=e,{x:r}=t,{axis:s,exclusive:a,reverse:o}=i;return Ti(Ai.Prod,r,n,s,a,o)}};const _i={kernelName:t.Cumsum,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:n,attrs:i}=e,{x:r}=t,{axis:s,exclusive:a,reverse:o}=i;return Ti(Ai.Sum,r,n,s,a,o)}};const Ei={kernelName:t.DenseBincount,backendName:"webgpu",kernelFunc:function(e){const{inputs:n,backend:i,attrs:r}=e,{x:s,weights:a}=n,{size:o,binaryOutput:u}=r,l=1===s.shape.length,d=t.util.sizeFromShape(a.shape)>0,h=a.dtype,p=l?[s.shape[0]]:[s.shape[0],s.shape[1]],c=re({backend:i,attrs:{shape:l?[o]:[s.shape[0],o],value:0,dtype:h}}),f=new Wn(p,d,u),m=[{type:"int32",data:[o]}],g=d?[s,a]:[s];return i.runWebGPUProgram(f,g,h,m,c)}};class Wi{constructor(e,t){this.variableNames=["x"],this.workgroupSize=[64,1,1],this.size=!0,this.uniforms="blockSize : i32,",this.outputShape=e,this.dispatchLayout=N(this.outputShape),this.dispatch=$(this.dispatchLayout,this.outputShape,this.workgroupSize),this.shaderKey=`depthToSpace_${t}`,this.dataFormat=t}getUserCode(){return`\n      ${x("index")} {\n        if (index < uniforms.size) {\n          let coords = getCoordsFromIndex(index);\n          let b = coords[0];\n          let h = ${this.getHeightCoordString()};\n          let w = ${this.getWidthCoordString()};\n          let d = ${this.getDepthCoordString()};\n\n          let in_h = h / uniforms.blockSize;\n          let offset_h = h % uniforms.blockSize;\n          let in_w = w / uniforms.blockSize;\n          let offset_w = w % uniforms.blockSize;\n          let offset_d = (offset_h * uniforms.blockSize + offset_w) *\n            ${this.getOutputDepthSize()};\n          let in_d = d + offset_d;\n\n          let rlt = ${this.getInputSamplingString()};\n          setOutputAtIndex(index, rlt);\n        }\n      }`}getHeightCoordString(){return"NHWC"===this.dataFormat?"coords[1]":"coords[2]"}getWidthCoordString(){return"NHWC"===this.dataFormat?"coords[2]":"coords[3]"}getDepthCoordString(){return"NHWC"===this.dataFormat?"coords[3]":"coords[1]"}getOutputDepthSize(){return"NHWC"===this.dataFormat?"uniforms.outShape[3]":"uniforms.outShape[1]"}getInputSamplingString(){return"NHWC"===this.dataFormat?"getX(b, in_h, in_w, in_d)":"getX(b, in_d, in_h, in_w)"}}const Li={kernelName:t.DepthToSpace,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:n,attrs:i}=e,{x:r}=t,{blockSize:s,dataFormat:a}=i,o=r.shape[0],u=("NHWC"===a?r.shape[1]:r.shape[2])*s,l=("NHWC"===a?r.shape[2]:r.shape[3])*s,d=("NHWC"===a?r.shape[3]:r.shape[1])/(s*s),h=[{type:"int32",data:[s]}],p=new Wi("NHWC"===a?[o,u,l,d]:[o,d,u,l],a);return n.runWebGPUProgram(p,[r],r.dtype,h)}};class Bi{constructor(e,t,n,i=!1,r=null,s=!1){this.variableNames=["x","W"],this.uniforms="pads : vec2<i32>, inDims : vec2<i32>,",this.workgroupSize=[16,16,1],this.outputShape=e,this.dispatchLayout={x:[3],y:[2],z:[0,1]},this.dispatch=$(this.dispatchLayout,this.outputShape,this.workgroupSize),i&&this.variableNames.push("bias"),s&&this.variableNames.push("preluActivationWeights"),this.addBias=i,this.activation=r,this.hasPreluActivation=s,this.filterHeight=t,this.filterWidth=n,this.shaderKey=`depthwiseNCHW_${this.activation}_${this.filterHeight}_${this.filterWidth}`}getUserCode(){const e=this.filterWidth*this.filterHeight,t=this.workgroupSize[0]*this.workgroupSize[1]*this.workgroupSize[2],n=this.workgroupSize[1]+this.filterHeight-1,i=this.workgroupSize[0]+this.filterWidth-1;return`\n      ${H(this.activation,this.hasPreluActivation,!1,4)}\n\n      var<workgroup> mm_Asub : array<array<f32, ${i}>, ${n}>;\n      var<workgroup> mm_Bsub : array<array<f32, ${this.filterWidth}>, ${this.filterHeight}>;\n      fn readX(batch : i32, channel : i32, row : i32, col : i32) -> f32 {\n        var value = 0.0;\n        if (row >=0 && row < uniforms.inDims[0] && col >=0 && col < uniforms.inDims[1])\n        {\n          value = getX(batch, channel, row, col);\n        }\n        return value;\n      }\n\n      ${x()} {\n        let coords = getOutputCoords();\n        let batch = coords[0];\n        let xRCCorner = vec2<i32>(coords.zw) - uniforms.pads;\n        let channelMul = uniforms.wShape[3];\n        let d1 = coords[1] / channelMul;\n        let q = coords[1] % channelMul;\n\n        let inputRowStart = xRCCorner.x;\n        let inputColStart = xRCCorner.y;\n\n        let localRow = i32(localId.y);\n        let localCol = i32(localId.x);\n\n        // Load one tile of X into local memory.\n        for (var inputRow = localRow; inputRow < ${n}; inputRow = inputRow + ${this.workgroupSize[1]}) {\n          for (var inputCol = localCol; inputCol < ${i}; inputCol = inputCol + ${this.workgroupSize[0]}) {\n            let rowOffset = inputRow - localRow;\n            let colOffset = inputCol - localCol;\n            mm_Asub[inputRow][inputCol] = readX(batch, d1, inputRowStart + rowOffset, inputColStart + colOffset);\n          }\n        }\n\n        // Load one tile of W into local memory.\n        var wIndex = i32(localIndex);\n        ${e<t?`if (wIndex < ${e})`:`for(; wIndex < ${e}; wIndex = wIndex + ${t})`}\n\n        {\n          let wRow = wIndex / ${this.filterWidth};\n          let wCol = wIndex % ${this.filterWidth};\n          mm_Bsub[wRow][wCol] = getW(wRow, wCol, d1, q);\n        }\n\n        workgroupBarrier();\n\n        var value = 0.0;\n        for (var wR = 0; wR < ${this.filterHeight}; wR = wR + 1) {\n          for (var wC = 0; wC < ${this.filterWidth}; wC = wC + 1) {\n            let xVal = mm_Asub[localRow + wR][localCol + wC];\n            let wVal = mm_Bsub[wR][wC];\n            value = fma(xVal, wVal, value);\n          }\n        }\n        ${X(this.addBias,this.activation)}\n        if (coordsInBounds4D(coords, uniforms.outShape)) {\n          setOutputAtCoords(coords[0], coords[1], coords[2], coords[3], value);\n        }\n      }\n    `}}class Oi{constructor(e,n=!1,i=null,r=!1){this.variableNames=["x","W"],this.uniforms="pads : vec2<i32>, inDims : vec2<i32>, virtualWidth : i32,",this.workgroupSize=[64,1,1],this.workPerThread=4,this.outputComponent=4,this.outputShape=e.outShape,this.virtualWidth=Math.ceil(this.outputShape[2]/this.workPerThread)*this.workPerThread;const s=[this.outputShape[0],this.outputShape[1],this.virtualWidth,this.outputShape[3]];this.dispatchLayout=N(s),this.dispatch=$(this.dispatchLayout,s,this.workgroupSize,[this.outputComponent*this.workPerThread,1,1]),t.util.assert("channelsLast"===e.dataFormat,(()=>"TODO: NCHW is unimplemented")),n&&this.variableNames.push("bias"),r&&this.variableNames.push("preluActivationWeights"),this.convInfo=e,this.addBias=n,this.activation=i,this.hasPreluActivation=r,this.shaderKey=`depthwiseVec4_${i}_${this.convInfo.filterHeight}_${this.convInfo.filterWidth}_${this.convInfo.strideHeight}_${this.convInfo.strideWidth}_${this.workPerThread}`}getUserCode(){const e=(this.workPerThread-1)*this.convInfo.strideWidth+this.convInfo.filterWidth,t=this.convInfo.strideHeight,n=this.convInfo.strideWidth;return`\n      ${H(this.activation,this.hasPreluActivation,!0,4)}\n      fn readX(batch : i32, row : i32, col : i32, channel : i32) -> vec4<f32> {\n        var value = vec4<f32>(0.0);\n        if (col >=0 && col < uniforms.inDims[1]) {\n          value = getX(batch, row, col, channel);\n        }\n        return value;\n      }\n\n      ${x("index")} {\n        let width0 = uniforms.outShape[3] / ${this.outputComponent};\n        let d1 = (index % width0) * ${this.outputComponent};\n        var index1 = index / width0;\n        let width1 = uniforms.virtualWidth / ${this.workPerThread};\n        let c = (index1 % width1) * ${this.workPerThread};\n        index1 = index1 / width1;\n        let r = index1 % uniforms.outShape[1];\n        let batch = index1 / uniforms.outShape[1];\n\n        let xRCCorner = vec2<i32>(r, c) * vec2<i32>(${t}, ${n}) - uniforms.pads;\n\n        let xRCorner = xRCCorner.x;\n        let xCCorner = xRCCorner.y;\n        var xVals : array<vec4<f32>, ${e}>;\n        var dotProd : array<vec4<f32>, ${this.workPerThread}>;\n        for (var i = 0; i < ${this.workPerThread}; i++) {\n          dotProd[i] = vec4<f32>(0.0);\n        }\n\n        // Use constant instead of uniform can give better performance.\n        for (var wR = 0; wR < ${this.convInfo.filterHeight}; wR = wR + 1) {\n          let xR = xRCorner + wR;\n          if (xR >=0 && xR < uniforms.inDims[0]) {\n            for (var i = 0; i < ${e}; i++) {\n              xVals[i] = readX(batch, xR, xCCorner + i, d1);\n            }\n            for (var wC = 0; wC < ${this.convInfo.filterWidth}; wC = wC + 1) {\n              let wValue = getW(wR, wC, d1, 0);\n              for (var i = 0; i < ${this.workPerThread}; i++) {\n                dotProd[i] = fma(xVals[i * ${n} + wC], wValue, dotProd[i]);\n              }\n            }\n          }\n        }\n\n        for (var i = 0; i < ${this.workPerThread}; i = i + 1) {\n          let coords = vec4<i32>(batch, r, c + i, d1);\n          if (coordsInBounds4D(coords, uniforms.outShape)) {\n            var value = dotProd[i];\n            ${X(this.addBias,this.activation)}\n            setOutputAtCoords(coords[0], coords[1], coords[2], coords[3], value);\n          }\n        }\n      }\n    `}}class Ui{constructor(e,t=!1,n=null,i=!1){this.variableNames=["x","W"],this.uniforms="pads : vec2<i32>, inDims : vec2<i32>, filterHeight : i32,\n      filterWidth : i32, strides : vec2<i32>, dilations : vec2<i32>,",this.workgroupSize=[256,1,1],this.size=!0,this.outputShape=e.outShape,this.dispatchLayout=N(this.outputShape),this.dispatch=$(this.dispatchLayout,this.outputShape,this.workgroupSize),this.isChannelsLast="channelsLast"===e.dataFormat,t&&this.variableNames.push("bias"),i&&this.variableNames.push("preluActivationWeights"),this.convInfo=e,this.addBias=t,this.activation=n,this.hasPreluActivation=i,this.shaderKey=`depthwise_${this.activation}_${this.isChannelsLast}`}getUserCode(){const e=this.isChannelsLast?"getX(batch, xR, xC, d1);":"getX(batch, d1, xR, xC);";return`\n      ${H(this.activation,this.hasPreluActivation,!1,4)}\n\n      ${x("index")} {\n        if (index < uniforms.size) {\n          let coords = getOutputCoords();\n          let batch = coords[0];\n          let xRCCorner = vec2<i32>(coords.${this.isChannelsLast?"yz":"zw"}) * uniforms.strides - uniforms.pads;\n          let d2 = coords[${this.isChannelsLast?3:1}];\n          let channelMul = uniforms.wShape[3];\n          let d1 = d2 / channelMul;\n          let q = d2 % channelMul;\n\n          let inputRowStart = xRCCorner.x;\n          let inputColStart = xRCCorner.y;\n          let inputRowEnd = inputRowStart + uniforms.filterHeight *\n              uniforms.dilations[0];\n          let inputColEnd = inputColStart + uniforms.filterWidth *\n              uniforms.dilations[1];\n\n          // Convolve x(?, ?, d1)|x(d1, ?, ?) with w(:, :, d1, q) to get\n          // y(yR, yC, d2)|y(d2, yR, yC). ? = to be determined. : = across all\n          // values in that axis. x(?, ?, d1) and y(yR, yC, d2) is for NHWC.\n          // x(d1, ?, ?) and y(d2, yR, yC) is for NCHW.\n          var value = 0.0;\n\n          // Extract if checking out of for loop for performance.\n          if (inputRowStart >= 0 && inputColStart >= 0 &&\n            inputRowEnd < uniforms.inDims[0] &&\n                inputColEnd < uniforms.inDims[1]) {\n              for (var wR = 0; wR < uniforms.filterHeight; wR = wR + 1) {\n                let xR = inputRowStart + wR * uniforms.dilations[0];\n\n                for (var wC = 0; wC < uniforms.filterWidth; wC = wC + 1) {\n                  let xC = inputColStart + wC * uniforms.dilations[1];\n\n                  let xVal = ${e};\n                  let wVal = getW(wR, wC, d1, q);\n                  value = value + xVal * wVal;\n                }\n              }\n            } else {\n              for (var wR = 0; wR < uniforms.filterHeight; wR = wR + 1) {\n                let xR = inputRowStart + wR * uniforms.dilations[0];\n\n                if (xR < 0 || xR >= uniforms.inDims[0]) {\n                  continue;\n                }\n\n                for (var wC = 0; wC < uniforms.filterWidth; wC = wC + 1) {\n                  let xC = inputColStart + wC * uniforms.dilations[1];\n\n                  if (xC < 0 || xC >= uniforms.inDims[1]) {\n                    continue;\n                  }\n\n                  let xVal = ${e};\n                  let wVal = getW(wR, wC, d1, q);\n                  value = value + xVal * wVal;\n                }\n              }\n            }\n            ${X(this.addBias,this.activation)}\n          setOutputAtCoords(coords[0], coords[1], coords[2], coords[3], value);\n        }\n      }\n    `}}const Mi={kernelName:t.DepthwiseConv2dNative,backendName:"webgpu",kernelFunc:function(e){const{inputs:n,backend:i,attrs:r}=e,{x:s,filter:a}=n,{strides:o,pad:u,dataFormat:l,dilations:d,dimRoundingMode:h}=r,p=t.backend_util.convertConv2DDataFormat(l);let c=d;null==c&&(c=[1,1]);const f=t.backend_util.computeConv2DInfo(s.shape,a.shape,o,c,u,h,!0,p),m=[{type:"int32",data:[f.padInfo.top,f.padInfo.left]},{type:"int32",data:[f.inHeight,f.inWidth]}],g="channelsLast"===f.dataFormat;let x;return!g&&f.inHeight>16&&f.inWidth>16&&1===f.strideHeight&&1===f.strideWidth&&1===f.dilationWidth&&1===f.dilationHeight&&f.inChannels===f.outChannels?x=new Bi(f.outShape,f.filterHeight,f.filterWidth):g&&f.outHeight>4&&f.outWidth>4&&f.strideWidth<=2&&f.inChannels===f.outChannels&&1===f.dilationHeight&&1===f.dilationWidth&&f.inChannels%4==0?(x=new Oi(f),m.push({type:"int32",data:[x.virtualWidth]})):(x=new Ui(f),m.push({type:"int32",data:[f.filterHeight]},{type:"int32",data:[f.filterWidth]},{type:"int32",data:[f.strideHeight,f.strideWidth]},{type:"int32",data:[f.dilationHeight,f.dilationWidth]})),i.runWebGPUProgram(x,[s,a],s.dtype,m)}};class Vi{constructor(e){this.variableNames=["x","dy"],this.uniforms="strides : vec2<i32>, pads : vec2<i32>, filterDims : vec2<i32>, outHeight : i32,\n      outWidth : i32, inHeight : i32, inWidth : i32, batchSize : i32, channelMul : i32,",this.workgroupSize=[64,1,1],this.size=!0,this.outputShape=e.filterShape,this.dispatchLayout=N(this.outputShape),this.dispatch=$(this.dispatchLayout,this.outputShape,this.workgroupSize),this.shaderKey="depthwise_conv2d_backprop_filter"}getUserCode(){return`\n      ${x("index")} {\n      if (index < uniforms.size) {\n        let coords = getCoordsFromIndex(index);\n        let wR = coords[0];\n        let wC = coords[1];\n        let d1 = coords[2];\n        let dm = coords[3];\n        let d2 = d1 * uniforms.channelMul + dm;\n\n        var dotProd = 0.0;\n        for (var b = 0; b < uniforms.batchSize; b++) {\n          for (var yR = 0; yR < uniforms.outHeight; yR++) {\n            let xR = wR + yR * uniforms.strides[0] - uniforms.pads[0];\n\n            if (xR < 0 || xR >= uniforms.inHeight) {\n              continue;\n            }\n\n            for (var yC = 0; yC < uniforms.outWidth; yC++) {\n              let xC = wC + yC * uniforms.strides[1] - uniforms.pads[1];\n\n              if (xC < 0 || xC >= uniforms.inWidth) {\n                continue;\n              }\n\n              let dyValue = getDy(b, yR, yC, d2);\n              let xValue = getX(b, xR, xC, d1);\n              dotProd += xValue * dyValue;\n            }\n          }\n        }\n        setOutputAtIndex(index, dotProd);\n      }\n    }\n    `}}class Gi{constructor(e){this.variableNames=["dy","W"],this.uniforms="strides : vec2<i32>, pads : vec2<i32>, filterDims : vec2<i32>,\n       outHeight : i32, outWidth : i32, channelMul : i32,",this.workgroupSize=[64,1,1],this.size=!0,this.outputShape=e.inShape,this.dispatchLayout=N(this.outputShape),this.dispatch=$(this.dispatchLayout,this.outputShape,this.workgroupSize),this.shaderKey="depthwise_conv2d_backprop_input"}getUserCode(){return`\n      ${x("index")} {\n      if (index < uniforms.size) {\n        let coords = getCoordsFromIndex(index);\n        let batch = coords[0];\n        let d1 = coords[3];\n        let dyCorner = coords.yz - uniforms.pads;\n        let dyRCorner = dyCorner.x;\n        let dyCCorner = dyCorner.y;\n\n        var dotProd = 0.0;\n        for (var wR = 0; wR < uniforms.filterDims[0]; wR++) {\n          let dyR = f32(dyRCorner + wR) / f32(uniforms.strides[0]);\n\n          if (dyR < 0.0 || dyR >= f32(uniforms.outHeight) || fract(dyR) > 0.0) {\n            continue;\n          }\n\n          let idyR = i32(dyR);\n          let wRPerm = uniforms.filterDims[0] - 1 - wR;\n\n          for (var wC = 0; wC < uniforms.filterDims[1]; wC++) {\n            let dyC = f32(dyCCorner + wC) / f32(uniforms.strides[1]);\n\n            if (dyC < 0.0 || dyC >= f32(uniforms.outWidth) || fract(dyC) > 0.0) {\n              continue;\n            }\n\n            let idyC = i32(dyC);\n            let wCPerm = uniforms.filterDims[1] - 1 - wC;\n\n            for (var dm = 0; dm < uniforms.channelMul; dm++) {\n              let d2 = d1 * uniforms.channelMul + dm;\n              let xValue = getDy(batch, idyR, idyC, d2);\n              let wValue = getW(wRPerm, wCPerm, d1, dm);\n              dotProd += xValue * wValue;\n            }\n          }\n        }\n        setOutputAtIndex(index, dotProd);\n      }\n    }\n    `}}const Hi={kernelName:t.DepthwiseConv2dNativeBackpropFilter,backendName:"webgpu",kernelFunc:function(e){const{inputs:n,backend:i,attrs:r}=e,{x:s,dy:a}=n,{strides:o,dilations:u,pad:l,dimRoundingMode:d,filterShape:h}=r,p=t.backend_util.computeConv2DInfo(s.shape,h,o,u,l,d,!0),c=new Vi(p),f=[{type:"int32",data:[p.strideHeight,p.strideWidth]},{type:"int32",data:[p.padInfo.top,p.padInfo.left]},{type:"int32",data:[p.filterHeight,p.filterWidth]},{type:"int32",data:[p.outHeight]},{type:"int32",data:[p.outWidth]},{type:"int32",data:[p.inHeight]},{type:"int32",data:[p.inWidth]},{type:"int32",data:[p.batchSize]},{type:"int32",data:[p.outChannels/p.inChannels]}];return i.runWebGPUProgram(c,[s,a],"float32",f)}};const Xi={kernelName:t.DepthwiseConv2dNativeBackpropInput,backendName:"webgpu",kernelFunc:function(e){const{inputs:n,backend:i,attrs:r}=e,{dy:s,filter:a}=n,{strides:o,dilations:u,pad:l,dimRoundingMode:d,inputShape:h}=r,p=t.backend_util.computeConv2DInfo(h,a.shape,o,u,l,d,!0),c=new Gi(p),f=[{type:"int32",data:[p.strideHeight,p.strideWidth]},{type:"int32",data:[p.filterHeight-1-p.padInfo.top,p.filterWidth-1-p.padInfo.left]},{type:"int32",data:[p.filterHeight,p.filterWidth]},{type:"int32",data:[p.outHeight]},{type:"int32",data:[p.outWidth]},{type:"int32",data:[p.outChannels/p.inChannels]}];return i.runWebGPUProgram(c,[s,a],s.dtype,f)}};class Ki{constructor(e){this.variableNames=["x"],this.workgroupSize=[64,1,1],this.size=!0,this.outputShape=[e,e],this.dispatchLayout=N(this.outputShape),this.dispatch=$(this.dispatchLayout,this.outputShape,this.workgroupSize),this.shaderKey="diag"}getUserCode(){return`\n      ${x("index")} {\n        if (index < uniforms.size) {\n          let coords = getOutputCoords();\n          let value = select(0.0, getX(coords[0]), coords[0] == coords[1]);\n          setOutputAtIndex(index, value);\n        }\n      }\n    `}}const qi={kernelName:t.Diag,backendName:"webgpu",kernelFunc:function(e){const{inputs:n,backend:i}=e,{x:r}=n,s=[...r.shape,...r.shape],a=t.util.sizeFromShape(r.shape),o=ae({inputs:{x:r},backend:i,attrs:{shape:[a]}}),u=new Ki(a),l=i.runWebGPUProgram(u,[o],o.dtype),d=ae({inputs:{x:l},backend:i,attrs:{shape:s}});return i.disposeData(o.dataId),i.disposeData(l.dataId),d}};class Yi{constructor(e){this.variableNames=["x","w"],this.uniforms="filterDims: vec2<i32>, pads: vec2<i32>, strides: vec2<i32>, dilations: vec2<i32>",this.workgroupSize=[64,1,1],this.size=!0,this.outputShape=e.outShape,this.dispatchLayout=N(this.outputShape),this.dispatch=$(this.dispatchLayout,this.outputShape,this.workgroupSize),this.shaderKey="dilation2d"}getUserCode(){return`\n       ${x("index")} {\n         if (index < uniforms.size) {\n           let neg_infinity = -3.4e38;\n           let coords = getOutputCoords();\n           let batch = coords.x;\n           let d1 = coords.w;\n           let outTopLeftCorner = coords.yz * uniforms.strides - uniforms.pads;\n           let hBeg = outTopLeftCorner.x;\n           let wBeg = outTopLeftCorner.y;\n\n           var curVal = neg_infinity;\n           for (var h = 0; h < uniforms.filterDims[0]; h = h + 1) {\n             let hIn = hBeg + h * uniforms.dilations[0];\n\n             if (hIn >= 0 && hIn < uniforms.xShape[1]) {\n               for (var w = 0; w < uniforms.filterDims[1]; w = w + 1) {\n                 let wIn = wBeg + w * uniforms.dilations[1];\n\n                 if (wIn >= 0 && wIn < uniforms.xShape[2]) {\n                   let val = getX(batch, hIn, wIn, d1) + getW(h, w, d1);\n                   if (val > curVal) {\n                     curVal = val;\n                   }\n                 }\n               }\n             }\n           }\n\n           setOutputAtIndex(index, curVal);\n         }\n       }\n     `}}const ji={kernelName:t.Dilation2D,backendName:"webgpu",kernelFunc:function(e){const{inputs:n,backend:i,attrs:r}=e,{x:s,filter:a}=n,{strides:o,pad:u,dilations:l}=r,d=t.backend_util.computeDilation2DInfo(s.shape,a.shape,o,u,"NHWC",l),h=[d.padInfo.top,d.padInfo.left],p=[{type:"int32",data:[d.filterHeight,d.filterWidth]},{type:"int32",data:[...h]},{type:"int32",data:[d.strideHeight,d.strideWidth]},{type:"int32",data:[d.dilationHeight,d.dilationWidth]}],c=new Yi(d);return i.runWebGPUProgram(c,[s,a],s.dtype,p)}};class Qi{constructor(e,t){if(this.variableNames=["x","w","dy"],this.uniforms="filterDims: vec2<i32>, pads: vec2<i32>, strides: vec2<i32>, dilations: vec2<i32>, dySize: i32,",this.workgroupSize=[64,1,1],this.atomic=!0,this.outputShape=e.inShape,this.dispatchLayout=N(e.outShape),this.dispatch=$(this.dispatchLayout,e.outShape,this.workgroupSize),"float32"!==t&&"int32"!==t)throw new Error(`Dilation2DBackpropInput only supports float32 and int32\n          types, does not support ${t} type.`);this.type=t,this.shaderKey="dilation2DBackpropInput"}getUserCode(){return`\n       ${x("index")} {\n         if (index < uniforms.dySize) {\n           let coords = getDyCoordsFromIndex(index);\n           let b = coords[0];\n           let r = coords[1];\n           let c = coords[2];\n           let d = coords[3];\n\n           let dyCorner = vec2<i32>(r, c) * uniforms.strides - uniforms.pads;\n           var curVal = -3.4e38;  // neg_infinity\n           var xRMax = 0;\n           var xCMax = 0;\n\n           // In the case of multiple argmax branches, we only back-propagate\n           // along the last branch, i.e., the one with largest value of\n           // 'wR * uniforms.filterDims[1] + wC', similarly to the max-pooling\n           // backward routines.\n           for (var wR = 0; wR < uniforms.filterDims[0]; wR++) {\n             let xR = dyCorner.x + wR * uniforms.dilations[0];\n\n             if (xR >= 0 && xR < uniforms.xShape[1]) {\n               for (var wC = 0; wC < uniforms.filterDims[1]; wC++) {\n                 let xC = dyCorner.y + wC * uniforms.dilations[1];\n\n                 if (xC >= 0 && xC < uniforms.xShape[2]) {\n                   let val = getX(b, xR, xC, d) + getW(wR, wC, d);\n                   if (val > curVal) {\n                     curVal = val;\n                     xRMax = xR;\n                     xCMax = xC;\n                   }\n                 }\n               }\n             }\n           }\n\n           let flatIndexIn = d + uniforms.xShape[3] *\n               (xCMax + uniforms.xShape[2] * (xRMax + uniforms.xShape[1] * b));\n           let value = getDy(b, r, c, d);\n           ${p("&result[flatIndexIn]","value",this.type)}\n         }\n       }\n     `}}class Zi{constructor(e,t,n){if(this.variableNames=["x","w","dy"],this.uniforms="filterDims: vec2<i32>, pads: vec2<i32>, strides: vec2<i32>, dilations: vec2<i32>, dySize: i32,",this.workgroupSize=[64,1,1],this.atomic=!0,this.outputShape=e.filterShape,this.dispatchLayout=N(e.outShape),this.dispatch=$(this.dispatchLayout,e.outShape,this.workgroupSize),"float32"!==n&&"int32"!==n)throw new Error(`Dilation2DBackpropFilter only supports float32 and int32\n          types, does not support ${n} type.`);this.type=n,this.shaderKey="dilation2DBackpropFilter"}getUserCode(){return`\n       ${x("index")} {\n         if (index < uniforms.dySize) {\n           let coords = getDyCoordsFromIndex(index);\n           let b = coords[0];\n           let r = coords[1];\n           let c = coords[2];\n           let d = coords[3];\n\n           let dyCorner = vec2<i32>(r, c) * uniforms.strides - uniforms.pads;\n           var curVal = -3.4e38;  // neg_infinity\n           var wRMax = 0;\n           var wCMax = 0;\n\n           // In the case of multiple argmax branches, we only back-propagate\n           // along the last branch, i.e., the one with largest value of\n           // 'wR * uniforms.filterDims[1] + wC', similarly to the max-pooling\n           // backward routines.\n           for (var wR = 0; wR < uniforms.filterDims[0]; wR++) {\n             let xR = dyCorner.x + wR * uniforms.dilations[0];\n\n             if (xR >= 0 && xR < uniforms.xShape[1]) {\n               for (var wC = 0; wC < uniforms.filterDims[1]; wC++) {\n                 let xC = dyCorner.y + wC * uniforms.dilations[1];\n\n                 if (xC >= 0 && xC < uniforms.xShape[2]) {\n                   let val = getX(b, xR, xC, d) + getW(wR, wC, d);\n                   if (val > curVal) {\n                     curVal = val;\n                     wRMax = wR;\n                     wCMax = wC;\n                   }\n                 }\n               }\n             }\n           }\n\n           let flatIndexIn = d + uniforms.wShape[2] * (wCMax + wRMax * uniforms.wShape[1]);\n           let value = getDy(b, r, c, d);\n           ${p("&result[flatIndexIn]","value",this.type)}\n         }\n       }\n     `}}const Ji={kernelName:t.Dilation2DBackpropFilter,backendName:"webgpu",kernelFunc:function(e){const{inputs:n,backend:i,attrs:r}=e,{x:s,filter:a,dy:o}=n,{strides:u,pad:l,dilations:d}=r,h=t.backend_util.computeDilation2DInfo(s.shape,a.shape,u,l,"NHWC",d),p=a.dtype,c=new Zi(h,a.shape,p),f=[{type:"int32",data:[h.filterHeight,h.filterWidth]},{type:"int32",data:[h.padInfo.top,h.padInfo.left]},{type:"int32",data:[h.strideHeight,h.strideWidth]},{type:"int32",data:[h.dilationHeight,h.dilationWidth]},{type:"int32",data:[t.util.sizeFromShape(h.outShape)]}],m=re({backend:i,attrs:{shape:a.shape,value:0,dtype:p}});return i.runWebGPUProgram(c,[s,a,o],p,f,m)}};const er={kernelName:t.Dilation2DBackpropInput,backendName:"webgpu",kernelFunc:function(e){const{inputs:n,backend:i,attrs:r}=e,{x:s,filter:a,dy:o}=n,{strides:u,pad:l,dilations:d}=r,h=t.backend_util.computeDilation2DInfo(s.shape,a.shape,u,l,"NHWC",d),p=s.dtype,c=new Qi(h,p),f=[{type:"int32",data:[h.filterHeight,h.filterWidth]},{type:"int32",data:[h.padInfo.top,h.padInfo.left]},{type:"int32",data:[h.strideHeight,h.strideWidth]},{type:"int32",data:[h.dilationHeight,h.dilationWidth]},{type:"int32",data:[t.util.sizeFromShape(h.outShape)]}],m=re({backend:i,attrs:{shape:h.inShape,value:0,dtype:p}});return i.runWebGPUProgram(c,[s,a,o],p,f,m)}},tr=be({opType:B.MUL,cpuKernelImpl:kt,supportsComplex:!0}),nr={kernelName:t.Multiply,backendName:"webgpu",kernelFunc:tr};function ir(e){const{inputs:t,backend:n,attrs:i}=e,{x:r}=t,{axis:s,keepDims:a}=i;return Jt(r,s,a,"sum",n)}const rr={kernelName:t.Sum,backendName:"webgpu",kernelFunc:ir};const sr={kernelName:t.Einsum,backendName:"webgpu",kernelFunc:function(e){const{inputs:n,backend:i,attrs:r}=e,{equation:s}=r,a=n,{allDims:o,summedDims:u,idDims:l}=t.backend_util.decodeEinsumEquation(s,a.length);t.backend_util.checkEinsumDimSizes(o.length,l,a);const{path:d,steps:h}=t.backend_util.getEinsumComputePath(u,l),p=h.length;let c=null,f=o.length;const m=[];for(let e=0;e<p;++e){for(const n of h[e]){const{permutationIndices:e,expandDims:r}=t.backend_util.getEinsumPermutation(f,l[n]);let s;t.backend_util.isIdentityPermutation(e)?s=a[n]:(s=jt({inputs:{x:a[n]},backend:i,attrs:{perm:e}}),m.push(s));const o=s.shape.slice();for(let e=0;e<r.length;++e)o.splice(r[e],0,1);t.util.arraysEqual(s.shape,o)||(s=ae({inputs:{x:s},backend:i,attrs:{shape:o}}),m.push(s)),null===c?c=s:(c=tr({inputs:{a:s,b:c},backend:i}),m.push(c))}e<p-1&&(d[e]>=0&&(c=ir({inputs:{x:c},backend:i,attrs:{axis:d[e]-(o.length-f),keepDims:!1}}),m.push(c)),f--)}for(const e of m)e!==c&&i.disposeData(e.dataId);return c}},ar=xe({opType:U.ELU}),or={kernelName:t.Elu,backendName:"webgpu",kernelFunc:ar},ur={kernelName:t.EluGrad,backendName:"webgpu",kernelFunc:e=>{const{inputs:t,backend:n}=e,{dy:i,y:r}=t,s=new he(B.ELU_DER,i.shape,r.shape);return n.runWebGPUProgram(s,[i,r],i.dtype)}},lr=be({opType:B.EQUAL,dtype:"bool",cpuKernelImpl:ot}),dr={kernelName:t.Equal,backendName:"webgpu",kernelFunc:lr},hr=xe({opType:U.ERF}),pr={kernelName:t.Erf,backendName:"webgpu",kernelFunc:hr},cr=xe({opType:U.EXP,cpuKernelImpl:ut,dtype:"float32"}),fr={kernelName:t.Exp,backendName:"webgpu",kernelFunc:cr};function mr(e){const{inputs:n,attrs:i,backend:r}=e,{dim:s}=i,{input:a}=n,o=a.shape.length,u=a.shape.slice();let l=s;return s<0&&(t.util.assert(-(o+1)<=s,(()=>`Axis must be in the interval [${-(o+1)}, ${o}]`)),l=o+s+1),u.splice(l,0,1),ae({inputs:{x:a},backend:r,attrs:{shape:u}})}const gr={kernelName:t.ExpandDims,backendName:"webgpu",kernelFunc:mr},xr=xe({opType:U.EXPM1,cpuKernelImpl:lt}),br={kernelName:t.Expm1,backendName:"webgpu",kernelFunc:xr};class yr{constructor(e,t){this.variableNames=["real","imag"],this.outputShape=[],this.uniforms="exponentMultiplier : f32, denominator: f32,",this.workgroupSize=[64,1,1],this.size=!0,this.outputShape=t,this.dispatchLayout=N(this.outputShape),this.dispatch=$(this.dispatchLayout,this.outputShape,this.workgroupSize),this.component=e,this.shaderKey=`fft_${e}`}getUserCode(){return`\n    fn unaryOpComplex(real: f32, expR: f32, imag: f32, expI: f32) -> f32 {\n      ${"real"===this.component?"return real * expR - imag * expI;":"return real * expI + imag * expR;"}\n    }\n\n    fn mulMatDFT(batch: i32, index: i32) -> f32 {\n      let indexRatio = f32(index) / f32(uniforms.realShape[1]);\n      let exponentMultiplierTimesIndexRatio =\n          uniforms.exponentMultiplier * indexRatio;\n\n      var result = 0.0;\n\n      for (var i = 0; i < uniforms.realShape[1]; i = i + 1) {\n        // x = (-2|2 * PI / N) * index * i;\n        let x = exponentMultiplierTimesIndexRatio * f32(i);\n        let expR = cos(x);\n        let expI = sin(x);\n        let real = getReal(batch, i);\n        let imag = getImag(batch, i);\n\n        result = result +\n            unaryOpComplex(real, expR, imag, expI) / uniforms.denominator;\n      }\n\n      return result;\n    }\n\n    ${x("index")} {\n      if (index < uniforms.size) {\n        let coords = getOutputCoords();\n        setOutputAtIndex(index, mulMatDFT(coords[0], coords[1]));\n      }\n    }\n  `}}function wr(e,n,i){const r=i.tensorMap.get(e.dataId),s=t.util.sizeFromShape(e.shape),a=e.shape[e.shape.length-1],o=[],u=ae({inputs:{x:e},backend:i,attrs:{shape:[s/a,a]}});o.push(u);const l=u.shape,d=new yr("real",l),h=new yr("imag",l),p=[{dataId:r.complexTensorInfos.real.dataId,dtype:r.complexTensorInfos.real.dtype,shape:l},{dataId:r.complexTensorInfos.imag.dataId,dtype:r.complexTensorInfos.imag.dtype,shape:l}],c=[{type:"float32",data:[n?2*Math.PI:-2*Math.PI]},{type:"float32",data:[n?l[1]:1]}],f=i.runWebGPUProgram(d,p,"float32",c);o.push(f);const m=i.runWebGPUProgram(h,p,"float32",c);o.push(m);const g=fe({inputs:{real:f,imag:m},backend:i});o.push(g);const x=ae({inputs:{x:g},backend:i,attrs:{shape:e.shape}});return o.forEach((e=>i.disposeData(e.dataId))),x}const Cr={kernelName:t.FFT,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:n}=e,{input:i}=t;return wr(i,!1,n)}};class kr{constructor(e){this.outputShape=[],this.variableNames=["x"],this.workgroupSize=[64,1,1],this.size=!0,this.outputShape=e,this.dispatchLayout=N(this.outputShape),this.dispatch=$(this.dispatchLayout,this.outputShape,this.workgroupSize),this.shaderKey="flipLeftRight"}getUserCode(){return`\n      ${x("index")} {\n        if (index < uniforms.size) {\n          let coords = getCoordsFromIndex(index);\n          let coordX = uniforms.xShape[2] - coords[2] - 1;\n          let outputValue = getX(coords[0], coords[1], coordX, coords[3]);\n          setOutputAtIndex(index, outputValue);\n        }\n      }\n    `}}const Sr={kernelName:t.FlipLeftRight,backendName:"webgpu",kernelFunc:({inputs:e,backend:t})=>{const{image:n}=e,i=t,r=new kr(n.shape);return i.runWebGPUProgram(r,[n],n.dtype)}},vr=xe({opType:U.FLOOR,cpuKernelImpl:dt}),Ir={kernelName:t.Floor,backendName:"webgpu",kernelFunc:vr},Rr=be({opType:B.INT_DIV,cpuKernelImpl:ht,dtype:"int32"}),$r={kernelName:t.FloorDiv,backendName:"webgpu",kernelFunc:Rr};class Pr{constructor(e,t,n=!1){this.isFromPixels=!0,this.outputShape=[0],this.variableNames=[],this.workgroupSize=[256,1,1],this.outputShape=e,this.dispatchLayout=N(this.outputShape),this.dispatch=$(this.dispatchLayout,this.outputShape,this.workgroupSize,[t,1,1]),this.importVideo=n,this.shaderKey=`fromPixels_${this.importVideo}`}getUserCode(){const e=this.importVideo?"textureLoad(src, vec2<i32>(coords.yx));":"textureLoad(src, vec2<i32>(coords.yx), 0)";return`\n      @binding(1) @group(0) var src: ${this.importVideo?"texture_external":"texture_2d<f32>"};\n      ${x("index")} {\n        let flatIndex = index * uniforms.numChannels;\n        if (flatIndex < uniforms.size) {\n          let coords = getCoordsFromIndex(flatIndex);\n          let values = ${e};\n          for (var i = 0; i < uniforms.numChannels; i = i + 1) {\n            result[flatIndex + i] = i32(floor(255.0 * values[i]));\n          }\n        }\n      }\n  `}}const Ar={kernelName:t.FromPixels,backendName:"webgpu",kernelFunc:function(e){const{inputs:n,backend:i,attrs:r}=e;let{pixels:s}=n;const{numChannels:a}=r;if(null==s)throw new Error("pixels passed to tf.browser.fromPixels() can not be null");const o="undefined"!=typeof HTMLVideoElement&&s instanceof HTMLVideoElement,u="undefined"!=typeof HTMLImageElement&&s instanceof HTMLImageElement,l="undefined"!=typeof HTMLCanvasElement&&s instanceof HTMLCanvasElement||"undefined"!=typeof OffscreenCanvas&&s instanceof OffscreenCanvas,d="undefined"!=typeof ImageBitmap&&s instanceof ImageBitmap,[h,p]=o?[s.videoWidth,s.videoHeight]:[s.width,s.height],c=[p,h,a],f=o||u;if(d||l||f){let e;{if(f){const e=t.env().getBool("CANVAS2D_WILL_READ_FREQUENTLY_FOR_GPU");null!=zr&&e===Nr||(Nr=e,zr=document.createElement("canvas").getContext("2d",{willReadFrequently:Nr})),zr.canvas.width=h,zr.canvas.height=p,zr.drawImage(s,0,0,h,p),s=zr.canvas}const n=GPUTextureUsage.COPY_DST|GPUTextureUsage.RENDER_ATTACHMENT|GPUTextureUsage.TEXTURE_BINDING,r="rgba8unorm",a=i.textureManager.acquireTexture(c[1],c[0],r,n);i.queue.copyExternalImageToTexture({source:s},{texture:a},[c[1],c[0]]),e=a}const n=t.util.sizeFromShape(c),r=t.util.computeStrides(c),o=new Pr(c,a,false),u=[{type:"uint32",data:[n]},{type:"uint32",data:[a]},{type:"uint32",data:[...r]}],l=i.makeTensorInfo([p,h],"int32");i.tensorMap.get(l.dataId).resource=e;const d=i.runWebGPUProgram(o,[l],"int32",u);return i.disposeData(l.dataId),d}const m=s.data;let g=m;if(null!=a&&4!==a){g=new Uint8Array(s.width*s.height*a);const e=m.length;let t=0;for(let n=0;n<e;n++)n%4<a&&(g[t++]=m[n])}const x=i.makeTensorInfo(c,"int32",new Int32Array(g));return i.uploadToGPU(x.dataId),x}};let zr,Nr=t.env().getBool("CANVAS2D_WILL_READ_FREQUENTLY_FOR_GPU");class Dr{constructor(e,n,i,r,s){this.uniforms="varianceEpsilon : f32,",this.workgroupSize=[128,1,1],this.size=!0,this.variableNames=["x","mean","variance"],t.backend_util.assertAndGetBroadcastShape(e,n),t.backend_util.assertAndGetBroadcastShape(e,i),this.outputShape=e,this.dispatchLayout=N(this.outputShape),this.dispatch=$(this.dispatchLayout,this.outputShape,this.workgroupSize),null!=r&&(t.backend_util.assertAndGetBroadcastShape(e,r),this.variableNames.push("offset")),null!=s&&(t.backend_util.assertAndGetBroadcastShape(e,s),this.variableNames.push("scale")),this.offsetShape=r,this.scaleShape=s,this.shaderKey="batchNorm"}getUserCode(){let e="0.0";null!=this.offsetShape&&(e="getOffsetByOutputIndex(index)");let t="1.0";null!=this.scaleShape&&(t="getScaleByOutputIndex(index)");return`\n      ${x("index")} {\n        if (index < uniforms.size)\n        {\n          let xValue = getXByOutputIndex(index);\n          let meanValue = getMeanByOutputIndex(index);\n          let varianValue = getVarianceByOutputIndex(index);\n          let offsetValue = ${e};\n          let scaleValue = ${t};\n          let inv = scaleValue * inverseSqrt(varianValue + f32(uniforms.varianceEpsilon));\n          setOutputAtIndex(index,dot(vec3<f32>(xValue, -meanValue, offsetValue), vec3<f32>(inv, inv, 1.0)));\n        }\n      }\n  `}}const Tr={kernelName:t.FusedBatchNorm,backendName:"webgpu",kernelFunc:({inputs:e,attrs:t,backend:n})=>{const{x:i,scale:r,offset:s,mean:a,variance:o}=e,{varianceEpsilon:u}=t,l=n,d=[i,a,o];let h=null;null!=s&&(h=s.shape,d.push(s));let p=null;null!=r&&(p=r.shape,d.push(r));const c=new Dr(i.shape,a.shape,o.shape,h,p),f=[{type:"float32",data:[u]}];return l.runWebGPUProgram(c,d,i.dtype,f)}};const Fr={kernelName:t.FusedConv2D,backendName:"webgpu",kernelFunc:function(e){const{inputs:n,backend:i,attrs:r}=e,{x:s,filter:a,bias:o,preluActivationWeights:u}=n,{strides:l,pad:d,dataFormat:h,dilations:p,dimRoundingMode:c,activation:f,leakyreluAlpha:m}=r,g=t.backend_util.convertConv2DDataFormat(h);return di({x:s,filter:a,convInfo:t.backend_util.computeConv2DInfo(s.shape,a.shape,l,p,d,c,!1,g),backend:i,bias:o,preluActivationWeights:u,leakyreluAlpha:m,activation:f})}};const _r={kernelName:t.FusedDepthwiseConv2D,backendName:"webgpu",kernelFunc:function(e){const{inputs:n,backend:i,attrs:r}=e,{x:s,filter:a,bias:o,preluActivationWeights:u}=n,{strides:l,pad:d,dilations:h,dimRoundingMode:p,activation:c,leakyreluAlpha:f}=r;let m=h;null==m&&(m=[1,1]),t.util.assert(t.backend_util.eitherStridesOrDilationsAreOne(l,m),(()=>`Error in depthwiseConv2d: Either strides or dilations must be 1. Got strides ${l} and dilations '${m}'`));const g=t.backend_util.computeConv2DInfo(s.shape,a.shape,l,m,d,p,!0),x=[s,a],b=null!=o,y=null!=u;b&&x.push(o),y&&x.push(u);const w=[{type:"int32",data:[g.padInfo.top,g.padInfo.left]},{type:"int32",data:[g.inHeight,g.inWidth]}];let C;return g.outHeight>4&&g.outWidth>4&&g.strideWidth<=2&&g.inChannels===g.outChannels&&1===g.dilationHeight&&1===g.dilationWidth&&g.inChannels%4==0?(C=new Oi(g,b,c,y),w.push({type:"int32",data:[C.virtualWidth]})):(C=new Ui(g,b,c,y),w.push({type:"int32",data:[g.filterHeight]},{type:"int32",data:[g.filterWidth]},{type:"int32",data:[g.strideHeight,g.strideWidth]},{type:"int32",data:[g.dilationHeight,g.dilationWidth]})),"leakyrelu"===c&&(w.push({type:"float32",data:[f]}),C.uniforms+=" alpha : f32,"),i.runWebGPUProgram(C,x,"float32",w)}};class Er{constructor(e,t){this.variableNames=["A","indices"],this.workgroupSize=[64,1,1],this.size=!0,this.outputShape=t,this.dispatchLayout=N(this.outputShape),this.dispatch=$(this.dispatchLayout,this.outputShape,this.workgroupSize),this.shaderKey=`gathernd_${e}`,this.sliceDim=e,this.uniforms=`sliceDim : i32, strides : ${m(e)},`}getUserCode(){let e;e=this.sliceDim>1?"uniforms.strides[j]":"uniforms.strides";return`\n      ${x("index")} {\n        if (index < uniforms.size) {\n          let coords = getCoordsFromIndex(index);\n          var flattenIndex = 0;\n          for (var j = 0; j < uniforms.sliceDim; j = j + 1) {\n            let indexTemp = i32(round(getIndices(coords[0], j)));\n            let strideNum = ${e};\n            flattenIndex = flattenIndex + indexTemp * strideNum;\n          }\n\n          setOutputAtIndex(index, getA(flattenIndex, coords[1]));\n        }\n      }\n      `}}const Wr={kernelName:t.GatherNd,backendName:"webgpu",kernelFunc:function(e){const{inputs:n,backend:i}=e,{params:r,indices:s}=n,a=s.shape,o=a[a.length-1],u=t.util.sizeFromShape(r.shape),[l,d,h,p]=t.backend_util.prepareAndValidate(r,s),c=ae({inputs:{x:s},backend:i,attrs:{shape:[d,o]}}),f=ae({inputs:{x:r},backend:i,attrs:{shape:[t.util.sizeFromShape(r.shape)/h,h]}});if(i.shouldExecuteOnCPU([r,s])||"string"===r.dtype){const e=i.readSync(s.dataId),t=i.bufferSync(r),n=pt(e,t,r.dtype,d,o,h,p,r.shape,u);return i.makeTensorInfo(l,r.dtype,n.values)}const m=new Er(o,[d,h]),g=[{type:"int32",data:[o]},{type:"int32",data:p}],x=i.runWebGPUProgram(m,[f,c],f.dtype,g),b=ae({inputs:{x:x},backend:i,attrs:{shape:l}});return i.disposeData(c.dataId),i.disposeData(f.dataId),i.disposeData(x.dataId),b}};class Lr{constructor(e,t){this.variableNames=["A","indices"],this.workgroupSize=[64,1,1],this.size=!0,this.outputShape=e.slice(),this.aShape=e,this.outputShape=t,this.dispatchLayout=N(this.outputShape),this.dispatch=$(this.dispatchLayout,this.outputShape,this.workgroupSize),this.shaderKey="gather"}getUserCode(){const e=function(e){const t=["resRC.x","resRC.y","resRC.z","resRC.w"],n=[];for(let i=0;i<e.length;i++)2===i?n.push("indexZ"):n.push(`${t[i]}`);return n.join()}(this.aShape);return`\n      ${x("index")} {\n        if (index < uniforms.size) {\n          let resRC = getCoordsFromIndex(index);\n          let indexZ = i32(getIndices(resRC.x, resRC.z));\n          let inBounds = select(0.0, 1.0, indexZ >= 0 && indexZ < uniforms.aShape[2]);\n          setOutputAtIndex(index, inBounds * getA(${e}));\n        }\n      }\n    `}}function Br(e){const{inputs:n,backend:i,attrs:r}=e,{x:s,indices:a}=n,{axis:o,batchDims:u}=r,l=t.util.parseAxisParam(o,s.shape)[0],d=t.backend_util.segment_util.collectGatherOpShapeInfo(s,a,l,u),h=t.util.sizeFromShape(a.shape),p=[],c=ae({inputs:{x:s},backend:i,attrs:{shape:[d.batchSize,d.outerSize,d.dimSize,d.sliceSize]}}),f=ae({inputs:{x:a},backend:i,attrs:{shape:[d.batchSize,h/d.batchSize]}});p.push(c),p.push(f);const m=[d.batchSize,d.outerSize,h/d.batchSize,d.sliceSize];if(i.shouldExecuteOnCPU([s,a])){const e=i.tensorMap.get(f.dataId).values,n=t.buffer(f.shape,f.dtype,e),r=i.tensorMap.get(c.dataId).values,s=t.buffer(c.shape,c.dtype,r),a=ct(s,n,m);return p.forEach((e=>i.disposeData(e.dataId))),i.makeTensorInfo(d.outputShape,a.dtype,a.values)}const g=new Lr(c.shape,m),x=i.runWebGPUProgram(g,[c,f],c.dtype);p.push(x);const b=ae({inputs:{x:x},backend:i,attrs:{shape:d.outputShape}});return p.forEach((e=>i.disposeData(e.dataId))),b}const Or={kernelName:t.GatherV2,backendName:"webgpu",kernelFunc:Br},Ur=be({opType:B.GREATER,cpuKernelImpl:mt,dtype:"bool"}),Mr={kernelName:t.Greater,backendName:"webgpu",kernelFunc:Ur},Vr=be({opType:B.GREATER_EQUAL,dtype:"bool",cpuKernelImpl:ft}),Gr={kernelName:t.GreaterEqual,backendName:"webgpu",kernelFunc:Vr};const Hr={kernelName:t.IFFT,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:n}=e,{input:i}=t;return wr(i,!0,n)}},Xr=xe({opType:U.IS_FINITE,dtype:"bool"}),Kr={kernelName:t.IsFinite,backendName:"webgpu",kernelFunc:Xr},qr=xe({opType:U.IS_INF,dtype:"bool"}),Yr={kernelName:t.IsInf,backendName:"webgpu",kernelFunc:qr},jr=xe({opType:U.IS_NAN,dtype:"bool"}),Qr={kernelName:t.IsNan,backendName:"webgpu",kernelFunc:jr};const Zr={kernelName:t.LeakyRelu,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:n,attrs:i}=e,{x:r}=t,{alpha:s}=i,a=[{type:"float32",data:[s]}],o=new ge(r.shape,U.LEAKYRELU,"alpha : f32,");return n.runWebGPUProgram(o,[r],"float32",a)}},Jr=be({opType:B.LESS,dtype:"bool",cpuKernelImpl:xt}),es={kernelName:t.Less,backendName:"webgpu",kernelFunc:Jr},ts=be({opType:B.LESS_EQUAL,dtype:"bool",cpuKernelImpl:gt}),ns={kernelName:t.LessEqual,backendName:"webgpu",kernelFunc:ts};class is{constructor(e){this.variableNames=[],this.outputShape=[],this.uniforms="start : f32, step : f32,",this.workgroupSize=[64,1,1],this.size=!0,this.outputShape=[e],this.dispatchLayout=N(this.outputShape),this.dispatch=$(this.dispatchLayout,this.outputShape,this.workgroupSize),this.shaderKey="linSpace"}getUserCode(){return`\n      ${x("index")} {\n        if (index < uniforms.size) {\n          setOutputAtIndex(index, uniforms.start + f32(index) * uniforms.step);\n        }\n      }\n    `}}const rs={kernelName:t.LinSpace,backendName:"webgpu",kernelFunc:function(e){const{backend:t,attrs:n}=e,{start:i,stop:r,num:s}=n,a=(r-i)/(s-1),o=new is(s),u=[{type:"float32",data:[i]},{type:"float32",data:[a]}];return t.runWebGPUProgram(o,[],"float32",u)}},ss=xe({opType:U.LOG,cpuKernelImpl:bt}),as={kernelName:t.Log,backendName:"webgpu",kernelFunc:ss},os=xe({opType:U.LOG1P}),us={kernelName:t.Log1p,backendName:"webgpu",kernelFunc:os},ls=be({opType:B.LOGICAL_AND,dtype:"bool"}),ds={kernelName:t.LogicalAnd,backendName:"webgpu",kernelFunc:ls},hs=xe({opType:U.LOGICAL_NOT}),ps={kernelName:t.LogicalNot,backendName:"webgpu",kernelFunc:hs},cs=be({opType:B.LOGICAL_OR}),fs={kernelName:t.LogicalOr,backendName:"webgpu",kernelFunc:cs},ms="\n  var powValue = 0.0;\n  let basis = uniforms.bias + uniforms.alpha * sum;\n  if (uniforms.beta == 0.5) {\n    powValue = inverseSqrt(basis);\n  } else if (uniforms.beta == 1.0) {\n    powValue = 1.0 / basis;\n  } else {\n    powValue = exp(log(basis) * (-uniforms.beta));\n  }\n";class gs{constructor(e){this.outputShape=[],this.variableNames=["x"],this.uniforms="radius : i32, bias : f32, alpha : f32, beta : f32,",this.workgroupSize=[64,1,1],this.size=!0,this.outputShape=e,this.dispatchLayout=N(this.outputShape),this.dispatch=$(this.dispatchLayout,this.outputShape,this.workgroupSize),this.shaderKey="lrn"}getUserCode(){return`\n    ${x("index")} {\n      if (index < uniforms.size) {\n        let coords = getOutputCoords();\n        let b = coords[0];\n        let r = coords[1];\n        let c = coords[2];\n        let d = coords[3];\n\n        let x = getX(b, r, c, d);\n        var sum = 0.0;\n        for (var i = -uniforms.radius; i <= uniforms.radius; i = i + 1) {\n          let idx = d + i;\n          if (idx >= 0 && idx < uniforms.xShape[3]) {\n            let z = getX(b, r, c, idx);\n            sum = sum + z * z;\n          }\n        }\n        ${ms}\n\n        setOutputAtIndex(index, x * powValue);\n      }\n    }\n  `}}class xs{constructor(e,n){this.outputShape=[],this.variableNames=["x"],this.uniforms="radius : i32, bias : f32, alpha : f32, beta : f32,",this.workgroupSize=[256,1,1],this.maxAllowRadius=16,t.util.assert(n<=this.maxAllowRadius,(()=>`Radius must be less than or equal to ${this.maxAllowRadius}, current radius is ${n}`)),this.outputShape=e,this.elementsPerWorkgroup=this.workgroupSize[0]-2*this.maxAllowRadius,this.dispatchLayout={x:[3],y:[2],z:[0,1]},this.dispatch=$(this.dispatchLayout,this.outputShape,[this.elementsPerWorkgroup,this.workgroupSize[1],this.workgroupSize[2]]),this.shaderKey="lrn_shared"}getUserCode(){return`\n    var <workgroup>lrnSub: array<f32, ${this.workgroupSize[0]}>;\n    const elementsPerWorkgroup = ${this.elementsPerWorkgroup};\n    const maxAllowRadius = ${this.maxAllowRadius};\n\n    ${x()} {\n      let localDepth = i32(localId.x);\n      let workgroupDepth = i32(workgroupId.x) * elementsPerWorkgroup;\n      let xDepth = workgroupDepth + localDepth - maxAllowRadius;\n      let b = i32(globalId.z) / uniforms.xShape[1];\n      let r = i32(globalId.z) - b * uniforms.xShape[1];\n      let c = i32(globalId.y);\n      let d = workgroupDepth + localDepth;\n\n      var x = 0.0;\n      if (xDepth >= 0 && xDepth < uniforms.xShape[3]) {\n        x = getX(b, r, c, xDepth);\n      }\n      lrnSub[localDepth] = x;\n      workgroupBarrier();\n\n      if (localDepth < elementsPerWorkgroup && d < uniforms.outShape[3]) {\n        var sum = 0.0;\n        let index = localDepth + maxAllowRadius;\n        for (var i = -uniforms.radius; i <= uniforms.radius; i = i + 1) {\n          let z = lrnSub[index + i];\n          sum = sum + z * z;\n        }\n        ${ms}\n\n        setOutputAtCoords(b, r, c, d, lrnSub[index] * powValue);\n      }\n    } `}}const bs={kernelName:t.LRN,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:n,attrs:i}=e,{x:r}=t,{depthRadius:s,bias:a,alpha:o,beta:u}=i;let l;l=s>16?new gs(r.shape):new xs(r.shape,s);const d=[{type:"int32",data:[s]},{type:"float32",data:[a]},{type:"float32",data:[o]},{type:"float32",data:[u]}];return n.runWebGPUProgram(l,[r],r.dtype,d)}};class ys{constructor(e){this.outputShape=[],this.variableNames=["inputImage","outputImage","dy"],this.uniforms="depthRadius : i32, bias : f32, alpha : f32, beta : f32,",this.workgroupSize=[64,1,1],this.size=!0,this.outputShape=e,this.dispatchLayout=N(this.outputShape),this.dispatch=$(this.dispatchLayout,this.outputShape,this.workgroupSize),this.shaderKey="lrn_grad"}getUserCode(){return`\n    ${x("index")} {\n      if (index < uniforms.size) {\n        let coords = getOutputCoords();\n        let b = coords[0];\n        let r = coords[1];\n        let c = coords[2];\n\n        let MIN_DEPTH_BEGIN = 0;\n        let MAX_DEPTH_END = uniforms.outShape[3];\n        var result = 0.0;\n        for (var d = MIN_DEPTH_BEGIN; d < MAX_DEPTH_END; d++) {\n          let depthBegin = max(MIN_DEPTH_BEGIN, d - uniforms.depthRadius);\n          let depthEnd = min(MAX_DEPTH_END, d + uniforms.depthRadius + 1);\n\n          var norm = 0.0;\n          for (var k = MIN_DEPTH_BEGIN; k < MAX_DEPTH_END; k++) {\n            if (k < depthBegin) {\n              continue;\n            } else if (k >= depthBegin && k < depthEnd) {\n              norm += getInputImage(b, r, c, k) * getInputImage(b, r, c, k);\n            } else {\n              break;\n            }\n          }\n\n          norm = uniforms.alpha * norm + uniforms.bias;\n\n          for (var k = MIN_DEPTH_BEGIN; k < MAX_DEPTH_END; k++) {\n            if (k < depthBegin) {\n              continue;\n            } else if (k >= depthBegin && k < depthEnd) {\n              var dyi = -2.0 * uniforms.alpha * uniforms.beta\n                * getInputImage(b, r, c, k) * getOutputImage(b, r, c, d) / norm;\n              if (k == d) {\n                dyi += pow(norm, -1.0 * uniforms.beta);\n              }\n              if (k == coords[3]) {\n                dyi *= getDy(b, r, c, d);\n                result += dyi;\n              }\n            } else {\n              break;\n            }\n          }\n        }\n\n        setOutputAtIndex(index, result);\n      }\n    }\n  `}}const ws={kernelName:t.LRNGrad,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:n,attrs:i}=e,{x:r,y:s,dy:a}=t,{depthRadius:o,bias:u,alpha:l,beta:d}=i,h=new ys(r.shape),p=[{type:"int32",data:[o]},{type:"float32",data:[u]},{type:"float32",data:[l]},{type:"float32",data:[d]}];return n.runWebGPUProgram(h,[r,s,a],r.dtype,p)}},Cs=be({opType:B.MAX,cpuKernelImpl:wt}),ks={kernelName:t.Maximum,backendName:"webgpu",kernelFunc:Cs};const Ss={kernelName:t.MaxPool,backendName:"webgpu",kernelFunc:function(e){const{inputs:n,backend:i,attrs:r}=e,{x:s}=n,{filterSize:a,strides:o,pad:u,dimRoundingMode:l}=r;return Sn(s,t.backend_util.computePool2DInfo(s.shape,a,o,1,u,l),"max",i)}};const vs={kernelName:t.MaxPool3D,backendName:"webgpu",kernelFunc:function(e){const{inputs:n,backend:i,attrs:r}=e,{x:s}=n,{filterSize:a,strides:o,pad:u,dataFormat:l,dimRoundingMode:d}=r,h=t.backend_util.computePool3DInfo(s.shape,a,o,[1,1,1],u,d,l),p=new bn(h,"max"),c=[{type:"int32",data:[h.strideDepth,h.strideHeight,h.strideWidth]},{type:"int32",data:[h.padInfo.front,h.padInfo.top,h.padInfo.left]},{type:"int32",data:[h.inDepth,h.inHeight,h.inWidth]},{type:"int32",data:[h.effectiveFilterDepth,h.effectiveFilterHeight,h.effectiveFilterWidth]}];return i.runWebGPUProgram(p,[s],s.dtype,c)}};class Is{constructor(e){this.variableNames=["dy","maxPos"],this.uniforms="strides : vec2<i32>, pads : vec2<i32>, dilations : vec2<i32>, filterDims : vec2<i32>,\n       outHeight : i32, outWidth : i32",this.workgroupSize=[64,1,1],this.size=!0,this.outputShape=e.inShape,this.dispatchLayout=N(this.outputShape),this.dispatch=$(this.dispatchLayout,this.outputShape,this.workgroupSize),this.shaderKey="maxPool2DBackprop"}getUserCode(){return`\n      ${x("index")} {\n      if (index < uniforms.size) {\n        let coords = getCoordsFromIndex(index);\n        let batch = coords[0];\n        let d = coords[3];\n\n        let dyRCCorner = vec2<i32>(coords.yz) - uniforms.pads;\n        let dyRCorner = dyRCCorner.x;\n        let dyCCorner = dyRCCorner.y;\n\n        // Convolve dy(?, ?, d) with pos mask(:, :, d) to get dx(xR, xC, d).\n        // ? = to be determined. : = across all values in that axis.\n        var dotProd = 0.0;\n        let lastIndex = uniforms.filterDims[0] * uniforms.filterDims[1] - 1;\n        for (var wR = 0; wR < uniforms.filterDims[0]; wR += uniforms.dilations[0]) {\n          let dyR = f32(dyRCorner + wR) / f32(uniforms.strides[0]);\n\n          if (dyR < 0.0 || dyR >= f32(uniforms.outHeight) || fract(dyR) > 0.0) {\n            continue;\n          }\n          let idyR = i32(dyR);\n\n          for (var wC = 0; wC < uniforms.filterDims[1]; wC += uniforms.dilations[1]) {\n            let dyC = f32(dyCCorner + wC) / f32(uniforms.strides[1]);\n\n            if (dyC < 0.0 || dyC >= f32(uniforms.outWidth) || fract(dyC) > 0.0) {\n              continue;\n            }\n            let idyC = i32(dyC);\n\n            let dyValue = getDy(batch, idyR, idyC, d);\n            let maxPosValue = lastIndex - i32(getMaxPos(batch, idyR, idyC, d));\n\n            // Get the current value, check it against the value from the\n            // position matrix.\n            let curPosValue = wR * uniforms.filterDims[1] + wC;\n            let mask = select(0.0, 1.0, maxPosValue == curPosValue);\n            dotProd += dyValue * mask;\n          }\n        }\n        setOutputAtIndex(index, dotProd);\n      }\n    }\n    `}}class Rs{constructor(e){this.variableNames=["dy","maxPos"],this.uniforms="strides : vec3<i32>, pads : vec3<i32>, filterDims : vec3<i32>,\n      outDepth : i32, outHeight : i32, outWidth : i32",this.workgroupSize=[64,1,1],this.size=!0,this.outputShape=e.inShape,this.dispatchLayout=N(this.outputShape),this.dispatch=$(this.dispatchLayout,this.outputShape,this.workgroupSize),this.shaderKey="maxPool3DBackprop"}getUserCode(){return`\n      ${x("index")} {\n      if (index < uniforms.size) {\n        let coords = getCoordsFromIndex(index);\n        let batch = coords.x;\n        let ch = coords.u;\n\n        let dyCorner = vec3<i32>(coords.y, coords.z, coords.w) - uniforms.pads;\n        let dyDCorner = dyCorner.x;\n        let dyRCorner = dyCorner.y;\n        let dyCCorner = dyCorner.z;\n\n        // Convolve dy(?, ?, ?, ch) with pos mask(:, :, :, d) to get\n        // dx(xD, xR, xC, ch).\n        // ? = to be determined. : = across all values in that axis.\n        var dotProd = 0.0;\n        let lastIndex = uniforms.filterDims[0] * uniforms.filterDims[1] * uniforms.filterDims[2] - 1;\n\n        for (var wD = 0; wD < uniforms.filterDims[0]; wD++) {\n          let dyD = f32(dyDCorner + wD) / f32(uniforms.strides[0]);\n\n          if (dyD < 0.0 || dyD >= f32(uniforms.outDepth) || fract(dyD) > 0.0) {\n            continue;\n          }\n          let idyD = i32(dyD);\n\n          for (var wR = 0; wR < uniforms.filterDims[1]; wR++) {\n            let dyR = f32(dyRCorner + wR) / f32(uniforms.strides[1]);\n\n            if (dyR < 0.0 || dyR >= f32(uniforms.outHeight) || fract(dyR) > 0.0) {\n              continue;\n            }\n            let idyR = i32(dyR);\n\n            for (var wC = 0; wC < uniforms.filterDims[2]; wC++) {\n              let dyC = f32(dyCCorner + wC) / f32(uniforms.strides[2]);\n\n              if (dyC < 0.0 || dyC >= f32(uniforms.outWidth) || fract(dyC) > 0.0) {\n                continue;\n              }\n              let idyC = i32(dyC);\n\n              let dyValue = getDy(batch, idyD, idyR, idyC, ch);\n              let maxPosValue = lastIndex - i32(getMaxPos(batch, idyD, idyR, idyC, ch));\n\n              // Get the current value, check it against the value from the\n              // position matrix.\n              let curPosValue = wD * uniforms.filterDims[1] * uniforms.filterDims[2] + wR * uniforms.filterDims[2] + wC;\n              let mask = select(0.0, 1.0, maxPosValue == curPosValue);\n              dotProd += dyValue * mask;\n            }\n          }\n        }\n\n        setOutputAtIndex(index, dotProd);\n      }\n    }\n    `}}const $s={kernelName:t.MaxPool3DGrad,backendName:"webgpu",kernelFunc:function(e){const{inputs:n,backend:i,attrs:r}=e,{dy:s,input:a}=n,o=a,{filterSize:u,strides:l,pad:d,dimRoundingMode:h}=r,p=t.backend_util.computePool3DInfo(o.shape,u,l,[1,1,1],d,h),c=new bn(p,"max",!0);let f=[{type:"int32",data:[p.strideDepth,p.strideHeight,p.strideWidth]},{type:"int32",data:[p.padInfo.front,p.padInfo.top,p.padInfo.left]},{type:"int32",data:[p.inDepth,p.inHeight,p.inWidth]},{type:"int32",data:[p.effectiveFilterDepth,p.effectiveFilterHeight,p.effectiveFilterWidth]}];const m=i.runWebGPUProgram(c,[o],"int32",f),g=new Rs(p);f=[{type:"int32",data:[p.strideDepth,p.strideHeight,p.strideWidth]},{type:"int32",data:[p.effectiveFilterDepth-1-p.padInfo.front,p.effectiveFilterHeight-1-p.padInfo.top,p.effectiveFilterWidth-1-p.padInfo.left]},{type:"int32",data:[p.effectiveFilterDepth,p.effectiveFilterHeight,p.effectiveFilterWidth]},{type:"int32",data:[p.outDepth]},{type:"int32",data:[p.outHeight]},{type:"int32",data:[p.outWidth]}];const x=i.runWebGPUProgram(g,[s,m],o.dtype,f);return i.disposeData(m.dataId),x}};const Ps={kernelName:t.MaxPoolGrad,backendName:"webgpu",kernelFunc:function(e){const{inputs:n,backend:i,attrs:r}=e,{dy:s,input:a,output:o}=n,u=a;F([a,o],"maxPoolGrad");const{filterSize:l,strides:d,pad:h,dimRoundingMode:p}=r,c=t.backend_util.computePool2DInfo(u.shape,l,d,1,h,p),f=new xn(c,"max",!0);let m=[{type:"int32",data:[c.strideHeight,c.strideWidth]},{type:"int32",data:[c.padInfo.top,c.padInfo.left]},{type:"int32",data:[c.dilationHeight,c.dilationWidth]},{type:"int32",data:[c.inHeight,c.inWidth]},{type:"int32",data:[c.effectiveFilterHeight,c.effectiveFilterWidth]}];const g=i.runWebGPUProgram(f,[u],"int32",m),x=new Is(c);m=[{type:"int32",data:[c.strideHeight,c.strideWidth]},{type:"int32",data:[c.effectiveFilterHeight-1-c.padInfo.top,c.effectiveFilterWidth-1-c.padInfo.left]},{type:"int32",data:[c.dilationHeight,c.dilationWidth]},{type:"int32",data:[c.effectiveFilterHeight,c.effectiveFilterWidth]},{type:"int32",data:[c.outHeight]},{type:"int32",data:[c.outWidth]}];const b=i.runWebGPUProgram(x,[s,g],u.dtype,m);return i.disposeData(g.dataId),b}};const As={kernelName:t.MaxPoolWithArgmax,backendName:"webgpu",kernelFunc:function(e){const{inputs:n,backend:i,attrs:r}=e,{filterSize:s,strides:a,pad:o,includeBatchInIndex:u}=r,{x:l}=n;t.util.assert(4===l.shape.length,(()=>`Error in maxPool: input must be rank 4 but got rank ${l.shape.length}.`));const d=[1,1];t.util.assert(t.backend_util.eitherStridesOrDilationsAreOne(a,d),(()=>`Error in maxPool: Either strides or dilations must be 1. Got strides ${a} and dilations '${d}'`));const h=t.backend_util.computePool2DInfo(l.shape,s,a,d,o),p=[{type:"int32",data:[h.strideHeight,h.strideWidth]},{type:"int32",data:[h.padInfo.top,h.padInfo.left]},{type:"int32",data:[h.dilationHeight,h.dilationWidth]},{type:"int32",data:[h.inHeight,h.inWidth]},{type:"int32",data:[h.effectiveFilterHeight,h.effectiveFilterWidth]}];let c=new xn(h,"max",!1);const f=i.runWebGPUProgram(c,[l],l.dtype,p);return c=new xn(h,"max",!0,!0,u),[f,i.runWebGPUProgram(c,[l],"int32",p)]}};const zs={kernelName:t.Min,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:n,attrs:i}=e,{x:r}=t,{axis:s,keepDims:a}=i;return Jt(r,s,a,"min",n)}},Ns=be({opType:B.MIN,cpuKernelImpl:Ct}),Ds={kernelName:t.Minimum,backendName:"webgpu",kernelFunc:Ns};class Ts{constructor(e,t,n){this.uniforms="",this.variableNames=["x"],this.workgroupSize=[64,1,1],this.size=!0,this.outputShape=t.map(((t,n)=>t[0]+e[n]+t[1])),this.dispatchLayout=N(this.outputShape),this.dispatch=$(this.dispatchLayout,this.outputShape,this.workgroupSize),this.xShape=e,t.map(((e,t)=>{this.uniforms+=` pad${t} : vec2<i32>,`})),this.offset="reflect"===n?0:1,this.shaderKey=`mirrorPad_${n}`}getUserCode(){const e=this.xShape.length,t=this.xShape.map(((e,t)=>`uniforms.pad${t}[0]`)).join(","),n=this.xShape.map(((t,n)=>`uniforms.pad${n}[0] + uniforms.xShape${e>1?`[${n}]`:""}`)).join(","),i=1===e?"start":"start[i]",r=1===e?"end":"end[i]",s=1===e?"outC":"outC[i]",a=m(e),o=e>1?["coords[0]","coords[1]","coords[2]","coords[3]"].slice(0,e):"coords";return`\n      ${x("index")} {\n        if (index < uniforms.size) {\n          let start = ${a}(${t});\n          let end = ${a}(${n});\n          var outC = getCoordsFromIndex(index);\n          for (var i = 0; i < ${e}; i = i + 1) {\n            if (${s} < ${i}) {\n              ${s} = ${i} * 2 - ${s} - ${this.offset};\n            } else if(${s} >= ${r}) {\n              ${s} = (${r} - 1) * 2 - ${s} + ${this.offset};\n            }\n          }\n          let coords = outC - start;\n          setOutputAtIndex(index, getX(${o}));\n        }\n      }\n    `}}const Fs={kernelName:t.MirrorPad,backendName:"webgpu",kernelFunc:({inputs:e,attrs:t,backend:n})=>{const{x:i}=e,{paddings:r,mode:s}=t,a=n,o=r.map((e=>({type:"int32",data:[e[0],e[1]]}))),u=new Ts(i.shape,r,s);return a.runWebGPUProgram(u,[i],i.dtype,o)}},_s=be({opType:B.MOD}),Es={kernelName:t.Mod,backendName:"webgpu",kernelFunc:_s};class Ws{constructor(e,t){this.variableNames=["probs"],this.outputShape=[],this.uniforms="seed : f32, numOutcomes: i32,",this.workgroupSize=[64,1,1],this.size=!0,this.outputShape=[e,t],this.dispatchLayout=N(this.outputShape),this.dispatch=$(this.dispatchLayout,this.outputShape,this.workgroupSize),this.shaderKey="multinomial"}getUserCode(){return`\n    //Based on the work of Dave Hoskins\n    //https://www.shadertoy.com/view/4djSRW\n    fn random (seed : f32, resultUV : vec2<f32>) -> f32 {\n      let HASHSCALE1 = 443.8975;\n      let p = resultUV * seed;\n      var p3  = fract(vec3<f32>(p.xyx) * HASHSCALE1);\n      p3 = p3 + dot(p3, p3.yzx + 19.19);\n      return fract((p3.x + p3.y) * p3.z);\n    }\n\n    ${x("index")} {\n      if (index < uniforms.size) {\n        let coords = getOutputCoords();\n        let batch = coords[0];\n\n        let resUV = vec2<f32>(f32(coords[1]) / f32(uniforms.outShape[1]),\n            f32(coords[0]) / f32(uniforms.outShape[0]));\n        let r = random(uniforms.seed, resUV);\n        var cdf = 0.0;\n        for (var i = 0; i < uniforms.numOutcomes - 1; i = i + 1) {\n          cdf = cdf + getProbs(batch, i);\n\n          if (r < cdf) {\n            setOutputAtIndexI32(index, i);\n            return;\n          }\n        }\n\n        // If no other event happened, last event happened.\n        setOutputAtIndexI32(index, uniforms.numOutcomes - 1);\n      }\n    }\n  `}}class Ls{constructor(e){this.variableNames=["logits"],this.outputShape=e,this.dispatchLayout=N(this.outputShape),this.dispatch=[this.outputShape[0],1,1],this.outputShape[1]>=4096?this.workgroupSize=[256,1,1]:this.workgroupSize=[64,1,1],this.shaderKey="softmax"}getUserCode(){return`\n    var<workgroup> buf : array<f32, ${this.workgroupSize[0]}>;\n    var<workgroup> rowMaxShared : f32;\n    var<workgroup> rowSumShared : f32;\n    const blockSize = ${this.workgroupSize[0]};\n    ${x("index")} {\n      let row = index / blockSize;\n      let tid = i32(localId.x);\n      let cols = uniforms.outShape[1];\n\n      var threadMax = -3.402823e+38f;\n      for (var col = tid; col < cols; col += blockSize) {\n        let value = getLogits(row, col);\n        threadMax = max(threadMax, value);\n      }\n      if (tid < cols) {\n        buf[tid] = threadMax;\n      }\n      workgroupBarrier();\n\n      var reduceSize = min(cols, blockSize);\n      for (var currSize = reduceSize >> 1;  currSize > 0; currSize = reduceSize >> 1) {\n        reduceSize = currSize + (reduceSize & 1);\n        if (tid < currSize) {\n          buf[tid] = max(buf[tid], buf[tid + reduceSize]);\n        }\n        workgroupBarrier();\n      }\n\n      if (tid == 0) {\n        rowMaxShared = buf[0];\n      }\n      workgroupBarrier();\n\n      var threadSum = 0.0;\n      for (var col = tid; col < cols; col += blockSize) {\n        let subExp = exp(getLogits(row, col) - rowMaxShared);\n        threadSum += subExp;\n      }\n      buf[tid] = threadSum;\n      workgroupBarrier();\n\n      for (var currSize = blockSize >> 1;  currSize > 0; currSize = currSize >> 1) {\n        if (tid < currSize) {\n          buf[tid] = buf[tid] + buf[tid + currSize];\n        }\n        workgroupBarrier();\n      }\n\n      if (tid == 0) {\n        rowSumShared = buf[0];\n      }\n      workgroupBarrier();\n\n      for (var col = tid; col < cols; col += blockSize) {\n        let value = exp(getLogits(row, col) - rowMaxShared) / rowSumShared;\n        setOutputAtCoords(row, col, value);\n      }\n  }\n    `}}function Bs(e){const{inputs:n,backend:i,attrs:r}=e,{logits:s}=n,{dim:a}=r,o=ae({inputs:{x:s},backend:i,attrs:{shape:[t.util.sizeFromShape(s.shape)/s.shape[a],s.shape[a]]}}),u=new Ls(o.shape),l=i.runWebGPUProgram(u,[o],s.dtype),d=ae({inputs:{x:l},backend:i,attrs:{shape:s.shape}});return i.disposeData(o.dataId),i.disposeData(l.dataId),d}const Os={kernelName:t.Softmax,backendName:"webgpu",kernelFunc:Bs};const Us={kernelName:t.Multinomial,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:n,attrs:i}=e,{logits:r}=t,{numSamples:s,seed:a,normalized:o}=i,u=o?r:Bs({inputs:{logits:r},backend:n,attrs:{dim:r.shape.length-1}}),l=u.shape[0],d=u.shape[1],h=new Ws(l,s),p=[{type:"float32",data:[a]},{type:"int32",data:[d]}],c=n.runWebGPUProgram(h,[u],"int32",p);return o||n.disposeData(u.dataId),c}};const Ms={kernelName:t.Neg,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:n}=e,{x:i}=t;if(n.shouldExecuteOnCPU([i])){const e=n.tensorMap.get(i.dataId),[t,r]=St(e.values,i.shape,i.dtype);return n.makeTensorInfo(r,i.dtype,t)}const r=new ge(i.shape,U.NEG);return n.runWebGPUProgram(r,[i],i.dtype)}};const Vs={kernelName:t.NonMaxSuppressionV3,backendName:"webgpu",kernelFunc:function(e){console.warn("tf.nonMaxSuppression() in webgpu locks the UI thread. Call tf.nonMaxSuppressionAsync() instead");const{inputs:n,backend:i,attrs:r}=e,{boxes:s,scores:a}=n,{maxOutputSize:o,iouThreshold:u,scoreThreshold:l}=r,d=i.readSync(s.dataId),h=i.readSync(a.dataId),{selectedIndices:p}=t.kernel_impls.nonMaxSuppressionV3Impl(d,h,o,u,l);return i.makeTensorInfo([p.length],"int32",new Int32Array(p))}};const Gs={kernelName:t.NonMaxSuppressionV5,backendName:"webgpu",kernelFunc:function(e){console.warn("tf.nonMaxSuppression() in webgpu locks the UI thread. Call tf.nonMaxSuppressionAsync() instead");const{inputs:n,backend:i,attrs:r}=e,{boxes:s,scores:a}=n,{maxOutputSize:o,iouThreshold:u,scoreThreshold:l,softNmsSigma:d}=r,h=i.readSync(s.dataId),p=i.readSync(a.dataId),c=o,f=u,m=l,g=d,{selectedIndices:x,selectedScores:b}=t.kernel_impls.nonMaxSuppressionV5Impl(h,p,c,f,m,g);return[i.makeTensorInfo([x.length],"int32",new Int32Array(x)),i.makeTensorInfo([b.length],"float32",new Float32Array(b))]}};class Hs{constructor(e,t){this.variableNames=["x"],this.uniforms="onValue : f32, offValue : f32,",this.workgroupSize=[64,1,1],this.size=!0,this.outputShape=[e,t],this.dispatchLayout=N(this.outputShape),this.dispatch=$(this.dispatchLayout,this.outputShape,this.workgroupSize),this.shaderKey="onehot"}getUserCode(){return`\n      ${x("index")} {\n        if(index < uniforms.size) {\n          let coords = getCoordsFromIndex(index);\n          setOutputAtIndex(index, mix(uniforms.offValue, uniforms.onValue,\n                                      f32(i32(round(getX(coords.x))) == coords.y)));\n        }\n      }\n    `}}const Xs={kernelName:t.OneHot,backendName:"webgpu",kernelFunc:function(e){const{inputs:n,backend:i,attrs:r}=e,{indices:s}=n,{dtype:a,depth:o,onValue:u,offValue:l}=r,d=t.util.sizeFromShape(s.shape),h=new Hs(d,o),p=ae({inputs:{x:s},backend:i,attrs:{shape:[d]}}),c=[{type:"float32",data:[u]},{type:"float32",data:[l]}],f=i.runWebGPUProgram(h,[p],a,c);i.disposeData(p.dataId);const m=ae({inputs:{x:f},backend:i,attrs:{shape:[...s.shape,o]}});return i.disposeData(f.dataId),m}};function Ks(e){const{inputs:t,backend:n}=e,{x:i}=t;if("complex64"===i.dtype){const e=Vn({inputs:{input:i},backend:n}),t=Ks({inputs:{x:e},backend:n}),r=ti({inputs:{input:i},backend:n}),s=Ks({inputs:{x:r},backend:n}),a=fe({inputs:{real:t,imag:s},backend:n});return n.disposeData(e.dataId),n.disposeData(t.dataId),n.disposeData(r.dataId),n.disposeData(s.dataId),a}return re({attrs:{shape:i.shape,dtype:i.dtype,value:"string"===i.dtype?"":0},backend:n})}const qs={kernelName:t.ZerosLike,backendName:"webgpu",kernelFunc:Ks};const Ys={kernelName:t.OnesLike,backendName:"webgpu",kernelFunc:function e(t){const{inputs:n,backend:i}=t,{x:r}=n;if("string"===r.dtype)throw new Error("onesLike is not supported under string dtype");if("complex64"===r.dtype){const t=Vn({inputs:{input:r},backend:i}),n=e({inputs:{x:t},backend:i}),s=ti({inputs:{input:r},backend:i}),a=Ks({inputs:{x:s},backend:i}),o=fe({inputs:{real:n,imag:a},backend:i});return i.disposeData(t.dataId),i.disposeData(n.dataId),i.disposeData(s.dataId),i.disposeData(a.dataId),o}return re({attrs:{shape:r.shape,dtype:r.dtype,value:1},backend:i})}};const js={kernelName:t.Pack,backendName:"webgpu",kernelFunc:function(e){const{inputs:n,backend:i,attrs:r}=e,{axis:s}=r;if(1===n.length)return mr({inputs:{input:n[0]},backend:i,attrs:{dim:s}});const a=n[0].shape,o=n[0].dtype;n.forEach((e=>{t.util.assertShapesMatch(a,e.shape,"All tensors passed to stack must have matching shapes"),t.util.assert(o===e.dtype,(()=>"All tensors passed to stack must have matching dtypes"))}));const u=[],l=ri({inputs:n.map((e=>{const t=mr({inputs:{input:e},backend:i,attrs:{dim:s}});return u.push(t),t})),backend:i,attrs:{axis:s}});return u.forEach((e=>i.disposeData(e.dataId))),l}};class Qs{constructor(e,t){this.variableNames=["x"],this.uniforms="constantValue : f32,",this.workgroupSize=[64,1,1],this.size=!0,this.outputShape=t.map(((t,n)=>t[0]+e[n]+t[1])),this.dispatchLayout=N(this.outputShape),this.dispatch=$(this.dispatchLayout,this.outputShape,this.workgroupSize),t.map(((e,t)=>{this.uniforms+=` pad${t} : vec2<i32>,`})),this.xShape=e,this.shaderKey="pad"}getUserCode(){const e=this.xShape.length,t=m(e),n=this.xShape.map(((e,t)=>`uniforms.pad${t}[0]`)).join(","),i=this.xShape.map(((t,n)=>`uniforms.pad${n}[0] + uniforms.xShape${e>1?`[${n}]`:""}`)).join(","),r=e>1?`${t}(${n})`:`${n}`,s=e>1?`${t}(${i})`:`${i}`,a=e>1?"any(outC < start)":"outC < start",o=e>1?"any(outC >= end)":"outC >= end",u=e>1?["coords[0]","coords[1]","coords[2]","coords[3]"].slice(0,e):"coords";return`\n      ${x("index")} {\n        if (index < uniforms.size) {\n          let start = ${r};\n          let end = ${s};\n          let outC = getCoordsFromIndex(index);\n\n          if (${a} || ${o}) {\n            setOutputAtIndex(index, uniforms.constantValue);\n          } else {\n            let coords = outC - start;\n            setOutputAtIndex(index, getX(${u}));\n          }\n        }\n      }\n    `}}const Zs=e=>{const{inputs:n,backend:i,attrs:r}=e,{x:s}=n,{paddings:a,constantValue:o}=r;if(a.every((e=>t.util.arraysEqual(e,[0,0]))))return pe({inputs:{x:s},backend:i});if(0===t.util.sizeFromShape(s.shape)){return re({backend:i,attrs:{shape:a.map(((e,t)=>e[0]+s.shape[t]+e[1])),value:o,dtype:s.dtype}})}const u=[{type:"float32",data:[o]}];a.map((e=>u.push({type:"int32",data:[e[0],e[1]]})));const l=new Qs(s.shape,a);return i.runWebGPUProgram(l,[s],s.dtype,u)},Js={kernelName:t.PadV2,backendName:"webgpu",kernelFunc:Zs},ea=be({opType:B.POW}),ta={kernelName:t.Pow,backendName:"webgpu",kernelFunc:ea};const na={kernelName:t.Prelu,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:n}=e,{x:i,alpha:r}=t,s=new he(B.PRELU,i.shape,r.shape);return n.runWebGPUProgram(s,[i,r],"float32")}};const ia={kernelName:t.Prod,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:n,attrs:i}=e,{x:r}=t,{axis:s,keepDims:a}=i;return Jt(r,s,a,"prod",n)}},ra={kernelName:t.Range,backendName:"webgpu",kernelFunc:e=>{const{backend:t,attrs:n}=e,{start:i,stop:r,step:s,dtype:a}=n,o=Rt(i,r,s,a);return t.makeTensorInfo([o.length],a,o)}},sa=be({opType:B.DIV}),aa={kernelName:t.RealDiv,backendName:"webgpu",kernelFunc:sa},oa=xe({opType:U.RECIPROCAL}),ua={kernelName:t.Reciprocal,backendName:"webgpu",kernelFunc:oa},la=xe({opType:U.RELU}),da={kernelName:t.Relu,backendName:"webgpu",kernelFunc:la},ha=xe({opType:U.RELU6}),pa={kernelName:t.Relu6,backendName:"webgpu",kernelFunc:ha};class ca{constructor(e,t,n){this.variableNames=["x"],this.uniforms="adjustHeightWidth : vec2<f32>, halfPixelCenters : f32,",this.workgroupSize=[64,1,1],this.size=!0,this.outputShape=[e[0],t,n,e[3]],this.dispatchLayout=N(this.outputShape),this.dispatch=$(this.dispatchLayout,this.outputShape,this.workgroupSize),this.shaderKey="resizeBilinear"}getUserCode(){return`\n      ${x("index")} {\n        if (index < uniforms.size) {\n        let coords = getCoordsFromIndex(index);\n          let b = coords[0];\n          let d = coords[3];\n          let rc = coords.yz;\n\n          let effectiveInSize = vec2<f32>(\n            f32(uniforms.xShape.y) - uniforms.adjustHeightWidth[0],\n            f32(uniforms.xShape.z) - uniforms.adjustHeightWidth[1]);\n\n          let effectiveOutSize = vec2<f32>(\n            f32(uniforms.outShape.y) - uniforms.adjustHeightWidth[0],\n            f32(uniforms.outShape.z) - uniforms.adjustHeightWidth[1]);\n\n          let effectiveInputOverOutputRatioRC =\n              effectiveInSize / effectiveOutSize;\n\n          // Fractional source index\n          let sourceFracIndexRC =\n            (vec2<f32>(rc) + vec2<f32>(uniforms.halfPixelCenters)) *\n            effectiveInputOverOutputRatioRC - vec2<f32>(uniforms.halfPixelCenters);\n\n          // Compute the four integer indices.\n          let sourceFloorRC = vec2<i32>(sourceFracIndexRC);\n          let sourceCeilRC = vec2<i32>(\n            min(vec2<f32>(uniforms.xShape.yz) - vec2<f32>(1.0), ceil(sourceFracIndexRC)));\n\n          let topLeft = getX(b, sourceFloorRC.x, sourceFloorRC.y, d);\n          let bottomLeft = getX(b, sourceCeilRC.x, sourceFloorRC.y, d);\n          let topRight = getX(b, sourceFloorRC.x, sourceCeilRC.y, d);\n          let bottomRight = getX(b, sourceCeilRC.x, sourceCeilRC.y, d);\n\n          let fracRC = sourceFracIndexRC - vec2<f32>(sourceFloorRC);\n\n          let top = topLeft + (topRight - topLeft) * fracRC.y;\n          let bottom = bottomLeft + (bottomRight - bottomLeft) * fracRC.y;\n          let newValue = top + (bottom - top) * fracRC.x;\n\n          setOutputAtIndex(index, newValue);\n        }\n      }\n    `}}const fa={kernelName:t.ResizeBilinear,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:n,attrs:i}=e,{images:r}=t,{alignCorners:s,size:a,halfPixelCenters:o}=i,[u,l]=a,d=[{type:"float32",data:[s&&u>1?1:0,s&&l>1?1:0]},{type:"float32",data:[o?.5:0]}],h=new ca(r.shape,u,l);return n.runWebGPUProgram(h,[r],"float32",d)}};class ma{constructor(e,t){this.variableNames=["dy"],this.uniforms="effectiveXSize : vec2<i32>, effectiveYSize : vec2<i32>, heightScale : f32, widthScale : f32,\n       invHeightScale : f32, invWidthScale : f32, winHeight : i32, winWidth : i32,",this.workgroupSize=[64,1,1],this.size=!0,this.outputShape=e,this.dispatchLayout=N(this.outputShape),this.dispatch=$(this.dispatchLayout,this.outputShape,this.workgroupSize),this.alignCorners=t,this.shaderKey=`resizeBilinearBackprop_${t}`}getUserCode(){return`\n      ${x("index")} {\n        if (index < uniforms.size) {\n          let coords = getOutputCoords();\n          let b = coords[0];\n          let d = coords[3];\n          let r = coords[1];\n          let c = coords[2];\n\n          var accumulator = 0.0;\n\n          // Compute bounds for where in dy we will look\n          let startRLerp = floor(f32(r) * uniforms.invHeightScale);\n          let startDyR = i32(startRLerp - f32(uniforms.winHeight / 2));\n\n          let startCLerp = floor(f32(c) * uniforms.invWidthScale);\n          let startDyC = i32(startCLerp - f32(uniforms.winWidth / 2));\n\n          // Loop over dy\n          for (var dyROffset = 0; dyROffset < uniforms.winHeight; dyROffset++) {\n            let dyR = startDyR + dyROffset;\n\n            // Guard against the window exceeding the bounds of dy\n            if (dyR < 0 || dyR >= uniforms.dyShape[1]) {\n              continue;\n            }\n\n            for (var dyCOffset = 0; dyCOffset < uniforms.winWidth; dyCOffset++) {\n              let dyC = startDyC + dyCOffset;\n\n              // Guard against the window exceeding the bounds of dy\n              if (dyC < 0 || dyC >= uniforms.dyShape[2]) {\n                continue;\n              }\n\n              let dxR = f32(dyR) * uniforms.heightScale;\n              let topDxRIndex = i32(floor(dxR));\n              let bottomDxRIndex = i32(min(ceil(dxR), f32(uniforms.outShape[1] - 1)));\n              let dxRLerp = dxR - f32(topDxRIndex);\n              let inverseDxRLerp = 1.0 - dxRLerp;\n\n              let dxC = f32(dyC) * uniforms.widthScale;\n              let leftDxCIndex = i32(floor(dxC));\n              let rightDxCIndex = i32(min(ceil(dxC), f32(uniforms.outShape[2] - 1)));\n              let dxCLerp = dxC - f32(leftDxCIndex);\n              let inverseDxCLerp = 1.0 - dxCLerp;\n\n              if (r == topDxRIndex && c == leftDxCIndex) {\n                // topLeft\n                accumulator +=\n                  getDy(b, dyR, dyC, d) * inverseDxRLerp * inverseDxCLerp;\n              }\n\n              if (r == topDxRIndex && c == rightDxCIndex) {\n                // topRight\n                accumulator += getDy(b, dyR, dyC, d) * inverseDxRLerp * dxCLerp;\n              }\n\n              if (r == bottomDxRIndex && c == leftDxCIndex) {\n                // bottomLeft\n                accumulator += getDy(b, dyR, dyC, d) * dxRLerp * inverseDxCLerp;\n              }\n\n              if (r == bottomDxRIndex && c == rightDxCIndex) {\n                // bottomRight\n                accumulator += getDy(b, dyR, dyC, d) * dxRLerp * dxCLerp;\n              }\n            }\n          }\n          // End loop over dy\n\n          setOutputAtIndex(index, accumulator);\n        }\n      }\n    `}}const ga={kernelName:t.ResizeBilinearGrad,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:n,attrs:i}=e,{images:r,dy:s}=t,{alignCorners:a}=i,[,o,u]=r.shape,[,l,d]=s.shape,h=[a&&l>1?o-1:o,a&&d>1?u-1:u],p=[a&&l>1?l-1:l,a&&d>1?d-1:d],c=h[0]/p[0],f=h[1]/p[1],m=1/c,g=1/f,x=2*Math.ceil(m)+2,b=2*Math.ceil(g)+2,y=new ma(r.shape,a),w=[{type:"int32",data:h},{type:"int32",data:p},{type:"float32",data:[c]},{type:"float32",data:[f]},{type:"float32",data:[m]},{type:"float32",data:[g]},{type:"int32",data:[x]},{type:"int32",data:[b]}];return n.runWebGPUProgram(y,[s],s.dtype,w)}};class xa{constructor(e,t,n,i){this.variableNames=["x"],this.uniforms="adjustHeightWidth : vec2<f32>, roundBase : f32,",this.workgroupSize=[64,1,1],this.size=!0,this.outputShape=[e[0],t,n,e[3]],this.dispatchLayout=N(this.outputShape),this.dispatch=$(this.dispatchLayout,this.outputShape,this.workgroupSize),this.halfPixelCenters=i,this.shaderKey=`resizeNearest_${i}`}getUserCode(){let e;e=this.halfPixelCenters?"max((vec2<f32>(rc) + vec2<f32>(0.5)) * effectiveInputOverOutputRatioRC, vec2<f32>(0.0))":"vec2<f32>(rc) * effectiveInputOverOutputRatioRC";return`\n      ${x("index")} {\n        if (index < uniforms.size) {\n          let coords = getCoordsFromIndex(index);\n          let b = coords[0];\n          let d = coords[3];\n          let rc = coords.yz;\n\n          let effectiveInSize = vec2<f32>(\n            f32(uniforms.xShape.y) - uniforms.adjustHeightWidth[0],\n            f32(uniforms.xShape.z) - uniforms.adjustHeightWidth[1]);\n\n          let effectiveOutSize = vec2<f32>(\n            f32(uniforms.outShape.y) - uniforms.adjustHeightWidth[0],\n            f32(uniforms.outShape.z) - uniforms.adjustHeightWidth[1]);\n\n          let effectiveInputOverOutputRatioRC =\n              effectiveInSize / effectiveOutSize;\n\n          // Fractional source index\n          let sourceFracIndexRC = ${e};\n\n          // Compute the coordinators of nearest neighbor point.\n          let inputShapeRC = vec2<f32>(f32(uniforms.xShape.y), f32(uniforms.xShape.z));\n          let sourceNearestRC = vec2<i32>(\n            min(inputShapeRC - 1.0, floor(sourceFracIndexRC + uniforms.roundBase)));\n          let newValue = getX(b, sourceNearestRC.x, sourceNearestRC.y, d);\n\n          setOutputAtIndex(index, newValue);\n        }\n      }\n    `}}const ba={kernelName:t.ResizeNearestNeighbor,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:n,attrs:i}=e,{images:r}=t,{alignCorners:s,halfPixelCenters:a,size:o}=i,[u,l]=o,d=[{type:"float32",data:[s&&u>1?1:0,s&&l>1?1:0]},{type:"float32",data:[s?.5:0]}],h=new xa(r.shape,u,l,a);return n.runWebGPUProgram(h,[r],r.dtype,d)}};class ya{constructor(e,t){this.variableNames=["dy"],this.uniforms="effectiveXSize : vec2<i32>, effectiveYSize : vec2<i32>, invHeightScale : f32, invWidthScale : f32,\n       winHeight : i32, winWidth : i32,",this.workgroupSize=[64,1,1],this.size=!0,this.outputShape=e,this.dispatchLayout=N(this.outputShape),this.dispatch=$(this.dispatchLayout,this.outputShape,this.workgroupSize),this.alignCorners=t,this.shaderKey=`resizeNearestNeigborBackprop_${t}`}getUserCode(){return`\n      ${x("index")} {\n        if (index < uniforms.size) {\n          let coords = getOutputCoords();\n          let b = coords[0];\n          let d = coords[3];\n          let r = coords[1];\n          let c = coords[2];\n\n          var accumulator = 0.0;\n\n          // Compute bounds for where in dy we will look\n          let startRLerp = floor(f32(r) * uniforms.invHeightScale);\n          let startDyR = i32(floor(startRLerp - f32(uniforms.winHeight / 2)));\n\n          let startCLerp = floor(f32(c) * uniforms.invWidthScale);\n          let startDyC = i32(floor(startCLerp - f32(uniforms.winWidth / 2)));\n\n          // Loop over dy\n          for (var dyROffset = 0; dyROffset < uniforms.winHeight; dyROffset++) {\n            let dyR = startDyR + dyROffset;\n\n            // Guard against the window exceeding the bounds of dy\n            if (dyR < 0 || dyR >= uniforms.dyShape[1]) {\n              continue;\n            }\n\n            for (var dyCOffset = 0; dyCOffset < uniforms.winWidth; dyCOffset++) {\n              let dyC = startDyC + dyCOffset;\n\n              // Guard against the window exceeding the bounds of dy\n              if (dyC < 0 || dyC >= uniforms.dyShape[2]) {\n                continue;\n              }\n\n              let sourceFracRow = f32(uniforms.effectiveXSize[0]) *\n                  (f32(dyR) / f32(uniforms.effectiveYSize[0]));\n\n              let sourceFracCol = f32(uniforms.effectiveXSize[1]) *\n                  (f32(dyC) / f32(uniforms.effectiveYSize[1]));\n\n              let sourceNearestRow =\n                  i32(min(f32(uniforms.outShape[1] - 1),\n                  ${this.alignCorners?"floor(sourceFracRow + 0.5)":"floor(sourceFracRow)"}));\n\n              let sourceNearestCol =\n                  i32(min(f32(uniforms.outShape[2] - 1),\n                  ${this.alignCorners?"floor(sourceFracCol + 0.5)":"floor(sourceFracCol)"}));\n\n              if (r == sourceNearestRow && c == sourceNearestCol) {\n                accumulator += getDy(b, dyR, dyC, d);\n              }\n            }\n          }\n          // End loop over dy\n\n          setOutputAtIndex(index, accumulator);\n        }\n      }\n    `}}const wa={kernelName:t.ResizeNearestNeighborGrad,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:n,attrs:i}=e,{images:r,dy:s}=t,{alignCorners:a}=i,[,o,u]=r.shape,[,l,d]=s.shape,h=[a&&l>1?o-1:o,a&&d>1?u-1:u],p=[a&&l>1?l-1:l,a&&d>1?d-1:d],c=1/(h[0]/p[0]),f=1/(h[1]/p[1]),m=2*Math.ceil(c)+2,g=2*Math.ceil(f)+2,x=new ya(r.shape,a),b=[{type:"int32",data:h},{type:"int32",data:p},{type:"float32",data:[c]},{type:"float32",data:[f]},{type:"int32",data:[m]},{type:"int32",data:[g]}];return n.runWebGPUProgram(x,[s],s.dtype,b)}};class Ca{constructor(e){this.variableNames=["x"],this.workgroupSize=[64,1,1],this.size=!0,this.outputShape=e,this.dispatchLayout=N(this.outputShape),this.dispatch=$(this.dispatchLayout,this.outputShape,this.workgroupSize),this.uniforms=" axis : vec4<i32>,",this.shaderKey="reverse"}getUserCode(){return`\n      \n      // Using uniform variables as judging conditions, so the function has\n      // coherent execution within all threads.\n      fn getReverseCoords(coords : vec4<i32>) -> vec4<i32> {\n        var reverseCoords = coords;\n        if (uniforms.axis[0] == 1) {\n          reverseCoords[0] = uniforms.xShape[0] - coords[0] - 1;\n        }\n        if (uniforms.axis[1] == 1) {\n          reverseCoords[1] = uniforms.xShape[1] - coords[1] - 1;\n        }\n        if (uniforms.axis[2] == 1) {\n          reverseCoords[2] = uniforms.xShape[2] - coords[2] - 1;\n        }\n        if (uniforms.axis[3] == 1) {\n          reverseCoords[3] = uniforms.xShape[3] - coords[3] - 1;\n        }\n\n        return reverseCoords;\n      }\n    \n      ${x("index")} {\n        if (index < uniforms.size) {\n          let coords = getCoordsFromIndex(index);\n          let reverseCoords = getReverseCoords(coords);\n          setOutputAtIndex(index, getX(reverseCoords[0],\n              reverseCoords[1], reverseCoords[2], reverseCoords[3]));\n        }\n      }\n    `}}const ka={kernelName:t.Reverse,backendName:"webgpu",kernelFunc:function(e){const{inputs:n,backend:i,attrs:r}=e,{x:s}=n,{dims:a}=r,o=s.shape.length;if(0===o)return pe({inputs:{x:s},backend:i});const u=s.shape,l=[1,1,1,1];u.forEach(((e,t)=>{l[t+4-o]=e}));const d=t.util.parseAxisParam(a,s.shape),h=[0,0,0,0];d.forEach((e=>{h[e+4-o]=1}));const p=[{type:"int32",data:h}],c=ae({inputs:{x:s},backend:i,attrs:{shape:l}}),f=new Ca(l),m=i.runWebGPUProgram(f,[c],c.dtype,p);i.disposeData(c.dataId);const g=ae({inputs:{x:m},backend:i,attrs:{shape:u}});return i.disposeData(m.dataId),g}};class Sa{constructor(e,t){this.outputShape=[],this.variableNames=["x"],this.workgroupSize=[64,1,1],this.size=!0,this.outputShape=e,this.dispatchLayout=N(this.outputShape),this.dispatch=$(this.dispatchLayout,this.outputShape,this.workgroupSize),this.uniforms="centerX : f32, centerY : f32, sinRadians : f32,\n          cosRadians : f32,",this.shaderKey="rotate",this.outputShape=e,"number"==typeof t?(this.uniforms+=" fillValue : f32,",this.fillSnippet="var outputValue = uniforms.fillValue;",this.shaderKey+="_float"):(this.uniforms+=" fillValue : vec3<f32>,",this.fillSnippet="var outputValue = uniforms.fillValue[coords[3]];",this.shaderKey+="_vec3")}getUserCode(){return`\n        ${x("index")} {\n          if (index < uniforms.size) {\n            let coords = getCoordsFromIndex(index);\n            let coordXFloat = (f32(coords[2]) - uniforms.centerX) *\n                uniforms.cosRadians - (f32(coords[1]) - uniforms.centerY) *\n                uniforms.sinRadians;\n            let coordYFloat = (f32(coords[2]) - uniforms.centerX) *\n                uniforms.sinRadians + (f32(coords[1]) - uniforms.centerY) *\n                uniforms.cosRadians;\n            let coordX = i32(round(coordXFloat + uniforms.centerX));\n            let coordY = i32(round(coordYFloat + uniforms.centerY));\n            ${this.fillSnippet}\n            if(coordX >= 0 && coordX < uniforms.xShape[2] && coordY >= 0 &&\n                coordY < uniforms.xShape[1]) {\n              outputValue = getX(coords[0], coordY, coordX, coords[3]);\n            }\n            setOutputAtIndex(index, outputValue);\n          }\n        }\n      `}}const va={kernelName:t.RotateWithOffset,backendName:"webgpu",kernelFunc:({inputs:e,attrs:n,backend:i})=>{const{image:r}=e,{radians:s,fillValue:a,center:o}=n,u=i,l=new Sa(r.shape,a),[d,h]=t.backend_util.getImageCenter(o,r.shape[1],r.shape[2]),p=[{type:"float32",data:[d]},{type:"float32",data:[h]},{type:"float32",data:[Math.sin(s)]},{type:"float32",data:[Math.cos(s)]}];"number"==typeof a?p.push({type:"float32",data:[Number.parseFloat(a.toFixed(2))]}):p.push({type:"float32",data:a});return u.runWebGPUProgram(l,[r],r.dtype,p)}},Ia=xe({opType:U.ROUND}),Ra={kernelName:t.Round,backendName:"webgpu",kernelFunc:Ia},$a=xe({opType:U.RSQRT,cpuKernelImpl:$t}),Pa={kernelName:t.Rsqrt,backendName:"webgpu",kernelFunc:$a};class Aa{constructor(e,t,n,i,r,s,a,o=!0){this.variableNames=["updates","indices"],this.workgroupSize=[64,1,1],this.atomic=!0,this.outputShape=s,this.type=a,this.sumDupeIndices=o,this.dispatchLayout=N(e),this.dispatch=$(this.dispatchLayout,e,this.workgroupSize),this.sliceDimGreaterThanOne=t>1,this.shaderKey=`scatter_${n}_${i}_${this.sliceDimGreaterThanOne}_${a}_${o}`;const u=m(r.length);this.uniforms=`sliceDim : i32, strides: ${u}, updatesSize: i32,`,this.updatesRank=i,this.indicesRank=n}getUserCode(){let e="";1===this.indicesRank?e="coords[0]":2===this.indicesRank&&(e="coords[0], j");const t=`getIndices(${e})`,n=this.sliceDimGreaterThanOne?"uniforms.strides[j]":"uniforms.strides";let i="",r="";1===this.dispatchLayout.x.length?(i="flattenedIndex",r="\n      fn getUpdatesCoordsFromFlatIndex(index : i32) -> i32 {\n        return index;\n      }\n      "):2===this.dispatchLayout.x.length&&(i="vec2<i32>(flattenedIndex, coords[1])",r="\n      fn getUpdatesCoordsFromFlatIndex(index : i32) -> vec2<i32> {\n        // N.B. |updates| could be a scalar tensor, conceptually representing a\n        // 2D tensor with all values equal to that. By design, its size must be\n        // the same as |outShape[1]| in one dimension, and |indicesShape[0]|\n        // gives the other.\n        let sliceSize = uniforms.outShape[1];\n        let d0 = index / sliceSize;\n        let d1 = index - d0 * sliceSize;\n        return vec2<i32>(d0, d1);\n      }\n      ");const s=`getUpdates(${Array.from({length:this.updatesRank},((e,t)=>`coords[${t}]`)).join(", ")})`;return`\n    ${r}\n      ${x("index")} {\n        if (index < uniforms.updatesSize) {\n          let coords = getUpdatesCoordsFromFlatIndex(index);\n          var flattenedIndex = 0;\n          for (var j = 0; j < uniforms.sliceDim; j = j + 1) {\n            let indexInside = i32(round(${t}));\n            flattenedIndex = flattenedIndex + indexInside * ${n};\n          }\n          let updateValue =\n              ${v(this.type)}(${s});\n          let flatIndex = getOutputIndexFromCoords(${i});\n\n          ${this.sumDupeIndices?p("&result[flatIndex]","updateValue",this.type):"atomicStore(&result[flatIndex], bitcast<i32>(updateValue));"}\n        }\n      }`}}const za={kernelName:t.ScatterNd,backendName:"webgpu",kernelFunc:function(e){const{inputs:n,backend:i,attrs:r}=e,{indices:s,updates:a}=n,{shape:o}=r,{sliceRank:u,numUpdates:l,sliceSize:d,strides:h,outputSize:p}=t.backend_util.calculateShapes(a,s,o),c=[p/d,d];if(0===p)return i.makeTensorInfo(o,s.dtype);const f=ae({inputs:{x:s},backend:i,attrs:{shape:[l,u]}}),m=ae({inputs:{x:a},backend:i,attrs:{shape:[l,d]}}),g=m.dtype,x=re({backend:i,attrs:{shape:c,value:0,dtype:g}}),b=[{type:"int32",data:[u]},{type:"int32",data:h},{type:"int32",data:[t.util.sizeFromShape(m.shape)]}],y=new Aa(m.shape,u,f.shape.length,m.shape.length,h,c,g),w=i.runWebGPUProgram(y,[m,f],g,b,x),C=ae({inputs:{x:w},backend:i,attrs:{shape:o}});return i.disposeData(f.dataId),i.disposeData(m.dataId),i.disposeData(w.dataId),C}};class Na{constructor(e,t){this.outputShape=[],this.variableNames=["sortedSequence","values"],this.uniforms="numInputs : i32,",this.workgroupSize=[64,1,1],this.size=!0,this.outputShape=e,this.dispatchLayout=N(this.outputShape),this.dispatch=$(this.dispatchLayout,this.outputShape,this.workgroupSize),this.side=t,this.shaderKey=`search_sorted_${t}`}getUserCode(){return`\n      fn findBound(batch: i32, value: f32) -> i32 {\n        var left = i32(0);\n        var right = uniforms.numInputs;\n        while (left < right) {\n          var mid = (left + right) / 2;\n          if (getSortedSequence(batch, mid) ${"left"===this.side?"<":"<="} value) {\n            left = mid + 1;\n          } else {\n            right = mid;\n          }\n        }\n        return right;\n      }\n\n      ${x("index")} {\n        if (index < uniforms.size) {\n          let coords = getCoordsFromIndex(index);\n          let value = getValuesByOutputIndex(index);\n          setOutputAtIndexI32(index, findBound(coords[0], value));\n        }\n      }\n    `}}const Da={kernelName:t.SearchSorted,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:n,attrs:i}=e,{sortedSequence:r,values:s}=t,{side:a}=i,o=new Na([s.shape[0],s.shape[1]],a),u=[{type:"int32",data:[r.shape[1]]}];return n.runWebGPUProgram(o,[r,s],"int32",u)}};class Ta{constructor(e,t,n){this.variableNames=["c","a","b"],this.workgroupSize=[64,1,1],this.size=!0,this.outputShape=t,this.dispatchLayout=N(this.outputShape),this.dispatch=$(this.dispatchLayout,this.outputShape,this.workgroupSize),this.cRank=e,this.rank=n,this.shaderKey="select"}getUserCode(){let e,t;if(this.rank>4)throw Error(`Where for rank ${this.rank} is not yet supported`);if(1===this.rank)t="resRC",e="resRC";else{const n=["resRC.x","resRC.y","resRC.z","resRC.w"],i=[],r=[];for(let e=0;e<this.outputShape.length;e++)r.push(`${n[e]}`),e<this.cRank&&i.push(`${n[e]}`);e=i.join(),t=r.join()}return`\n      ${x("index")} {\n        if (index < uniforms.size) {\n          let resRC = getCoordsFromIndex(index);\n          let cVal = getC(${e});\n          if (cVal >= 1.0) {\n            setOutputAtIndex(index, getA(${t}));\n          } else {\n            setOutputAtIndex(index, getB(${t}));\n          }\n        }\n      }\n    `}}const Fa={kernelName:t.Select,backendName:"webgpu",kernelFunc:function(e){const{inputs:n,backend:i}=e,{condition:r,t:s,e:a}=n,o=new Ta(r.shape.length,s.shape,s.shape.length);return i.runWebGPUProgram(o,[r,s,a],t.upcastType(s.dtype,a.dtype))}},_a=xe({opType:U.SELU}),Ea={kernelName:t.Selu,backendName:"webgpu",kernelFunc:_a},Wa=xe({opType:U.SIGMOID}),La={kernelName:t.Sigmoid,backendName:"webgpu",kernelFunc:Wa},Ba=xe({opType:U.SIGN}),Oa={kernelName:t.Sign,backendName:"webgpu",kernelFunc:Ba},Ua=xe({opType:U.SIN}),Ma={kernelName:t.Sin,backendName:"webgpu",kernelFunc:Ua},Va=xe({opType:U.SINH}),Ga={kernelName:t.Sinh,backendName:"webgpu",kernelFunc:Va},Ha=xe({opType:U.SOFTPLUS}),Xa={kernelName:t.Softplus,backendName:"webgpu",kernelFunc:Ha},Ka={kernelName:t.SpaceToBatchND,backendName:"webgpu",kernelFunc:e=>{const{inputs:n,backend:i,attrs:r}=e,{x:s}=n,{blockShape:a,paddings:o}=r;t.util.assert(s.shape.length<=4,(()=>"spaceToBatchND for rank > 4 with a WebGPU backend not implemented yet"));const u=a.reduce(((e,t)=>e*t)),l=[[0,0]];l.push(...o);for(let e=1+a.length;e<s.shape.length;++e)l.push([0,0]);const d=[],h=Zs({inputs:{x:s},backend:i,attrs:{paddings:l,constantValue:0}}),p=t.backend_util.getReshaped(h.shape,a,u,!1),c=t.backend_util.getPermuted(p.length,a.length,!1),f=t.backend_util.getReshapedPermuted(h.shape,a,u,!1),m=ae({inputs:{x:h},backend:i,attrs:{shape:p}}),g=jt({inputs:{x:m},backend:i,attrs:{perm:c}}),x=ae({inputs:{x:g},backend:i,attrs:{shape:f}});return d.push(h),d.push(m),d.push(g),d.forEach((e=>i.disposeData(e.dataId))),x}};class qa{constructor(e,t){this.variableNames=["A"],this.workgroupSize=[64,1,1],this.size=!0;const n=new Array(e.length);for(let i=0;i<n.length;i++)n[i]=e[i]*t[i];this.outputShape=n,this.dispatchLayout=N(this.outputShape),this.dispatch=$(this.dispatchLayout,this.outputShape,this.workgroupSize),this.rank=this.outputShape.length,this.shaderKey="tile"}getUserCode(){const e=function(e,t=""){if(e>=5)throw Error(`Tile for rank ${e} is not yet supported`);if(1===e)return`(resRC % ${t}aShape)`;const n=["resRC.x","resRC.y","resRC.z","resRC.w"],i=[];for(let r=0;r<e;r++)i.push(`(${n[r]} % ${t}aShape[${r}])`);return i.join()}(this.rank,"uniforms.");return`\n      ${x("index")} {\n        if (index < uniforms.size) {\n          let resRC = getCoordsFromIndex(index);\n          setOutputAtIndex(index, getA(${e}));\n        }\n      }\n    `}}function Ya(e){const{inputs:n,backend:i,attrs:r}=e,{x:s}=n,{reps:a}=r;if(i.shouldExecuteOnCPU([s])||"string"===s.dtype||s.shape.length>=5){const e=i.readSync(s.dataId),n="string"===s.dtype?e.map((e=>t.util.decodeString(e))):e,r=t.buffer(s.shape,s.dtype,n),o=Ft(r,a);return i.makeTensorInfo(o.shape,o.dtype,o.values)}const o=new qa(s.shape,a);return i.runWebGPUProgram(o,[s],s.dtype)}const ja={kernelName:t.Tile,backendName:"webgpu",kernelFunc:Ya};const Qa={kernelName:t.SparseToDense,backendName:"webgpu",kernelFunc:function(e){const{inputs:n,backend:i,attrs:r}=e,{sparseIndices:s,sparseValues:a,defaultValue:o}=n,{outputShape:u}=r,{sliceRank:l,numUpdates:d,sliceSize:h,strides:p,outputSize:c}=t.backend_util.calculateShapes(a,s,u),f=!1;if("string"===a.dtype){const e=i.bufferSync(s),n=i.bufferSync(a),r=t.util.decodeString(i.readSync(o.dataId)[0]),m=Pt(e,n,u,c,h,d,l,p,r,f);return i.makeTensorInfo(u,m.dtype,m.values)}const m=[c/h,h],g=ae({inputs:{x:s},backend:i,attrs:{shape:[d,l]}}),x=a.shape.length?ae({inputs:{x:a},backend:i,attrs:{shape:[d,h]}}):pe({inputs:{x:a},backend:i}),b=x.dtype,y=i.makeTensorInfo([],b,t.util.makeZerosTypedArray(1,b)),w=ae({inputs:{x:o},backend:i,attrs:{shape:Array(m.length).fill(1)}}),C=Ya({inputs:{x:w},backend:i,attrs:{reps:m}}),k=[{type:"int32",data:[l]},{type:"int32",data:p},{type:"int32",data:[t.util.sizeFromShape([d,h])]}];switch(d){case 0:break;case 1:{const e=new Aa([d,h],l,g.shape.length,x.shape.length,p,m,b,f);i.runWebGPUProgram(e,[x,g],b,k,C)}break;default:{const e=new Aa([d,h],l,g.shape.length,y.shape.length,p,m,b,f);i.runWebGPUProgram(e,[y,g],b,k,C)}{const e=new Aa([d,h],l,g.shape.length,x.shape.length,p,m,b);i.runWebGPUProgram(e,[x,g],b,k,C)}}const S=ae({inputs:{x:C},backend:i,attrs:{shape:u}});return i.disposeData(g.dataId),i.disposeData(x.dataId),i.disposeData(w.dataId),i.disposeData(y.dataId),i.disposeData(C.dataId),S}};const Za={kernelName:t.SplitV,backendName:"webgpu",kernelFunc:function(e){const{inputs:n,backend:i,attrs:r}=e,{x:s}=n,{numOrSizeSplits:a,axis:o}=r,u=t.util.parseAxisParam(o,s.shape)[0],l=t.backend_util.prepareSplitSize(s,a,u),d=s.shape.length,h=new Array(d).fill(0),p=s.shape.slice();return l.map((e=>{const t=[...p];t[u]=e;const n=Tn({inputs:{x:s},backend:i,attrs:{begin:h,size:t}});return h[u]+=e,n}))}},Ja=xe({opType:U.SQRT}),eo={kernelName:t.Sqrt,backendName:"webgpu",kernelFunc:Ja},to={kernelName:t.Square,backendName:"webgpu",kernelFunc:({inputs:e,backend:t})=>{const{x:n}=e,i=t,r=new ge(n.shape,U.SQUARE);return i.runWebGPUProgram(r,[n],n.dtype)}},no=be({opType:B.SQUARED_DIFFERENCE}),io={kernelName:t.SquaredDifference,backendName:"webgpu",kernelFunc:no};const ro={kernelName:t.Step,backendName:"webgpu",kernelFunc:function({inputs:e,attrs:t,backend:n}){const{x:i}=e,r=new ge(i.shape,U.STEP,"stepAlpha : f32,"),s=[{type:"float32",data:[t.alpha]}];return n.runWebGPUProgram(r,[i],i.dtype,s)}};class so{constructor(e){this.variableNames=["x"],this.workPerThread=1,this.workgroupSize=[64,1,1],this.size=!0,this.outputShape=e,this.dispatchLayout=N(this.outputShape),this.dispatch=$(this.dispatchLayout,this.outputShape,this.workgroupSize,[this.workPerThread,1,1]);const t=m(this.outputShape.length);this.uniforms=`begin : ${t},  strides : ${t}, `,this.shaderKey="stridedSlice"}getUserCode(){let e="";if(1===this.outputShape.length)e="coords * uniforms.strides + uniforms.begin";else{let t=0;e=this.outputShape.map(((e,n)=>(t++,1===this.outputShape.length?`coords * uniforms.strides[${n}] + uniforms.begin[${n}]`:`coords[${t-1}] * uniforms.strides[${n}] + uniforms.begin[${n}]`))).join(",")}return`\n       ${x("index")} {\n         if (index < uniforms.size) {\n           let coords = getCoordsFromIndex(index);\n           setOutputAtIndex(index, getX(${e}));\n         }\n       }\n     `}}const ao={kernelName:t.StridedSlice,backendName:"webgpu",kernelFunc:function(e){const{inputs:n,backend:i,attrs:r}=e,{x:s}=n,{begin:a,end:o,strides:u,beginMask:l,endMask:d,ellipsisMask:h,newAxisMask:p,shrinkAxisMask:c}=r,{finalShapeSparse:f,finalShape:m,isIdentity:g,sliceDim0:x,isSimpleSlice:b,begin:y,end:w,strides:C}=t.slice_util.sliceInfo(s.shape,a,o,u,l,d,h,p,c);let k;if(g)k=ae({inputs:{x:s},backend:i,attrs:{shape:m}});else if(x||b){t.util.assert(s.shape.length>=1,(()=>`Input must have rank at least 1, got: ${s.shape.length}`));const e=t.slice_util.computeOutShape(y,w,C),n=Tn({inputs:{x:s},backend:i,attrs:{begin:y,size:e}});k=ae({inputs:{x:n},backend:i,attrs:{shape:m}}),i.disposeData(n.dataId)}else{if(i.shouldExecuteOnCPU([s])){const e=i.readSync(s.dataId),n=t.buffer(s.shape,s.dtype,e),r=Nt(f,n,C,y);k=i.makeTensorInfo(m,s.dtype,r.values)}else{const e=new so(f),t=[{type:"int32",data:y},{type:"int32",data:C}],n=i.runWebGPUProgram(e,[s],s.dtype,t);k=ae({inputs:{x:n},backend:i,attrs:{shape:m}}),i.disposeData(n.dataId)}}return k}};const oo={kernelName:t.StringNGrams,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:n,attrs:i}=e,{separator:r,nGramWidths:s,leftPad:a,rightPad:o,padWidth:u,preserveShortSequences:l}=i,{data:d,dataSplits:h}=t,p=n.readSync(d.dataId),c=n.readSync(h.dataId),[f,m]=Dt(p,c,r,s,a,o,u,l);return[n.makeTensorInfo([f.length],"string",f),n.makeTensorInfo(h.shape,"int32",m)]}},uo=be({opType:B.SUB,cpuKernelImpl:Tt,supportsComplex:!0}),lo={kernelName:t.Sub,backendName:"webgpu",kernelFunc:uo},ho=xe({opType:U.TAN}),po={kernelName:t.Tan,backendName:"webgpu",kernelFunc:ho},co=xe({opType:U.TANH}),fo={kernelName:t.Tanh,backendName:"webgpu",kernelFunc:co};const mo={kernelName:t.TensorScatterUpdate,backendName:"webgpu",kernelFunc:function(e){const{inputs:n,backend:i,attrs:r}=e,{tensor:s,indices:a,updates:o}=n,{sliceRank:u,numUpdates:l,sliceSize:d,strides:h,outputSize:p}=t.backend_util.calculateShapes(o,a,s.shape),c=[p/d,d];if(0===p)return i.makeTensorInfo(s.shape,a.dtype);const f=[],m=ae({inputs:{x:a},backend:i,attrs:{shape:[l,u]}});f.push(m);const g=ae({inputs:{x:o},backend:i,attrs:{shape:[l,d]}});f.push(g);const x=ae({inputs:{x:s},backend:i,attrs:{shape:c}});f.push(x);const b=Ya({inputs:{x:x},backend:i,attrs:{reps:Array(c.length).fill(1)}}),y=new Aa([l,d],u,m.shape.length,g.shape.length,h,c,s.dtype,!1),w=[{type:"int32",data:[u]},{type:"int32",data:h},{type:"int32",data:[t.util.sizeFromShape([l,d])]}],C=i.runWebGPUProgram(y,[g,m],x.dtype,w,b);f.push(C);const k=ae({inputs:{x:C},backend:i,attrs:{shape:s.shape}});return f.forEach((e=>i.disposeData(e.dataId))),k}};class go{constructor(e){this.variableNames=["x","indices"],this.workgroupSize=[256,1,1],this.size=!0,this.outputShape=e,this.dispatchLayout=N(this.outputShape),this.dispatch=$(this.dispatchLayout,this.outputShape,this.workgroupSize),this.uniforms="inputSize : i32, firstPass : i32, negativeInf : f32,\n        dir : i32, inc : i32,",this.shaderKey="swap"}getUserCode(){return`\n        ${x("index")} {\n          if (index < uniforms.size) {\n            let outC = getCoordsFromIndex(index);\n            let batch = outC[0];\n            let elemIdx = outC[1];\n            // We compare elements pair-wise within a group of size 2 * inc.\n            // The comparing rule for each group alternates between ascending\n            // and descending. Within each group, we compare each pair at\n            // positions i and i+inc. To decide whether an element at position i\n            // is x0 or x1, we mod it by 2 * inc, if the result is smaller than\n            // inc, it is in the first half of the group, we denote it as x0,\n            // otherwise we denote it as x1.\n            // For example, as shown in the Bitonic top K paper referenced\n            // above, Figure5(a) shows that element[1] is in the second half of\n            // the group when group size is 2, but it is in the first half of\n            // the group when group size is 4.\n            let isFirstInPair = elemIdx % (2 * uniforms.inc) < uniforms.inc;\n            var i = 0;\n            if (isFirstInPair) {\n              i = elemIdx;\n            } else {\n              i = elemIdx - uniforms.inc;\n            }\n\n            var i0 = 0;\n            if (uniforms.firstPass == 1) {\n              i0 = i;\n            } else {\n              i0 = i32(getIndices(batch, i));\n            }\n\n            var i1 = 0;\n            if (uniforms.firstPass == 1) {\n              i1 = i + uniforms.inc;\n            } else {\n              i1 = i32(getIndices(batch, i + uniforms.inc));\n            }\n\n            var x0 = f32(0.0);\n            var x1 = f32(0.0);\n            if (i0 < uniforms.inputSize) {\n              x0 = getX(batch, i0);\n            } else {\n              x0 = uniforms.negativeInf;\n            }\n            if (i1 < uniforms.inputSize) {\n              x1 = getX(batch, i1);\n            } else {\n              x1 = uniforms.negativeInf;\n            }\n\n            let reverse = elemIdx % (2 * uniforms.dir) >= uniforms.dir;\n            let isGreater = x0 > x1 || (x0 == x1 && i1 > i0);\n            if (reverse == isGreater) {\n              // Elements in opposite order of direction\n              let iTemp = i0;\n              i0 = i1;\n              i1 = iTemp;\n            }\n            if (isFirstInPair) {\n              setOutputAtIndex(index, f32(i0));\n            } else {\n              setOutputAtIndex(index, f32(i1));\n            }\n          }\n        }\n      `}}class xo{constructor(e){this.variableNames=["x","indices"],this.workgroupSize=[256,1,1],this.size=!0,this.outputShape=e,this.dispatchLayout=N(this.outputShape),this.dispatch=$(this.dispatchLayout,this.outputShape,this.workgroupSize),this.uniforms="inputSize : i32, firstPass : i32, k : i32,",this.shaderKey="merge"}getUserCode(){return`\n        ${x("index")} {\n          if (index < uniforms.size) {\n            let outC = getCoordsFromIndex(index);\n            let batch = outC[0];\n            let elemIdx = outC[1];\n            // The output size is half of the previous size.\n            // If the previous sequence is | | | | _ _ _ _  | | | |  _ _ _ _\n            // (k=4), we only need to output the indices at positions |, the\n            // indices at positions _ can be thrown away, see Figure5(b) After\n            // Phase 2 (Merge phase) in the Bitonic Top K paper referenced\n            // above.\n            // For example, the paper shows we only need to output the orange\n            // bars. The output sequence should look like this | | | | | | | |.\n            // Because the sequence is halved, to map the output index back to\n            // the previous sequence to find the corresponding value, we need\n            // to double the index. When we double the index, we basically\n            // interpolate a position, so 2i looks like\n            // | _ | _ | _ | _ | _ | _ | _. We move the | to the first k\n            // position of each 2k positions by - elemIdx % k. E.g. for output\n            // at index 4,5,6,7, we want to get the corresponding element at\n            // original index 8,9,10,11, for output at index 8,9,10,11,\n            // we want to get the corresponding element at original index\n            // 16,17,18,19, so on and so forth.\n\n            var i = 0;\n            if (elemIdx < uniforms.k) {\n              i = elemIdx;\n            } else {\n              i = elemIdx * 2 - elemIdx % uniforms.k;\n            }\n            var i0 = 0;\n            if (uniforms.firstPass == 1) {\n              i0 = i;\n            } else {\n              i0 = i32(getIndices(batch, i));\n            }\n            var i1 = 0;\n            if (uniforms.firstPass == 1) {\n              i1 = i + uniforms.k;\n            } else {\n              i1 = i32(getIndices(batch, i + uniforms.k));\n            }\n\n            let x0 = getX(batch, i0);\n            var x1 = f32(0.0);\n            if (i1 < uniforms.inputSize) {\n              x1 = getX(batch, i1);\n            } else {\n              x1 = x0;\n            }\n\n            if (x0 >= x1) {\n              setOutputAtIndex(index, f32(i0));\n            } else {\n              setOutputAtIndex(index, f32(i1));\n            }\n          }\n        }\n      `}}function bo(e,t){null!==t&&e.disposeData(t.dataId)}function yo(e){let t=1;for(;t<e;)t*=2;return t}const wo={kernelName:t.TopK,backendName:"webgpu",kernelFunc:function(e){const{inputs:n,backend:i,attrs:r}=e,{x:s}=n,{k:a,sorted:o}=r,u=s.shape,l=u[u.length-1];if(i.shouldExecuteOnCPU([s])){const e=i.readSync(s.dataId),[t,n]=_t(e,u,s.dtype,a,o);return[i.makeTensorInfo(t.shape,t.dtype,t.values),i.makeTensorInfo(n.shape,n.dtype,n.values)]}if(0===a)return u[u.length-1]=0,[i.makeTensorInfo(u,s.dtype,[]),i.makeTensorInfo(u,"int32",[])];if(1===l)return[s,re({attrs:{shape:u,dtype:"int32",value:0},backend:i})];const d=t.util.sizeFromShape(u)/l,h=ae({inputs:{x:s},attrs:{shape:[d,l]},backend:i}),p=yo(a),c=yo(l);let f=null;const m=()=>null===f?[h,h]:[h,f],g=(e,t,n)=>{const r=m(),s=new go(n),a=[{type:"int32",data:[l]},{type:"int32",data:[null===f?1:0]},{type:"float32",data:[Number.NEGATIVE_INFINITY]},{type:"int32",data:[e]},{type:"int32",data:[t]}],o=f;f=i.runWebGPUProgram(s,r,"int32",a),bo(i,o)};for(let e=1;e<p;e*=2){const t=2*e;for(let n=e;n>=1;n/=2)g(t,n,[d,c])}for(let e=c;e>p;e/=2){const t=m(),n=new xo([d,e/2]),r=[{type:"int32",data:[l]},{type:"int32",data:[null===f?1:0]},{type:"int32",data:[p]}],s=f;f=i.runWebGPUProgram(n,t,"int32",r),bo(i,s);const a=p/2,o=2*a;for(let e=a;e>=1;e/=2)g(o,e,f.shape)}let x=f;f=Tn({inputs:{x:f},backend:i,attrs:{begin:0,size:[d,a]}}),bo(i,x);let b=Br({inputs:{x:h,indices:f},backend:i,attrs:{axis:1,batchDims:1}});bo(i,h);const y=u.slice(0,-1);y.push(a),x=f,f=ae({inputs:{x:f},attrs:{shape:y},backend:i}),bo(i,x);const w=b;return b=ae({inputs:{x:b},attrs:{shape:y},backend:i}),bo(i,w),[b,f]}};class Co{constructor(e){this.variableNames=["Image","Transforms"],this.uniforms="interpolationModeId : i32, fillModeId : i32, fillValue : f32,",this.workgroupSize=[64,1,1],this.size=!0,this.outputShape=e,this.dispatchLayout=N(this.outputShape),this.dispatch=$(this.dispatchLayout,this.outputShape,this.workgroupSize),this.shaderKey="transform"}getUserCode(){return`\n          fn mapCoord(outCoord : f32, len : f32) -> f32{\n            var inCoord = outCoord;\n            if(uniforms.fillModeId == 2) {\n              if (inCoord < 0.0) {\n                if (len <= 1.0) {\n                  inCoord = 0.0;\n                } else {\n                  let sz2 = 2.0 * len;\n                  if (inCoord < sz2) {\n                    inCoord = sz2 * f32(i32(f32(-inCoord / sz2))) +\n                    inCoord;\n                  }\n                  if (inCoord < -len) {\n                    inCoord = inCoord + sz2;\n                  } else {\n                    inCoord = -inCoord - 1.0;\n                  }\n                }\n              } else if (inCoord > len - 1.0) {\n                if (len <= 1.0) {\n                  inCoord = 0.0;\n                } else {\n                  let sz2 = 2.0 * len;\n                  inCoord = inCoord - sz2 * f32(i32(f32(inCoord / sz2)));\n                  if (inCoord >= len) {\n                    inCoord = sz2 - inCoord - 1.0;\n                  }\n                }\n              }\n              return clamp(inCoord, 0.0, len - 1.0);\n            } else if (uniforms.fillModeId == 3) {\n              if (inCoord < 0.0) {\n                if (len <= 1.0) {\n                  inCoord = 0.0;\n                } else {\n                  let sz = len - 1.0;\n                  inCoord = inCoord + len * (f32(i32(f32(-inCoord / sz))) + 1.0);\n                }\n              } else if (inCoord > len - 1.0) {\n                if (len <= 1.0) {\n                  inCoord = 0.0;\n                } else {\n                  let sz = len - 1.0;\n                  inCoord = inCoord - len * f32(i32(f32(inCoord / sz)));\n                }\n              }\n              return clamp(inCoord, 0.0, len - 1.0);\n            } else if (uniforms.fillModeId == 4) {\n              return clamp(outCoord, 0.0, len - 1.0);\n            }\n            return outCoord;\n          }\n          fn readWithFillValue(batch : i32, coordY : i32, coordX : i32,\n            channel : i32) -> f32 {\n            var outputValue : f32;\n            if (0 <= coordY && coordY < uniforms.imageShape[1] && 0 <= coordX && coordX < uniforms.imageShape[2]) {\n                outputValue = getImage(batch, coordY, coordX, channel);\n            } else {\n              outputValue = uniforms.fillValue;\n            }\n            return outputValue;\n          }\n\n          ${x("index")} {\n            if (index < uniforms.size) {\n              let coords = getCoordsFromIndex(index);\n              var outputValue : f32;\n              let batch = coords[0];\n              let x = coords[2];\n              let y = coords[1];\n              let channel = coords[3];\n              let xf = f32(x);\n              let yf = f32(y);\n              let a1 = getTransforms(batch, 0);\n              let a2 = getTransforms(batch, 1);\n              let a3 = getTransforms(batch, 2);\n              let b1 = getTransforms(batch, 3);\n              let b2 = getTransforms(batch, 4);\n              let b3 = getTransforms(batch, 5);\n              let c1 = getTransforms(batch, 6);\n              let c2 = getTransforms(batch, 7);\n              let projection = c1 * xf + c2 * yf + 1.0;\n              if (projection == 0.0) {\n                outputValue = uniforms.fillValue;\n              } else {\n                let inX = (a1 * xf + a2 * yf + a3) / projection;\n                let inY = (b1 * xf + b2 * yf + b3) / projection;\n                let mapX = mapCoord(inX, f32(uniforms.imageShape[2]));\n                let mapY = mapCoord(inY, f32(uniforms.imageShape[1]));\n\n                if (uniforms.interpolationModeId == 1) {\n                  let coordY = i32(round(mapY));\n                  let coordX = i32(round(mapX));\n                  outputValue = readWithFillValue(batch, coordY, coordX,\n                    channel);\n                } else {\n                  let yFloor = floor(mapY);\n                  let xFloor = floor(mapX);\n                  let yCeil = yFloor + 1.0;\n                  let xCeil = xFloor + 1.0;\n                  let valueYFloor = (xCeil - mapX) *\n                  readWithFillValue(batch, i32(yFloor), i32(xFloor), channel) +\n                  (mapX - xFloor) *\n                  readWithFillValue(batch, i32(yFloor), i32(xCeil), channel);\n                  let valueYCeil = (xCeil - mapX) *\n                  readWithFillValue(batch, i32(yCeil), i32(xFloor), channel) +\n                  (mapX - xFloor) *\n                  readWithFillValue(batch, i32(yCeil), i32(xCeil), channel);\n                  outputValue = (yCeil - mapY) * valueYFloor +\n                  (mapY - yFloor) * valueYCeil;\n                }\n              }\n              setOutputAtIndex(index, outputValue);\n            }\n          }\n        `}}const ko={kernelName:t.Transform,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:n,attrs:i}=e,{image:r,transforms:s}=t,{interpolation:a,fillMode:o,fillValue:u,outputShape:l}=i,[d,h,p,c]=r.shape,[f,m]=null!=l?l:[h,p],g=new Co([d,f,m,c]),x="nearest"===a?1:2;let b;switch(o){case"constant":default:b=1;break;case"reflect":b=2;break;case"wrap":b=3;break;case"nearest":b=4}const y=[{type:"int32",data:[x]},{type:"int32",data:[b]},{type:"float32",data:[u]}];return n.runWebGPUProgram(g,[r,s],"float32",y)}};const So={kernelName:t.Unpack,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:n,attrs:i}=e,{value:r}=t;let{axis:s}=i;s<0&&(s+=r.shape.length);const a=r,o=a.shape.length,u=r.shape[s],l=new Array(o-1);let d=0;for(let e=0;e<o;e++)e!==s&&(l[d++]=a.shape[e]);const h=[],p=new Array(o).fill(0),c=a.shape.slice();c[s]=1;const f=new Array(u);for(let e=0;e<f.length;e++){p[s]=e;const t=Tn({inputs:{x:a},backend:n,attrs:{begin:p,size:c}}),i=ae({inputs:{x:t},backend:n,attrs:{shape:l}});f[e]=i,h.push(t)}return h.forEach((e=>n.disposeData(e.dataId))),f}};class vo{constructor(e,t,n){if(this.outputShape=[],this.variableNames=["x","segmentIds"],this.uniforms="numSegments : i32, xSize: i32,",this.workgroupSize=[64,1,1],this.atomic=!0,this.outputShape=t,this.dispatchLayout=N(e),this.dispatch=$(this.dispatchLayout,e,this.workgroupSize),"float32"!==n&&"int32"!==n)throw new Error(`UnsortedSegmentSum only supports float32 and int32\n              types, does not support ${n} type.`);this.type=n,this.shaderKey="unsortedSegmentSum"}getUserCode(){return`\n    ${x("index")} {\n      if (index < uniforms.xSize) {\n        let coords = getXCoordsFromIndex(index);\n        let b = coords[0];\n        let inCol = coords[1];\n\n        let segmentId = i32(getSegmentIds(inCol));\n        if (segmentId >= 0) {\n          let flatIndex = b * uniforms.numSegments + segmentId % uniforms.numSegments;\n          let value = getX(b, inCol);\n\n          ${p("&result[flatIndex]","value",this.type)}\n        }\n      }\n    }\n  `}}const Io=[le,Bt,Ut,Vt,Ht,Kt,en,tn,rn,sn,on,ln,hn,cn,mn,vn,In,Pn,An,zn,_n,Ln,On,Hn,Kn,jn,me,Jn,si,hi,gi,bi,wi,Ci,ki,vi,Ri,Pi,Fi,_i,Ei,Li,Hi,Xi,Mi,qi,ji,Ji,er,sr,or,ur,dr,pr,fr,gr,br,Cr,se,Sr,Ar,Ir,$r,Tr,Fr,_r,Wr,Or,Mr,Gr,ce,Hr,ni,Kr,Yr,Qr,Zr,es,ns,rs,us,as,ds,ps,fs,bs,ws,wn,ks,Ss,Ps,vs,$s,As,kn,zs,Ds,Fs,Es,Us,nr,Ms,Vs,Gs,Mn,Xs,Ys,js,Js,ta,na,ia,ra,Gn,aa,ua,da,pa,oe,fa,ga,ba,wa,ka,va,Ra,Pa,za,Da,Fa,Ea,La,Oa,Ma,Ga,Fn,ro,ao,oo,Os,Xa,Ka,Qa,Za,eo,to,io,lo,rr,po,fo,mo,ja,wo,ko,Qt,So,{kernelName:t.UnsortedSegmentSum,backendName:"webgpu",kernelFunc:function(e){const{inputs:n,backend:i,attrs:r}=e,{x:s,segmentIds:a}=n,{numSegments:o}=r,u=s.shape.length,l=[];let d=0;const h=t.backend_util.getAxesPermutation([d],u);let p=s;null!=h&&(p=jt({inputs:{x:s},backend:i,attrs:{perm:h}}),l.push(p),d=t.backend_util.getInnerMostAxes(1,u)[0]);const c=t.backend_util.segment_util.computeOutShape(p.shape,d,o),f=t.util.sizeFromShape([p.shape[d]]),m=ae({inputs:{x:p},backend:i,attrs:{shape:[-1,f]}});l.push(m);const g=s.dtype,x=[m.shape[0],o],b=re({backend:i,attrs:{shape:x,value:0,dtype:g}}),y=new vo(m.shape,x,g),w=[{type:"int32",data:[o]},{type:"int32",data:[t.util.sizeFromShape(m.shape)]}],C=i.runWebGPUProgram(y,[m,a],g,w,b),k=ae({inputs:{x:C},backend:i,attrs:{shape:c}});l.push(C);let S=k;if(null!=h){l.push(k);const e=t.backend_util.getUndoAxesPermutation(h);S=jt({inputs:{x:S},backend:i,attrs:{perm:e}})}return l.forEach((e=>i.disposeData(e.dataId))),S}},qs];for(const e of Io)t.registerKernel(e);e.WebGPUBackend=L,e.webgpu_util=E}));
//# sourceMappingURL=tf-backend-webgpu.es2017.min.js.map
